import { DefaultOptionsRule } from 'devextreme/core/options/utils';
import { InkRippleConfig } from "./common/ink_ripple";
import { BaseWidgetProps } from "./common/base_props";
export declare const viewFunction: (viewModel: Button) => any;
export declare type ButtonPropsType = typeof BaseWidgetProps & {
    activeStateEnabled: boolean;
    hoverStateEnabled: boolean;
    icon: string;
    iconPosition?: string;
    onClick?: (e: {
        event: Event;
    }) => void;
    onSubmit?: (e: {
        event: Event;
        submitInput: HTMLInputElement | null;
    }) => void;
    pressed?: boolean;
    stylingMode: "outlined" | "text" | "contained";
    template?: (props: {
        data: {
            icon?: string;
            text?: string;
        };
    }) => any;
    iconTemplate?: (props: any) => any;
    children?: React.ReactNode;
    text: string;
    type: "back" | "danger" | "default" | "normal" | "success";
    useInkRipple: boolean;
    useSubmitBehavior: boolean;
    templateData?: Record<string, unknown>;
    render?: (props: {
        data: {
            icon?: string;
            text?: string;
        };
    }) => any;
    component?: (props: {
        data: {
            icon?: string;
            text?: string;
        };
    }) => any;
    iconRender?: (props: any) => any;
    iconComponent?: (props: any) => any;
};
export declare const ButtonProps: ButtonPropsType;
export declare const defaultOptionRules: DefaultOptionsRule<ButtonPropsType>[];
import * as React from "react";
export declare type ButtonRef = {
    focus: () => void;
    activate: () => void;
    deactivate: () => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface Button {
    props: typeof ButtonProps & RestProps;
    contentRef: any;
    inkRippleRef: any;
    submitInputRef: any;
    widgetRef: any;
    onActive: (event: Event) => void;
    onInactive: (event: Event) => void;
    onWidgetClick: (event: Event) => void;
    keyDown: (e: {
        originalEvent: Event & {
            cancel: boolean;
        };
        keyName: string;
        which: string;
    }) => Event | undefined;
    aria: Record<string, string>;
    cssClasses: string;
    iconSource: string;
    inkRippleConfig: InkRippleConfig;
    buttonTemplateData: Record<string, unknown>;
    restAttributes: RestProps;
}
declare const Button: React.FC<import("./common/base_props").BaseWidgetPropsType & {
    activeStateEnabled: boolean;
    hoverStateEnabled: boolean;
    icon: string;
    iconPosition?: string;
    onClick?: (e: {
        event: Event;
    }) => void;
    onSubmit?: (e: {
        event: Event;
        submitInput: HTMLInputElement | null;
    }) => void;
    pressed?: boolean;
    stylingMode: "outlined" | "text" | "contained";
    template?: (props: {
        data: {
            icon?: string;
            text?: string;
        };
    }) => any;
    iconTemplate?: (props: any) => any;
    children?: React.ReactNode;
    text: string;
    type: "back" | "danger" | "default" | "normal" | "success";
    useInkRipple: boolean;
    useSubmitBehavior: boolean;
    templateData?: Record<string, unknown>;
    render?: (props: {
        data: {
            icon?: string;
            text?: string;
        };
    }) => any;
    component?: (props: {
        data: {
            icon?: string;
            text?: string;
        };
    }) => any;
    iconRender?: (props: any) => any;
    iconComponent?: (props: any) => any;
} & RestProps & {
    ref?: React.Ref<ButtonRef>;
}> & {
    defaultProps: typeof ButtonProps;
};
export { Button };
export default Button;
declare type ButtonOptionRule = DefaultOptionsRule<typeof ButtonProps>;
export declare function defaultOptions(rule: ButtonOptionRule): void;
