import { MutableRefObject } from "react";
import type DomComponent from 'devextreme/core/dom_component';
import { ComponentClass } from 'devextreme/core/dom_component';
import { ConfigContextValue } from "../../common/config_context";
import { EventCallback } from "./event_callback";
interface ComponentProps {
    className?: string;
    itemTemplate?: string | (() => string | HTMLElement);
    valueChange?: EventCallback<any>;
}
export declare const viewFunction: ({ props: { componentProps: { className }, }, restAttributes, widgetRef, }: DomComponentWrapper) => any;
export declare type DomComponentWrapperPropsType = {
    rootElementRef?: MutableRefObject<HTMLDivElement | null>;
    componentType: ComponentClass<Record<string, any>>;
    templateNames: string[];
    componentProps: ComponentProps;
};
export declare const DomComponentWrapperProps: DomComponentWrapperPropsType;
import * as React from "react";
export declare type DomComponentWrapperRef = {
    getInstance: () => DomComponent | null;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface DomComponentWrapper {
    props: typeof DomComponentWrapperProps & RestProps;
    widgetRef: any;
    config?: ConfigContextValue;
    properties: Record<string, unknown>;
    restAttributes: RestProps;
}
declare const DomComponentWrapper: React.FC<DomComponentWrapperPropsType & RestProps & {
    ref?: React.Ref<DomComponentWrapperRef>;
}> & {
    defaultProps: typeof DomComponentWrapperProps;
};
export { DomComponentWrapper };
export default DomComponentWrapper;
