import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["iconComponent", "iconRender", "iconTemplate", "position", "source"];
import { getImageSourceType } from 'devextreme/core/utils/icon';
import { combineClasses } from "../../utils/combine_classes";
export var viewFunction = _ref => {
  var {
    iconClassName,
    props: {
      iconTemplate: IconTemplate,
      source
    },
    sourceType
  } = _ref;
  return React.createElement(React.Fragment, null, sourceType === "dxIcon" && React.createElement("i", {
    className: iconClassName
  }), sourceType === "fontIcon" && React.createElement("i", {
    className: iconClassName
  }), sourceType === "image" && React.createElement("img", {
    className: iconClassName,
    alt: "",
    src: source
  }), IconTemplate && React.createElement("i", {
    className: iconClassName
  }, IconTemplate({})));
};
export var IconProps = {
  position: "left",
  source: ""
};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function Icon(props) {
  var __sourceType = useCallback(function __sourceType() {
    return getImageSourceType(props.source);
  }, [props.source]);

  var __cssClass = useCallback(function __cssClass() {
    return props.position !== "left" ? "dx-icon-right" : "";
  }, [props.position]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __iconClassName = useCallback(function __iconClassName() {
    var generalClasses = {
      "dx-icon": true,
      [__cssClass()]: !!__cssClass()
    };
    var {
      source
    } = props;

    if (__sourceType() === "dxIcon") {
      return combineClasses(_extends({}, generalClasses, {
        ["dx-icon-".concat(source)]: true
      }));
    }

    if (__sourceType() === "fontIcon") {
      return combineClasses(_extends({}, generalClasses, {
        [String(source)]: !!source
      }));
    }

    if (__sourceType() === "image") {
      return combineClasses(generalClasses);
    }

    if (__sourceType() === "svg") {
      return combineClasses(_extends({}, generalClasses, {
        "dx-svg-icon": true
      }));
    }

    return "";
  }, [__cssClass, props.source, __sourceType]);

  return viewFunction({
    props: _extends({}, props, {
      iconTemplate: getTemplate(props.iconTemplate, props.iconRender, props.iconComponent)
    }),
    sourceType: __sourceType(),
    cssClass: __cssClass(),
    iconClassName: __iconClassName(),
    restAttributes: __restAttributes()
  });
}
Icon.defaultProps = IconProps;