export declare const viewFunction: (model: InkRipple) => any;
export interface InkRippleConfig {
    isCentered?: boolean;
    useHoldAnimation?: boolean;
    waveSizeCoefficient?: number;
    wavesNumber?: number;
    durations?: {
        showingScale: number;
        hidingScale: number;
        hidingOpacity: number;
    };
}
export declare type InkRipplePropsType = {
    config?: InkRippleConfig;
};
export declare const InkRippleProps: InkRipplePropsType;
import * as React from "react";
export declare type InkRippleRef = {
    hideWave: (opts: {
        element?: HTMLElement;
        event: Event;
    }) => void;
    showWave: (opts: {
        element?: HTMLElement;
        event: Event;
        wave?: number;
    }) => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface InkRipple {
    props: typeof InkRippleProps & RestProps;
    getConfig: InkRippleConfig;
    restAttributes: RestProps;
}
declare const InkRipple: React.FC<InkRipplePropsType & RestProps & {
    ref?: React.Ref<InkRippleRef>;
}> & {
    defaultProps: typeof InkRippleProps;
};
export { InkRipple };
export default InkRipple;
