import { MutableRefObject } from "react";
import 'devextreme/events/click';
import 'devextreme/events/hover';
import { BaseWidgetProps } from "./base_props";
import { ConfigContextValue } from "../../common/config_context";
export declare const viewFunction: (viewModel: Widget) => any;
export declare type WidgetPropsType = typeof BaseWidgetProps & {
    rootElementRef?: MutableRefObject<HTMLDivElement | null>;
    _feedbackHideTimeout?: number;
    _feedbackShowTimeout?: number;
    activeStateUnit?: string;
    cssText: string;
    aria?: Record<string, string>;
    children?: React.ReactNode;
    classes?: string | undefined;
    name?: string;
    addWidgetClass?: boolean;
    onActive?: (e: Event) => void;
    onDimensionChanged?: () => void;
    onInactive?: (e: Event) => void;
    onVisibilityChange?: (args: boolean) => void;
    onFocusIn?: (e: Event) => void;
    onFocusOut?: (e: Event) => void;
    onHoverStart?: (e: Event) => void;
    onHoverEnd?: (e: Event) => void;
    onRootElementRendered?: (rootElement: HTMLDivElement) => void;
};
export declare const WidgetProps: WidgetPropsType;
import * as React from "react";
export declare type WidgetRef = {
    focus: () => void;
    blur: () => void;
    activate: () => void;
    deactivate: () => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface Widget {
    props: typeof WidgetProps & RestProps;
    active: boolean;
    focused: boolean;
    hovered: boolean;
    widgetElementRef: any;
    config?: ConfigContextValue;
    shouldRenderConfigProvider: boolean;
    rtlEnabled: boolean | undefined;
    attributes: Record<string, string>;
    styles: Record<string, string | number>;
    cssClasses: string;
    tabIndex: undefined | number;
    restAttributes: RestProps;
}
declare const Widget: React.FC<import("./base_props").BaseWidgetPropsType & {
    rootElementRef?: MutableRefObject<HTMLDivElement | null>;
    _feedbackHideTimeout?: number;
    _feedbackShowTimeout?: number;
    activeStateUnit?: string;
    cssText: string;
    aria?: Record<string, string>;
    children?: React.ReactNode;
    classes?: string | undefined;
    name?: string;
    addWidgetClass?: boolean;
    onActive?: (e: Event) => void;
    onDimensionChanged?: () => void;
    onInactive?: (e: Event) => void;
    onVisibilityChange?: (args: boolean) => void;
    onFocusIn?: (e: Event) => void;
    onFocusOut?: (e: Event) => void;
    onHoverStart?: (e: Event) => void;
    onHoverEnd?: (e: Event) => void;
    onRootElementRendered?: (rootElement: HTMLDivElement) => void;
} & RestProps & {
    ref?: React.Ref<WidgetRef>;
}> & {
    defaultProps: typeof WidgetProps;
};
export { Widget };
export default Widget;
