import { EventCallback } from "../common/event_callback";
import { BaseWidgetProps } from "../common/base_props";
export declare const viewFunction: ({ componentProps, domComponentWrapperRef, restAttributes, }: Calendar) => any;
export declare type CalendarPropsType = typeof BaseWidgetProps & {
    min?: Date | number | string;
    max?: Date | number | string;
    firstDayOfWeek?: number;
    value?: Date | number | string | null;
    valueChange?: EventCallback<Date | number | string>;
    focusStateEnabled?: boolean;
    tabIndex?: number;
    _todayDate?: any;
    skipFocusCheck?: boolean;
    defaultValue: Date | number | string | null;
    isReactComponentWrapper?: boolean;
};
export declare const CalendarProps: CalendarPropsType;
import * as React from "react";
export declare type CalendarRef = {
    focus: () => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface Calendar {
    props: typeof CalendarProps & RestProps;
    domComponentWrapperRef: any;
    componentProps: typeof CalendarProps;
    restAttributes: RestProps;
}
declare const Calendar: React.FC<import("../common/base_props").BaseWidgetPropsType & {
    min?: Date | number | string;
    max?: Date | number | string;
    firstDayOfWeek?: number;
    value?: Date | number | string | null;
    valueChange?: EventCallback<Date | number | string>;
    focusStateEnabled?: boolean;
    tabIndex?: number;
    _todayDate?: any;
    skipFocusCheck?: boolean;
    defaultValue: Date | number | string | null;
    isReactComponentWrapper?: boolean;
} & RestProps & {
    ref?: React.Ref<CalendarRef>;
}> & {
    defaultProps: typeof CalendarProps;
};
export { Calendar };
export default Calendar;
