import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["_todayDate", "accessKey", "activeStateEnabled", "className", "defaultValue", "disabled", "firstDayOfWeek", "focusStateEnabled", "height", "hint", "hoverStateEnabled", "isReactComponentWrapper", "max", "min", "onClick", "onKeyDown", "rtlEnabled", "skipFocusCheck", "tabIndex", "value", "valueChange", "visible", "width"];
import LegacyCalendar from 'devextreme/ui/calendar';
import { DomComponentWrapper } from "../common/dom_component_wrapper";
import { BaseWidgetProps } from "../common/base_props";

function today() {
  return new Date();
}

export var viewFunction = _ref => {
  var {
    componentProps,
    domComponentWrapperRef,
    restAttributes
  } = _ref;
  return React.createElement(DomComponentWrapper, _extends({
    componentType: LegacyCalendar,
    componentProps: componentProps,
    templateNames: ["cellTemplate"],
    ref: domComponentWrapperRef
  }, restAttributes));
};
export var CalendarProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
  _todayDate: today,
  skipFocusCheck: false,
  defaultValue: null,
  isReactComponentWrapper: true
})));
import * as React from "react";
import { useState, useCallback, useEffect, useRef, useImperativeHandle, forwardRef } from "react";
var Calendar = forwardRef(function calendar(props, ref) {
  var __domComponentWrapperRef = useRef(null);

  var [__state_value, __state_setValue] = useState(() => props.value !== undefined ? props.value : props.defaultValue);
  var instance = useRef();

  var __componentProps = useCallback(function __componentProps() {
    return _extends({}, props, {
      value: props.value !== undefined ? props.value : __state_value
    });
  }, [props, __state_value]);

  var __restAttributes = useCallback(function __restAttributes() {
    var _props$value = _extends({}, props, {
      value: props.value !== undefined ? props.value : __state_value
    }),
        restProps = _objectWithoutPropertiesLoose(_props$value, _excluded);

    return restProps;
  }, [props, __state_value]);

  var __focus = useCallback(function __focus() {
    var _instance$current;

    (_instance$current = instance.current) === null || _instance$current === void 0 ? void 0 : _instance$current.focus();
  }, [instance]);

  useEffect(() => {
    var _domComponentWrapper;

    instance.current = (_domComponentWrapper = __domComponentWrapperRef.current) === null || _domComponentWrapper === void 0 ? void 0 : _domComponentWrapper.getInstance();
  }, []);
  useImperativeHandle(ref, () => ({
    focus: __focus
  }), [__focus]);
  return viewFunction({
    props: _extends({}, props, {
      value: props.value !== undefined ? props.value : __state_value
    }),
    domComponentWrapperRef: __domComponentWrapperRef,
    componentProps: __componentProps(),
    restAttributes: __restAttributes()
  });
});
export { Calendar };
export default Calendar;
Calendar.defaultProps = CalendarProps;