import { EditorProps } from "../internal/editor";
export declare const viewFunction: (viewModel: CheckBox) => any;
export declare type CheckBoxPropsType = typeof EditorProps & {
    text: string;
    iconSize?: number | string;
    activeStateEnabled: boolean;
    hoverStateEnabled: boolean;
    focusStateEnabled: any;
    value: boolean | null;
    saveValueChangeEvent?: (event: Event) => void;
    defaultValue: boolean | null;
    valueChange?: (value: boolean | null) => void;
};
export declare const CheckBoxProps: CheckBoxPropsType;
export declare type CheckBoxPropsTypeType = {
    text: string;
    iconSize?: number | string;
    activeStateEnabled: boolean;
    hoverStateEnabled: boolean;
    focusStateEnabled: any;
    value: boolean | null;
    saveValueChangeEvent?: (event: Event) => void;
    defaultValue: boolean | null;
    valueChange?: (value: boolean | null) => void;
    readOnly: boolean;
    name: string;
    validationError: Record<string, unknown> | null;
    validationErrors: Record<string, unknown>[] | null;
    validationMessageMode: "auto" | "always";
    validationStatus: "valid" | "invalid" | "pending";
    isValid: boolean;
    onFocusIn?: (e: Event) => void;
    className?: string;
    accessKey?: string;
    disabled?: boolean;
    height?: string | number | (() => string | number);
    hint?: string;
    onClick?: (e: any) => void;
    onKeyDown?: (e: any) => any;
    rtlEnabled?: boolean;
    tabIndex?: number;
    visible?: boolean;
    width?: string | number | (() => string | number);
    aria?: Record<string, string>;
};
export declare const CheckBoxPropsType: CheckBoxPropsTypeType;
import { DefaultOptionsRule } from 'devextreme/core/options/utils';
import * as React from "react";
export declare type CheckBoxRef = {
    focus: () => void;
    blur: () => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface CheckBox {
    props: typeof CheckBoxPropsType & RestProps;
    editorRef: any;
    onWidgetClick: (event: Event) => void;
    keyDown: (e: {
        originalEvent: Event & {
            cancel: boolean;
        };
        keyName: string;
        which: string;
    }) => Event | undefined;
    cssClasses: string;
    aria: Record<string, string>;
    restAttributes: RestProps;
}
declare const CheckBox: React.FC<CheckBoxPropsTypeType & RestProps & {
    ref?: React.Ref<CheckBoxRef>;
}> & {
    defaultProps: typeof CheckBoxPropsType;
};
export { CheckBox };
export default CheckBox;
declare type CheckBoxOptionRule = DefaultOptionsRule<typeof CheckBoxPropsType>;
export declare function defaultOptions(rule: CheckBoxOptionRule): void;
