import DataSource, { Options as DataSourceOptions } from 'devextreme/data/data_source';
import Store from 'devextreme/data/abstract_store';
import { EventCallback } from "../../common/event_callback";
import { BaseWidgetProps } from "../../common/base_props";
export declare const viewFunction: ({ componentProps, restAttributes, }: SelectBox) => any;
export declare type SelectBoxPropsType = typeof BaseWidgetProps & {
    dataSource?: string | (string | any)[] | Store | DataSource | DataSourceOptions;
    displayExpr?: string;
    value?: any;
    valueExpr?: string;
    valueChange?: EventCallback<any>;
    focusStateEnabled?: boolean;
    hoverStateEnabled?: boolean;
    defaultValue: any;
    isReactComponentWrapper?: boolean;
};
export declare const SelectBoxProps: SelectBoxPropsType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface SelectBox {
    props: typeof SelectBoxProps & RestProps;
    componentProps: typeof SelectBoxProps;
    restAttributes: RestProps;
}
export declare function SelectBox(props: typeof SelectBoxProps & RestProps): any;
export declare namespace SelectBox {
    var defaultProps: SelectBoxPropsType;
}
export default SelectBox;
