import { EventCallback } from "../common/event_callback";
import { BaseWidgetProps } from "../common/base_props";
export declare const viewFunction: ({ componentProps, restAttributes, }: NumberBox) => any;
export declare type NumberBoxPropsType = typeof BaseWidgetProps & {
    invalidValueMessage?: string;
    max?: number;
    min?: number;
    mode?: "number" | "text" | "tel";
    showSpinButtons?: boolean;
    step?: number;
    useLargeSpinButtons?: boolean;
    value: number | null;
    valueChange?: EventCallback<number>;
    focusStateEnabled?: boolean;
    hoverStateEnabled?: boolean;
    defaultValue: number | null;
    isReactComponentWrapper?: boolean;
};
export declare const NumberBoxProps: NumberBoxPropsType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface NumberBox {
    props: typeof NumberBoxProps & RestProps;
    componentProps: typeof NumberBoxProps;
    restAttributes: RestProps;
}
export declare function NumberBox(props: typeof NumberBoxProps & RestProps): any;
export declare namespace NumberBox {
    var defaultProps: NumberBoxPropsType;
}
export default NumberBox;
