import { UserDefinedElement, DxElement } from 'devextreme/core/element';
import { template } from 'devextreme/core/templates/template';
import { AnimationConfig } from 'devextreme/animation/fx';
import { PositionConfig } from 'devextreme/animation/position';
import { BaseWidgetProps } from "../common/base_props";
export declare const viewFunction: ({ componentProps, restAttributes, }: Overlay) => any;
export declare type OverlayPropsType = typeof BaseWidgetProps & {
    integrationOptions?: any;
    templatesRenderAsynchronously?: boolean;
    shading?: boolean;
    width?: number | string | (() => number | string);
    height?: number | string | (() => number | string);
    hideOnOutsideClick?: boolean;
    hideOnParentScroll?: boolean;
    animation?: AnimationConfig | null;
    position?: "bottom" | "center" | "left" | "left bottom" | "left top" | "right" | "right bottom" | "right top" | "top" | PositionConfig | Function;
    visible?: boolean;
    container?: string | Element;
    propagateOutsideClick?: boolean;
    _checkParentVisibility?: boolean;
    rtlEnabled?: boolean;
    contentTemplate?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    maxWidth?: number | string | (() => number | string) | null;
    isReactComponentWrapper?: boolean;
};
export declare const OverlayProps: OverlayPropsType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface Overlay {
    props: typeof OverlayProps & RestProps;
    componentProps: typeof OverlayProps;
    restAttributes: RestProps;
}
export declare function Overlay(props: typeof OverlayProps & RestProps): any;
export declare namespace Overlay {
    var defaultProps: OverlayPropsType;
}
export default Overlay;
