import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["_checkParentVisibility", "accessKey", "activeStateEnabled", "animation", "className", "container", "contentTemplate", "disabled", "focusStateEnabled", "height", "hideOnOutsideClick", "hideOnParentScroll", "hint", "hoverStateEnabled", "integrationOptions", "isReactComponentWrapper", "maxWidth", "onClick", "onKeyDown", "position", "propagateOutsideClick", "rtlEnabled", "shading", "tabIndex", "templatesRenderAsynchronously", "visible", "width"];
import LegacyOverlay from 'devextreme/ui/overlay/ui.overlay';
import { DomComponentWrapper } from "../common/dom_component_wrapper";
import { BaseWidgetProps } from "../common/base_props";
export var viewFunction = _ref => {
  var {
    componentProps,
    restAttributes
  } = _ref;
  return React.createElement(DomComponentWrapper, _extends({
    componentType: LegacyOverlay,
    componentProps: componentProps,
    templateNames: []
  }, restAttributes));
};
export var OverlayProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
  get integrationOptions() {
    return {};
  },

  templatesRenderAsynchronously: false,
  shading: true,
  hideOnOutsideClick: false,
  hideOnParentScroll: false,

  get animation() {
    return {
      type: "pop",
      duration: 300,
      to: {
        opacity: 0,
        scale: 0.55
      },
      from: {
        opacity: 1,
        scale: 1
      }
    };
  },

  visible: false,
  propagateOutsideClick: true,
  _checkParentVisibility: false,
  rtlEnabled: false,
  contentTemplate: "content",
  maxWidth: null,
  isReactComponentWrapper: true
})));
import * as React from "react";
import { useCallback } from "react";
export function Overlay(props) {
  var __componentProps = useCallback(function __componentProps() {
    return props;
  }, [props]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props),
    componentProps: __componentProps(),
    restAttributes: __restAttributes()
  });
}
Overlay.defaultProps = OverlayProps;