import { UserDefinedElement, DxElement } from 'devextreme/core/element';
import { template } from 'devextreme/core/templates/template';
import { AnimationConfig } from 'devextreme/animation/fx';
import { PositionConfig } from 'devextreme/animation/position';
import { BaseWidgetProps } from "../common/base_props";
export declare const viewFunction: ({ componentProps, domComponentWrapperRef, restAttributes, }: Popover) => any;
export declare type PopoverPropsType = typeof BaseWidgetProps & {
    animation?: {
        show: AnimationConfig;
        hide: AnimationConfig;
    };
    hideOnOutsideClick: boolean | (() => boolean);
    container?: string | Element;
    contentTemplate: template | ((contentElement: DxElement) => string | UserDefinedElement);
    deferRendering: boolean;
    disabled: boolean;
    height: number | string | (() => number | string);
    hideEvent?: string;
    hint?: string;
    hoverStateEnabled: boolean;
    maxHeight?: number | string | (() => number | string) | null;
    maxWidth?: number | string | (() => number | string) | null;
    minHeight?: number | string | (() => number | string) | null;
    minWidth?: number | string | (() => number | string) | null;
    onHidden?: () => void;
    onHiding?: () => void;
    onInitialized?: () => void;
    onOptionChanged?: () => void;
    onShowing?: () => void;
    onShown?: () => void;
    onTitleRendered?: () => void;
    position: PositionConfig | Function | "bottom" | "left" | "right" | "top";
    rtlEnabled: boolean;
    shading: boolean;
    shadingColor: string;
    showCloseButton: any;
    showEvent?: string;
    showTitle: boolean;
    target?: string | Element;
    title: string;
    titleTemplate: template | ((contentElement: DxElement) => string | UserDefinedElement);
    toolbarItems?: any;
    visible: boolean;
    width: number | string | (() => number | string);
    children?: React.ReactNode;
    defaultVisible: boolean;
    visibleChange?: (visible: boolean) => void;
    contentRender?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    contentComponent?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    titleRender?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    titleComponent?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    isReactComponentWrapper?: boolean;
};
export declare const PopoverProps: PopoverPropsType;
import { DefaultOptionsRule } from 'devextreme/core/options/utils';
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface Popover {
    props: typeof PopoverProps & RestProps;
    domComponentWrapperRef: any;
    componentProps: {
        children?: typeof PopoverProps["children"];
        restProps: Partial<typeof PopoverProps>;
    };
    restAttributes: RestProps;
}
export declare function Popover(props: typeof PopoverProps & RestProps): any;
export declare namespace Popover {
    var defaultProps: PopoverPropsType;
}
export default Popover;
declare type PopoverOptionRule = DefaultOptionsRule<typeof PopoverProps>;
export declare function defaultOptions(rule: PopoverOptionRule): void;
