import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["children"],
    _excluded2 = ["accessKey", "activeStateEnabled", "animation", "children", "className", "container", "contentComponent", "contentRender", "contentTemplate", "defaultVisible", "deferRendering", "disabled", "focusStateEnabled", "height", "hideEvent", "hideOnOutsideClick", "hint", "hoverStateEnabled", "isReactComponentWrapper", "maxHeight", "maxWidth", "minHeight", "minWidth", "onClick", "onHidden", "onHiding", "onInitialized", "onKeyDown", "onOptionChanged", "onShowing", "onShown", "onTitleRendered", "position", "rtlEnabled", "shading", "shadingColor", "showCloseButton", "showEvent", "showTitle", "tabIndex", "target", "title", "titleComponent", "titleRender", "titleTemplate", "toolbarItems", "visible", "visibleChange", "width"];
import devices from 'devextreme/core/devices';
import LegacyPopover from 'devextreme/ui/popover';
import { DomComponentWrapper } from "../common/dom_component_wrapper";
import { BaseWidgetProps } from "../common/base_props";
var isDesktop = !(!devices.real().generic || devices.isSimulator());
export var viewFunction = _ref => {
  var {
    componentProps,
    domComponentWrapperRef,
    restAttributes
  } = _ref;
  return React.createElement(DomComponentWrapper, _extends({
    componentType: LegacyPopover,
    componentProps: componentProps.restProps,
    templateNames: ["titleTemplate", "contentTemplate"],
    ref: domComponentWrapperRef
  }, restAttributes), componentProps.children);
};
export var PopoverProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
  get animation() {
    return {
      show: {
        type: "fade",
        from: 0,
        to: 1
      },
      hide: {
        type: "fade",
        to: 0
      }
    };
  },

  hideOnOutsideClick: false,
  contentTemplate: "content",
  deferRendering: true,
  disabled: false,
  height: "auto",
  hoverStateEnabled: false,
  maxHeight: null,
  maxWidth: null,
  minHeight: null,
  minWidth: null,
  position: "bottom",
  rtlEnabled: false,
  shading: false,
  shadingColor: "",
  showCloseButton: isDesktop,
  showTitle: false,
  title: "",
  titleTemplate: "title",
  width: "auto",
  defaultVisible: true,
  visibleChange: () => {},
  isReactComponentWrapper: true
})));
import { convertRulesToOptions } from 'devextreme/core/options/utils';
import * as React from "react";
import { useState, useCallback, useMemo, useEffect, useRef } from "react";
import { getWrapperTemplate } from "@devextreme/runtime/react";
export function Popover(props) {
  var __domComponentWrapperRef = useRef(null);

  var [__state_visible, __state_setVisible] = useState(() => props.visible !== undefined ? props.visible : props.defaultVisible);
  var instance = useRef();

  var __componentProps = useMemo(function __componentProps() {
    var _props$visible = _extends({}, props, {
      visible: props.visible !== undefined ? props.visible : __state_visible
    }),
        {
      children
    } = _props$visible,
        restProps = _objectWithoutPropertiesLoose(_props$visible, _excluded);

    return {
      children,
      restProps
    };
  }, [props, __state_visible]);

  var __restAttributes = useCallback(function __restAttributes() {
    var _props$visible2 = _extends({}, props, {
      visible: props.visible !== undefined ? props.visible : __state_visible
    }),
        restProps = _objectWithoutPropertiesLoose(_props$visible2, _excluded2);

    return restProps;
  }, [props, __state_visible]);

  useEffect(() => {
    var _domComponentWrapper;

    instance.current = (_domComponentWrapper = __domComponentWrapperRef.current) === null || _domComponentWrapper === void 0 ? void 0 : _domComponentWrapper.getInstance();
  }, []);
  useEffect(() => {
    instance.current.option("onHiding", () => {
      __state_setVisible(__state_visible => false), props.visibleChange(false);
    });
  }, [instance, props.visibleChange]);
  return viewFunction({
    props: _extends({}, props, {
      visible: props.visible !== undefined ? props.visible : __state_visible,
      contentTemplate: getWrapperTemplate(props.contentTemplate),
      titleTemplate: getWrapperTemplate(props.titleTemplate)
    }),
    domComponentWrapperRef: __domComponentWrapperRef,
    componentProps: __componentProps,
    restAttributes: __restAttributes()
  });
}

function __processTwoWayProps(defaultProps) {
  var twoWayProps = ["visible"];
  return Object.keys(defaultProps).reduce((props, propName) => {
    var propValue = defaultProps[propName];
    var defaultPropName = twoWayProps.some(p => p === propName) ? "default" + propName.charAt(0).toUpperCase() + propName.slice(1) : propName;
    props[defaultPropName] = propValue;
    return props;
  }, {});
}

Popover.defaultProps = PopoverProps;
var __defaultOptionRules = [];
export function defaultOptions(rule) {
  __defaultOptionRules.push(rule);

  Popover.defaultProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(Popover.defaultProps), Object.getOwnPropertyDescriptors(__processTwoWayProps(convertRulesToOptions(__defaultOptionRules)))));
}