import { UserDefinedElement, DxElement } from 'devextreme/core/element';
import { template } from 'devextreme/core/templates/template';
import { AnimationConfig } from 'devextreme/animation/fx';
import { PositionConfig } from 'devextreme/animation/position';
import { BaseWidgetProps } from "../common/base_props";
export declare const viewFunction: ({ componentProps, domComponentWrapperRef, restAttributes, }: Popup) => any;
export declare type PopupPropsType = typeof BaseWidgetProps & {
    accessKey?: string;
    animation?: {
        show: AnimationConfig;
        hide: AnimationConfig;
    };
    hideOnOutsideClick: boolean | (() => boolean);
    container?: string | Element;
    contentTemplate: template | ((contentElement: DxElement) => string | UserDefinedElement);
    deferRendering: boolean;
    disabled: boolean;
    dragEnabled: any;
    elementAttr: any;
    focusStateEnabled: any;
    fullScreen: boolean;
    height?: number | string | (() => number | string);
    hint?: string;
    hoverStateEnabled: boolean;
    maxHeight?: number | string | (() => number | string) | null;
    maxWidth?: number | string | (() => number | string) | null;
    minHeight?: number | string | (() => number | string) | null;
    minWidth?: number | string | (() => number | string) | null;
    onHidden?: () => void;
    onHiding?: () => void;
    onInitialized?: () => void;
    onOptionChanged?: () => void;
    onResize?: () => void;
    onResizeEnd?: () => void;
    onResizeStart?: () => void;
    onShowing?: () => void;
    onShown?: () => void;
    onTitleRendered?: () => void;
    position: PositionConfig | Function | "bottom" | "center" | "left" | "left bottom" | "left top" | "right" | "right bottom" | "right top" | "top";
    resizeEnabled: boolean;
    rtlEnabled: boolean;
    shading: boolean;
    shadingColor: string;
    showCloseButton: any;
    showTitle: boolean;
    tabIndex: number;
    title: string;
    titleTemplate: template | ((contentElement: DxElement) => string | UserDefinedElement);
    toolbarItems?: any;
    visible: boolean;
    width?: number | string | (() => number | string);
    children?: React.ReactNode;
    defaultVisible: boolean;
    visibleChange?: (visible: boolean) => void;
    contentRender?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    contentComponent?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    titleRender?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    titleComponent?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    isReactComponentWrapper?: boolean;
};
export declare const PopupProps: PopupPropsType;
import { DefaultOptionsRule } from 'devextreme/core/options/utils';
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface Popup {
    props: typeof PopupProps & RestProps;
    domComponentWrapperRef: any;
    componentProps: {
        children?: typeof PopupProps["children"];
        restProps: Partial<typeof PopupProps>;
    };
    restAttributes: RestProps;
}
export declare function Popup(props: typeof PopupProps & RestProps): any;
export declare namespace Popup {
    var defaultProps: PopupPropsType;
}
export default Popup;
declare type PopupOptionRule = DefaultOptionsRule<typeof PopupProps>;
export declare function defaultOptions(rule: PopupOptionRule): void;
