import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["children"],
    _excluded2 = ["accessKey", "activeStateEnabled", "animation", "children", "className", "container", "contentComponent", "contentRender", "contentTemplate", "defaultVisible", "deferRendering", "disabled", "dragEnabled", "elementAttr", "focusStateEnabled", "fullScreen", "height", "hideOnOutsideClick", "hint", "hoverStateEnabled", "isReactComponentWrapper", "maxHeight", "maxWidth", "minHeight", "minWidth", "onClick", "onHidden", "onHiding", "onInitialized", "onKeyDown", "onOptionChanged", "onResize", "onResizeEnd", "onResizeStart", "onShowing", "onShown", "onTitleRendered", "position", "resizeEnabled", "rtlEnabled", "shading", "shadingColor", "showCloseButton", "showTitle", "tabIndex", "title", "titleComponent", "titleRender", "titleTemplate", "toolbarItems", "visible", "visibleChange", "width"];
import { getWindow } from 'devextreme/core/utils/window';
import devices from 'devextreme/core/devices';
import LegacyPopup from 'devextreme/ui/popup';
import { DomComponentWrapper } from "../common/dom_component_wrapper";
import { BaseWidgetProps } from "../common/base_props";
var isDesktop = !(!devices.real().generic || devices.isSimulator());
var window = getWindow();
export var viewFunction = _ref => {
  var {
    componentProps,
    domComponentWrapperRef,
    restAttributes
  } = _ref;
  return React.createElement(DomComponentWrapper, _extends({
    componentType: LegacyPopup,
    componentProps: componentProps.restProps,
    templateNames: ["titleTemplate", "contentTemplate"],
    ref: domComponentWrapperRef
  }, restAttributes), componentProps.children);
};
export var PopupProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
  get animation() {
    return {
      show: {
        type: "slide",
        duration: 400,
        from: {
          position: {
            my: "top",
            at: "bottom",
            of: window
          }
        },
        to: {
          position: {
            my: "center",
            at: "center",
            of: window
          }
        }
      },
      hide: {
        type: "slide",
        duration: 400,
        from: {
          position: {
            my: "center",
            at: "center",
            of: window
          }
        },
        to: {
          position: {
            my: "top",
            at: "bottom",
            of: window
          }
        }
      }
    };
  },

  hideOnOutsideClick: false,
  contentTemplate: "content",
  deferRendering: true,
  disabled: false,
  dragEnabled: isDesktop,

  get elementAttr() {
    return {};
  },

  focusStateEnabled: isDesktop,
  fullScreen: false,
  hoverStateEnabled: false,
  maxHeight: null,
  maxWidth: null,
  minHeight: null,
  minWidth: null,

  get position() {
    return {
      my: "center",
      at: "center",
      of: "window"
    };
  },

  resizeEnabled: false,
  rtlEnabled: false,
  shading: true,
  shadingColor: "",
  showCloseButton: isDesktop,
  showTitle: true,
  tabIndex: 0,
  title: "",
  titleTemplate: "title",
  defaultVisible: true,
  visibleChange: () => {},
  isReactComponentWrapper: true
})));
import { convertRulesToOptions } from 'devextreme/core/options/utils';
import * as React from "react";
import { useState, useCallback, useMemo, useEffect, useRef } from "react";
import { getWrapperTemplate } from "@devextreme/runtime/react";
export function Popup(props) {
  var __domComponentWrapperRef = useRef(null);

  var [__state_visible, __state_setVisible] = useState(() => props.visible !== undefined ? props.visible : props.defaultVisible);
  var instance = useRef();

  var __componentProps = useMemo(function __componentProps() {
    var _props$visible = _extends({}, props, {
      visible: props.visible !== undefined ? props.visible : __state_visible
    }),
        {
      children
    } = _props$visible,
        restProps = _objectWithoutPropertiesLoose(_props$visible, _excluded);

    return {
      children,
      restProps
    };
  }, [props, __state_visible]);

  var __restAttributes = useCallback(function __restAttributes() {
    var _props$visible2 = _extends({}, props, {
      visible: props.visible !== undefined ? props.visible : __state_visible
    }),
        restProps = _objectWithoutPropertiesLoose(_props$visible2, _excluded2);

    return restProps;
  }, [props, __state_visible]);

  useEffect(() => {
    var _domComponentWrapper;

    instance.current = (_domComponentWrapper = __domComponentWrapperRef.current) === null || _domComponentWrapper === void 0 ? void 0 : _domComponentWrapper.getInstance();
  }, []);
  useEffect(() => {
    instance.current.option("onHiding", () => {
      __state_setVisible(__state_visible => false), props.visibleChange(false);
    });
  }, [instance, props.visibleChange]);
  return viewFunction({
    props: _extends({}, props, {
      visible: props.visible !== undefined ? props.visible : __state_visible,
      contentTemplate: getWrapperTemplate(props.contentTemplate),
      titleTemplate: getWrapperTemplate(props.titleTemplate)
    }),
    domComponentWrapperRef: __domComponentWrapperRef,
    componentProps: __componentProps,
    restAttributes: __restAttributes()
  });
}

function __processTwoWayProps(defaultProps) {
  var twoWayProps = ["visible"];
  return Object.keys(defaultProps).reduce((props, propName) => {
    var propValue = defaultProps[propName];
    var defaultPropName = twoWayProps.some(p => p === propName) ? "default" + propName.charAt(0).toUpperCase() + propName.slice(1) : propName;
    props[defaultPropName] = propValue;
    return props;
  }, {});
}

Popup.defaultProps = PopupProps;
var __defaultOptionRules = [];
export function defaultOptions(rule) {
  __defaultOptionRules.push(rule);

  Popup.defaultProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(Popup.defaultProps), Object.getOwnPropertyDescriptors(__processTwoWayProps(convertRulesToOptions(__defaultOptionRules)))));
}