import { UserDefinedElement, DxElement } from 'devextreme/core/element';
import { template } from 'devextreme/core/templates/template';
import { AnimationConfig } from 'devextreme/animation/fx';
import { PositionConfig } from 'devextreme/animation/position';
import { BaseWidgetProps } from "../common/base_props";
export declare const viewFunction: ({ componentProps, domComponentWrapperRef, restAttributes, }: Tooltip) => any;
export declare type TooltipPropsType = typeof BaseWidgetProps & {
    animation?: {
        show: AnimationConfig;
        hide: AnimationConfig;
    };
    hideOnOutsideClick: boolean | (() => boolean);
    container?: string | Element;
    contentTemplate: template | ((contentElement: DxElement) => string | UserDefinedElement);
    deferRendering: boolean;
    disabled: boolean;
    wrapperAttr: any;
    focusStateEnabled: any;
    fullScreen: boolean;
    height: number | string | (() => number | string);
    hideEvent?: string;
    hint?: string;
    hoverStateEnabled: boolean;
    maxHeight?: number | string | (() => number | string) | null;
    maxWidth?: number | string | (() => number | string) | null;
    minHeight?: number | string | (() => number | string) | null;
    minWidth?: number | string | (() => number | string) | null;
    onHidden?: () => void;
    onHiding?: () => void;
    onInitialized?: () => void;
    onOptionChanged?: () => void;
    onShowing?: () => void;
    onShown?: () => void;
    onTitleRendered?: () => void;
    position: PositionConfig | Function | "bottom" | "left" | "right" | "top";
    rtlEnabled: boolean;
    shading: boolean;
    shadingColor: string;
    showEvent?: string;
    target?: string | Element;
    visible: boolean;
    width?: number | string | (() => number | string);
    children?: React.ReactNode;
    defaultVisible: boolean;
    visibleChange?: (visible: boolean) => void;
    contentRender?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    contentComponent?: template | ((contentElement: DxElement) => string | UserDefinedElement);
    isReactComponentWrapper?: boolean;
};
export declare const TooltipProps: TooltipPropsType;
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface Tooltip {
    props: typeof TooltipProps & RestProps;
    domComponentWrapperRef: any;
    componentProps: {
        children?: typeof TooltipProps["children"];
        restProps: Partial<typeof TooltipProps>;
    };
    restAttributes: RestProps;
}
export declare function Tooltip(props: typeof TooltipProps & RestProps): any;
export declare namespace Tooltip {
    var defaultProps: TooltipPropsType;
}
export default Tooltip;
