import { BaseWidgetProps } from "../common/base_props";
export declare const viewFunction: ({ componentProps, restAttributes, }: ValidationMessage) => any;
export declare type ValidationMessagePropsType = typeof BaseWidgetProps & {
    mode?: "auto" | "always";
    validationErrors?: Record<string, unknown>[] | null;
    positionRequest?: string;
    boundary?: string | Element | null;
    container?: string | Element | null;
    target?: string | Element | null;
    offset?: Record<string, number>;
    contentId?: string;
    isReactComponentWrapper?: boolean;
};
export declare const ValidationMessageProps: ValidationMessagePropsType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
    isReactComponentWrapper?: boolean;
};
interface ValidationMessage {
    props: typeof ValidationMessageProps & RestProps;
    componentProps: typeof ValidationMessageProps;
    restAttributes: RestProps;
}
export declare function ValidationMessage(props: typeof ValidationMessageProps & RestProps): any;
export declare namespace ValidationMessage {
    var defaultProps: ValidationMessagePropsType;
}
export default ValidationMessage;
