import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "className", "label", "onClick"];
import { subscribeToClickEvent } from "../../../utils/subscribe_to_event";
import { KeyboardActionContext } from "./keyboard_action_context";
export var viewFunction = _ref => {
  var {
    props: {
      children,
      className,
      label
    },
    widgetRef
  } = _ref;
  return React.createElement("div", {
    ref: widgetRef,
    className: className,
    tabIndex: 0,
    role: "button",
    "aria-label": label
  }, children);
};
export var LightButtonProps = {
  className: "",
  label: ""
};
import * as React from "react";
import { useContext, useCallback, useEffect, useRef } from "react";
export function LightButton(props) {
  var __widgetRef = useRef(null);

  var keyboardContext = useContext(KeyboardActionContext);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  useEffect(() => {
    return keyboardContext.registerKeyboardAction(__widgetRef.current, props.onClick);
  }, [keyboardContext, props.onClick]);
  useEffect(() => {
    return subscribeToClickEvent(__widgetRef.current, props.onClick);
  }, [props.onClick]);
  return viewFunction({
    props: _extends({}, props),
    widgetRef: __widgetRef,
    keyboardContext,
    restAttributes: __restAttributes()
  });
}
LightButton.defaultProps = LightButtonProps;