import { MutableRefObject } from "react";
import { InternalPagerProps } from "./common/pager_props";
import { KeyboardActionContextType } from "./common/keyboard_action_context";
export declare const viewFunction: ({ classes, infoVisible, isLargeDisplayMode, pageIndexSelectorVisible, pagesContainerVisibility, pagesContainerVisible, props: { hasKnownLastPage, infoText, infoTextRef, maxPagesCount, pageCount, pageIndex, pageIndexChange, pageSize, pageSizeChange, pageSizes, pageSizesRef, pagesCountText, pagesRef, rtlEnabled, showNavigationButtons, showPageSizes, totalCount, visible, }, restAttributes, widgetRootElementRef, }: PagerContent) => any;
export declare type PagerContentPropsType = typeof InternalPagerProps & {
    infoTextVisible: boolean;
    isLargeDisplayMode: boolean;
    rootElementRef?: MutableRefObject<HTMLDivElement | null>;
    pageSizesRef?: MutableRefObject<HTMLDivElement | null>;
    pagesRef?: MutableRefObject<HTMLElement | null>;
    infoTextRef?: MutableRefObject<HTMLDivElement | null>;
};
export declare const PagerContentProps: PagerContentPropsType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface PagerContent {
    props: typeof PagerContentProps & RestProps;
    widgetRootElementRef: any;
    keyboardAction: KeyboardActionContextType;
    infoVisible: boolean;
    pageIndexSelectorVisible: boolean;
    pagesContainerVisible: boolean;
    pagesContainerVisibility: "hidden" | undefined;
    isLargeDisplayMode: boolean;
    classes: string;
    restAttributes: RestProps;
}
export declare function PagerContent(props: typeof PagerContentProps & RestProps): JSX.Element;
export declare namespace PagerContent {
    var defaultProps: PagerContentPropsType;
}
export default PagerContent;
