import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["infoText", "pageCount", "pageIndex", "rootElementRef", "totalCount"];
import { format } from 'devextreme/core/utils/string';
import messageLocalization from 'devextreme/localization/message';
import { InternalPagerProps } from "./common/pager_props";
export var PAGER_INFO_CLASS = "dx-info";
export var viewFunction = _ref => {
  var {
    props: {
      rootElementRef
    },
    text
  } = _ref;
  return React.createElement("div", {
    ref: rootElementRef,
    className: PAGER_INFO_CLASS
  }, text);
};
export var InfoTextProps = {};
var InfoTextPropsType = {
  pageIndex: InternalPagerProps.pageIndex,
  pageCount: InternalPagerProps.pageCount,
  totalCount: InternalPagerProps.totalCount
};
import * as React from "react";
import { useCallback } from "react";
export function InfoText(props) {
  var __infoText = useCallback(function __infoText() {
    var _props$infoText;

    return ((_props$infoText = props.infoText) !== null && _props$infoText !== void 0 ? _props$infoText : "") || messageLocalization.getFormatter("dxPager-infoText")();
  }, [props.infoText]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __text = useCallback(function __text() {
    var {
      pageCount,
      pageIndex,
      totalCount
    } = props;
    return format(__infoText(), (pageIndex + 1).toString(), pageCount.toString(), totalCount.toString());
  }, [props.pageCount, props.pageIndex, props.totalCount, __infoText]);

  return viewFunction({
    props: _extends({}, props),
    infoText: __infoText(),
    text: __text(),
    restAttributes: __restAttributes()
  });
}
InfoText.defaultProps = InfoTextPropsType;