import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["pageSize", "pageSizeChange", "pageSizes"];
import { combineClasses } from "../../../utils/combine_classes";
import { LightButton } from "../common/light_button";
import { InternalPagerProps } from "../common/pager_props";
import { PAGER_SELECTED_PAGE_SIZE_CLASS, PAGER_PAGE_SIZE_CLASS, FIRST_CHILD_CLASS } from "../common/consts";
export var viewFunction = _ref => {
  var {
    pageSizesText
  } = _ref;
  return React.createElement(React.Fragment, null, pageSizesText.map(_ref2 => {
    var {
      className,
      click,
      label,
      text
    } = _ref2;
    return React.createElement(LightButton, {
      key: text,
      className: className,
      label: label,
      onClick: click
    }, text);
  }));
};
export var PageSizeLargeProps = {};
var PageSizeLargePropsType = {
  pageSize: InternalPagerProps.pageSize
};
import * as React from "react";
import { useCallback, useMemo } from "react";
export function PageSizeLarge(props) {
  var __onPageSizeChange = useCallback(function __onPageSizeChange(processedPageSize) {
    return () => {
      props.pageSizeChange(processedPageSize);
      return props.pageSize;
    };
  }, [props.pageSizeChange, props.pageSize]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __pageSizesText = useMemo(function __pageSizesText() {
    var {
      pageSize,
      pageSizes
    } = props;
    return pageSizes.map((_ref3, index) => {
      var {
        text,
        value: processedPageSize
      } = _ref3;
      var selected = processedPageSize === pageSize;
      var className = combineClasses({
        [selected ? PAGER_SELECTED_PAGE_SIZE_CLASS : PAGER_PAGE_SIZE_CLASS]: true,
        [FIRST_CHILD_CLASS]: index === 0
      });
      return {
        className,
        click: __onPageSizeChange(processedPageSize),
        label: "Display ".concat(processedPageSize, " items on page"),
        text
      };
    });
  }, [props.pageSize, props.pageSizes, __onPageSizeChange]);

  return viewFunction({
    props: _extends({}, props),
    pageSizesText: __pageSizesText,
    restAttributes: __restAttributes()
  });
}
PageSizeLarge.defaultProps = PageSizeLargePropsType;