import { MutableRefObject } from "react";
import { FullPageSize } from "../common/types";
export declare const viewFunction: ({ htmlRef, normalizedPageSizes, props: { isLargeDisplayMode, pageSize, pageSizeChange }, }: PageSizeSelector) => any;
export declare type PageSizeSelectorPropsType = {
    isLargeDisplayMode: boolean;
    rootElementRef?: MutableRefObject<HTMLDivElement | null>;
};
import { EventCallback } from "../../common/event_callback";
export declare type PageSizeSelectorPropsTypeType = {
    pageSize: number;
    pageSizeChange: EventCallback<number>;
    pageSizes: (number | "all")[];
    isLargeDisplayMode: boolean;
    rootElementRef?: MutableRefObject<HTMLDivElement | null>;
};
declare const PageSizeSelectorPropsType: PageSizeSelectorPropsTypeType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface PageSizeSelector {
    props: typeof PageSizeSelectorPropsType & RestProps;
    htmlRef: any;
    normalizedPageSizes: FullPageSize[];
    restAttributes: RestProps;
}
export declare function PageSizeSelector(props: typeof PageSizeSelectorPropsType & RestProps): any;
export declare namespace PageSizeSelector {
    var defaultProps: PageSizeSelectorPropsTypeType;
}
export default PageSizeSelector;
