import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["isLargeDisplayMode", "pageSize", "pageSizeChange", "pageSizes", "rootElementRef"];
import { PageSizeSmall } from "./small";
import { PageSizeLarge } from "./large";
import { InternalPagerProps } from "../common/pager_props";
import messageLocalization from 'devextreme/localization/message';
import { PAGER_PAGE_SIZES_CLASS } from "../common/consts";
export var viewFunction = _ref => {
  var {
    htmlRef,
    normalizedPageSizes,
    props: {
      isLargeDisplayMode,
      pageSize,
      pageSizeChange
    }
  } = _ref;
  return React.createElement("div", {
    ref: htmlRef,
    className: PAGER_PAGE_SIZES_CLASS
  }, isLargeDisplayMode && React.createElement(PageSizeLarge, {
    pageSizes: normalizedPageSizes,
    pageSize: pageSize,
    pageSizeChange: pageSizeChange
  }), !isLargeDisplayMode && React.createElement(PageSizeSmall, {
    parentRef: htmlRef,
    pageSizes: normalizedPageSizes,
    pageSize: pageSize,
    pageSizeChange: pageSizeChange
  }));
};

function getAllText() {
  return messageLocalization.getFormatter("dxPager-pageSizesAllText")();
}

var PageSizeSelectorProps = {
  isLargeDisplayMode: true
};
var PageSizeSelectorPropsType = {
  pageSize: InternalPagerProps.pageSize,
  pageSizes: InternalPagerProps.pageSizes,
  isLargeDisplayMode: PageSizeSelectorProps.isLargeDisplayMode
};
import * as React from "react";
import { useCallback, useMemo, useEffect, useRef } from "react";
export function PageSizeSelector(props) {
  var __htmlRef = useRef(null);

  var __normalizedPageSizes = useMemo(function __normalizedPageSizes() {
    var {
      pageSizes
    } = props;
    return pageSizes.map(p => p === "all" || p === 0 ? {
      text: getAllText(),
      value: 0
    } : {
      text: String(p),
      value: p
    });
  }, [props.pageSizes]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  useEffect(() => {
    var {
      rootElementRef
    } = props;

    if (rootElementRef) {
      rootElementRef.current = __htmlRef.current;
    }
  }, []);
  return viewFunction({
    props: _extends({}, props),
    htmlRef: __htmlRef,
    normalizedPageSizes: __normalizedPageSizes,
    restAttributes: __restAttributes()
  });
}
PageSizeSelector.defaultProps = PageSizeSelectorPropsType;