import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["className", "defaultPageIndex", "defaultPageSize", "displayMode", "gridCompatibility", "hasKnownLastPage", "infoText", "lightModeEnabled", "maxPagesCount", "onKeyDown", "pageCount", "pageIndex", "pageIndexChange", "pageSize", "pageSizeChange", "pageSizes", "pagesCountText", "pagesNavigatorVisible", "rtlEnabled", "showInfo", "showNavigationButtons", "showPageSizes", "totalCount", "visible"];
import { ResizableContainer } from "./resizable_container";
import { PagerProps } from "./common/pager_props";
import { PagerContent } from "./content";
import { combineClasses } from "../../utils/combine_classes";
export var viewFunction = _ref => {
  var {
    pagerProps,
    restAttributes
  } = _ref;
  return React.createElement(ResizableContainer, _extends({
    contentTemplate: PagerContent,
    pagerProps: pagerProps
  }, restAttributes));
};
import * as React from "react";
import { useState, useCallback, useMemo } from "react";
export function Pager(props) {
  var [__state_pageSize, __state_setPageSize] = useState(() => props.pageSize !== undefined ? props.pageSize : props.defaultPageSize);
  var [__state_pageIndex, __state_setPageIndex] = useState(() => props.pageIndex !== undefined ? props.pageIndex : props.defaultPageIndex);

  var __pageIndexChange = useCallback(function __pageIndexChange(newPageIndex) {
    if (props.gridCompatibility) {
      __state_setPageIndex(__state_pageIndex => newPageIndex + 1), props.pageIndexChange(newPageIndex + 1);
    } else {
      __state_setPageIndex(__state_pageIndex => newPageIndex), props.pageIndexChange(newPageIndex);
    }
  }, [props.gridCompatibility, props.pageIndexChange]);

  var __pageIndex = useCallback(function __pageIndex() {
    if (props.gridCompatibility) {
      return (props.pageIndex !== undefined ? props.pageIndex : __state_pageIndex) - 1;
    }

    return props.pageIndex !== undefined ? props.pageIndex : __state_pageIndex;
  }, [props.gridCompatibility, props.pageIndex, __state_pageIndex]);

  var __pageSizeChange = useCallback(function __pageSizeChange(newPageSize) {
    __state_setPageSize(__state_pageSize => newPageSize), props.pageSizeChange(newPageSize);
  }, [props.pageSizeChange]);

  var __className = useCallback(function __className() {
    if (props.gridCompatibility) {
      return combineClasses({
        "dx-datagrid-pager": true,
        ["".concat(props.className)]: !!props.className
      });
    }

    return props.className;
  }, [props.gridCompatibility, props.className]);

  var __restAttributes = useCallback(function __restAttributes() {
    var _props$pageSize$pageI = _extends({}, props, {
      pageSize: props.pageSize !== undefined ? props.pageSize : __state_pageSize,
      pageIndex: props.pageIndex !== undefined ? props.pageIndex : __state_pageIndex
    }),
        restProps = _objectWithoutPropertiesLoose(_props$pageSize$pageI, _excluded);

    return restProps;
  }, [props, __state_pageSize, __state_pageIndex]);

  var __pagerProps = useMemo(function __pagerProps() {
    return _extends({}, _extends({}, props, {
      pageSize: props.pageSize !== undefined ? props.pageSize : __state_pageSize,
      pageIndex: props.pageIndex !== undefined ? props.pageIndex : __state_pageIndex
    }), {
      className: __className(),
      pageIndex: __pageIndex(),
      pageIndexChange: pageIndex => __pageIndexChange(pageIndex),
      pageSizeChange: pageSize => __pageSizeChange(pageSize)
    });
  }, [props, __className, __pageIndex, __pageIndexChange, __pageSizeChange, __state_pageSize, __state_pageIndex]);

  return viewFunction({
    props: _extends({}, props, {
      pageSize: props.pageSize !== undefined ? props.pageSize : __state_pageSize,
      pageIndex: props.pageIndex !== undefined ? props.pageIndex : __state_pageIndex
    }),
    pageIndexChange: __pageIndexChange,
    pageIndex: __pageIndex(),
    pageSizeChange: __pageSizeChange,
    className: __className(),
    pagerProps: __pagerProps,
    restAttributes: __restAttributes()
  });
}
Pager.defaultProps = PagerProps;