import { PagePropsInterface } from "./page";
import { ConfigContextValue } from "../../../common/config_context";
export declare const viewFunction: ({ pages }: PagesLarge) => any;
interface PageType {
    key: string;
    pageProps: PagePropsInterface | null;
}
declare type PageIndex = number | "low" | "high";
interface PageIndexes extends Array<PageIndex> {
}
import { EventCallback } from "../../common/event_callback";
export declare type PagesLargePropsTypeType = {
    pageIndex: number;
    pageIndexChange: EventCallback<number>;
    maxPagesCount: number;
    pageCount: number;
};
declare const PagesLargePropsType: PagesLargePropsTypeType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface PagesLarge {
    props: typeof PagesLargePropsType & RestProps;
    config?: ConfigContextValue;
    pageIndexes: PageIndexes;
    pages: PageType[];
    restAttributes: RestProps;
}
export declare function PagesLarge(props: typeof PagesLargePropsType & RestProps): any;
export declare namespace PagesLarge {
    var defaultProps: PagesLargePropsTypeType;
}
export default PagesLarge;
