import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["className", "index", "onClick", "selected"];
import { LightButton } from "../common/light_button";
import { PAGER_PAGE_CLASS, PAGER_SELECTION_CLASS } from "../common/consts";
import { combineClasses } from "../../../utils/combine_classes";
export var viewFunction = _ref => {
  var {
    className,
    label,
    props: {
      onClick
    },
    value
  } = _ref;
  return React.createElement(LightButton, {
    className: className,
    label: label,
    onClick: onClick
  }, value);
};
export var PageProps = {
  index: 0,
  selected: false,
  className: PAGER_PAGE_CLASS
};
import * as React from "react";
import { useCallback } from "react";
export function Page(props) {
  var __value = useCallback(function __value() {
    return props.index + 1;
  }, [props.index]);

  var __className = useCallback(function __className() {
    var {
      selected
    } = props;
    return combineClasses({
      ["".concat(props.className)]: !!props.className,
      [PAGER_SELECTION_CLASS]: !!selected
    });
  }, [props.selected, props.className]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __label = useCallback(function __label() {
    return "Page ".concat(__value());
  }, [__value]);

  return viewFunction({
    props: _extends({}, props),
    label: __label(),
    value: __value(),
    className: __className(),
    restAttributes: __restAttributes()
  });
}
Page.defaultProps = PageProps;