import { ConfigContextValue } from "../../../common/config_context";
export declare const PAGER_BUTTON_DISABLE_CLASS = "dx-button-disable";
export declare const viewFunction: ({ navigateToNextPage, navigateToPrevPage, nextClassName, pageIndexChange, prevClassName, props: { isLargeDisplayMode, maxPagesCount, pageCount, pageIndex, pagesCountText, }, renderNextButton, renderPrevButton, }: PageIndexSelector) => any;
export declare type PageIndexSelectorPropsType = {
    isLargeDisplayMode: boolean;
};
export declare const PageIndexSelectorProps: PageIndexSelectorPropsType;
import { EventCallback } from "../../common/event_callback";
export declare type PageIndexSelectorPropsTypeType = {
    pageIndex: number;
    pageIndexChange: EventCallback<number>;
    maxPagesCount: number;
    pageCount: number;
    pagesCountText?: string;
    hasKnownLastPage: boolean;
    showNavigationButtons: boolean;
    totalCount: number;
    isLargeDisplayMode: boolean;
};
declare const PageIndexSelectorPropsType: PageIndexSelectorPropsTypeType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface PageIndexSelector {
    props: typeof PageIndexSelectorPropsType & RestProps;
    config?: ConfigContextValue;
    pageIndexChange: (pageIndex: number) => void;
    navigateToNextPage: () => void;
    navigateToPrevPage: () => void;
    renderPrevButton: boolean;
    renderNextButton: boolean;
    nextClassName: string;
    prevClassName: string;
    restAttributes: RestProps;
}
export declare function PageIndexSelector(props: typeof PageIndexSelectorPropsType & RestProps): any;
export declare namespace PageIndexSelector {
    var defaultProps: PageIndexSelectorPropsTypeType;
}
export default PageIndexSelector;
