import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["pageCount", "pageIndex", "pageIndexChange", "pagesCountText"];
import { Page } from "./page";
import { PAGER_INFO_CLASS } from "../info";
import { NumberBox } from "../../editors/number_box";
import messageLocalization from 'devextreme/localization/message';
import { calculateValuesFittedWidth } from "../utils/calculate_values_fitted_width";
import { getElementMinWidth } from "../utils/get_element_width";
import { InternalPagerProps } from "../common/pager_props";
var PAGER_INFO_TEXT_CLASS = "".concat(PAGER_INFO_CLASS, "  dx-info-text");
var PAGER_PAGE_INDEX_CLASS = "dx-page-index";
var LIGHT_PAGES_CLASS = "dx-light-pages";
var PAGER_PAGES_COUNT_CLASS = "dx-pages-count";
export var viewFunction = _ref => {
  var {
    pageIndexRef,
    pagesCountText,
    props: {
      pageCount
    },
    selectLastPageIndex,
    value,
    valueChange,
    width
  } = _ref;
  return React.createElement("div", {
    className: LIGHT_PAGES_CLASS,
    ref: pageIndexRef
  }, React.createElement(NumberBox, {
    className: PAGER_PAGE_INDEX_CLASS,
    min: 1,
    max: pageCount,
    width: width,
    value: value,
    valueChange: valueChange
  }), React.createElement("span", {
    className: PAGER_INFO_TEXT_CLASS
  }, pagesCountText), React.createElement(Page, {
    className: PAGER_PAGES_COUNT_CLASS,
    selected: false,
    index: pageCount - 1,
    onClick: selectLastPageIndex
  }));
};
var PagerSmallProps = {
  pageIndex: InternalPagerProps.pageIndex,
  pageCount: InternalPagerProps.pageCount
};
import * as React from "react";
import { useState, useCallback, useEffect, useRef } from "react";
export function PagesSmall(props) {
  var __pageIndexRef = useRef(null);

  var [__state_minWidth, __state_setMinWidth] = useState(10);

  var __value = useCallback(function __value() {
    return props.pageIndex + 1;
  }, [props.pageIndex]);

  var __width = useCallback(function __width() {
    var {
      pageCount
    } = props;
    return calculateValuesFittedWidth(__state_minWidth, [pageCount]);
  }, [props.pageCount, __state_minWidth]);

  var __pagesCountText = useCallback(function __pagesCountText() {
    var _props$pagesCountText;

    return ((_props$pagesCountText = props.pagesCountText) !== null && _props$pagesCountText !== void 0 ? _props$pagesCountText : "") || messageLocalization.getFormatter("dxPager-pagesCountText")();
  }, [props.pagesCountText]);

  var __selectLastPageIndex = useCallback(function __selectLastPageIndex() {
    props.pageIndexChange(props.pageCount - 1);
  }, [props.pageIndexChange, props.pageCount]);

  var __valueChange = useCallback(function __valueChange(value) {
    props.pageIndexChange(value - 1);
  }, [props.pageIndexChange]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  useEffect(() => {
    var _pageIndexRef$curren;

    var el = (_pageIndexRef$curren = __pageIndexRef.current) === null || _pageIndexRef$curren === void 0 ? void 0 : _pageIndexRef$curren.querySelector(".".concat(PAGER_PAGE_INDEX_CLASS));

    __state_setMinWidth(__state_minWidth => el && getElementMinWidth(el) || __state_minWidth);
  }, [__state_minWidth]);
  return viewFunction({
    props: _extends({}, props),
    pageIndexRef: __pageIndexRef,
    value: __value(),
    width: __width(),
    pagesCountText: __pagesCountText(),
    selectLastPageIndex: __selectLastPageIndex,
    valueChange: __valueChange,
    restAttributes: __restAttributes()
  });
}
PagesSmall.defaultProps = PagerSmallProps;