import { InternalPagerProps } from "./common/pager_props";
import { PagerContentProps } from "./content";
export declare const viewFunction: ({ contentAttributes, infoTextRef, infoTextVisible, isLargeDisplayMode, pageSizesRef, pagesRef, parentRef, props: { contentTemplate: Content }, }: ResizableContainer) => any;
interface ChildElements<T> {
    pageSizes: T;
    pages: T;
    info: T;
}
interface AllElements<T> extends ChildElements<T> {
    parent: T;
}
interface ChildElementProps {
    infoTextVisible: boolean;
    isLargeDisplayMode: boolean;
}
export declare function calculateAdaptivityProps({ info: infoWidth, pageSizes: pageSizesWidth, pages: pagesWidth, parent: parentWidth, }: AllElements<number>): ChildElementProps;
export declare type ResizableContainerPropsType = {
    pagerProps: typeof InternalPagerProps;
    contentTemplate: React.FunctionComponent<Partial<Omit<typeof PagerContentProps, "pageSizeChange" | "pageIndexChange">> & Required<Pick<typeof PagerContentProps, "pageSizeChange" | "pageIndexChange">>>;
    contentRender?: React.FunctionComponent<Partial<Omit<typeof PagerContentProps, "pageSizeChange" | "pageIndexChange">> & Required<Pick<typeof PagerContentProps, "pageSizeChange" | "pageIndexChange">>>;
    contentComponent?: React.JSXElementConstructor<Partial<Omit<typeof PagerContentProps, "pageSizeChange" | "pageIndexChange">> & Required<Pick<typeof PagerContentProps, "pageSizeChange" | "pageIndexChange">>>;
};
export declare const ResizableContainerProps: ResizableContainerPropsType;
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface ResizableContainer {
    props: typeof ResizableContainerProps & RestProps;
    parentRef: any;
    pageSizesRef: any;
    infoTextRef: any;
    pagesRef: any;
    infoTextVisible: boolean;
    isLargeDisplayMode: boolean;
    contentAttributes: Record<string, unknown> & typeof InternalPagerProps;
    updateAdaptivityProps: () => void;
    restAttributes: RestProps;
}
export declare function ResizableContainer(props: typeof ResizableContainerProps & RestProps): any;
export declare namespace ResizableContainer {
    var defaultProps: ResizableContainerPropsType;
}
export default ResizableContainer;
