import { AppointmentTemplateProps, AppointmentViewModel, AppointmentClickData } from "./types";
import type { AppointmentTemplateData } from 'devextreme/ui/scheduler';
export declare const viewFunction: ({ classes, data, dateText, isReduced, onItemClick, props: { appointmentTemplate, index, viewModel: { info: { isRecurrent }, }, }, ref, styles, text, }: Appointment) => any;
export declare type AppointmentPropsType = {
    viewModel: AppointmentViewModel;
    index: number;
    appointmentTemplate?: React.FunctionComponent<Partial<AppointmentTemplateProps>>;
    onItemClick: (e: AppointmentClickData) => void;
    appointmentRender?: React.FunctionComponent<Partial<AppointmentTemplateProps>>;
    appointmentComponent?: React.JSXElementConstructor<Partial<AppointmentTemplateProps>>;
};
export declare const AppointmentProps: AppointmentPropsType;
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface Appointment {
    props: typeof AppointmentProps & RestProps;
    ref: any;
    text: string;
    styles: any;
    isReduced: boolean;
    classes: string;
    dateText: string;
    data: AppointmentTemplateData;
    onItemClick: () => void;
    restAttributes: RestProps;
}
export declare function Appointment(props: typeof AppointmentProps & RestProps): any;
export declare namespace Appointment {
    var defaultProps: AppointmentPropsType;
}
export default Appointment;
