import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["appointmentComponent", "appointmentRender", "appointmentTemplate", "data", "dateText", "index", "isRecurrent", "isReduced", "text"];
import { AppointmentDetails } from "./details/layout";
import { AppointmentTitle } from "./title/layout";
export var viewFunction = _ref => {
  var {
    props: {
      appointmentTemplate,
      data,
      dateText,
      index,
      isRecurrent,
      isReduced,
      text
    }
  } = _ref;
  var AppointmentTemplate = appointmentTemplate;
  return React.createElement("div", {
    className: "dx-scheduler-appointment-content"
  }, appointmentTemplate ? AppointmentTemplate({
    data: data,
    index: index
  }) : React.createElement(React.Fragment, null, React.createElement(AppointmentTitle, {
    text: text
  }), React.createElement(AppointmentDetails, {
    dateText: dateText
  }), isRecurrent && React.createElement("div", {
    className: "dx-scheduler-appointment-recurrence-icon dx-icon-repeat"
  }), isReduced && React.createElement("div", {
    className: "dx-scheduler-appointment-reduced-icon"
  })));
};
export var AppointmentContentProps = {
  text: "",
  dateText: "",
  isRecurrent: false,
  isReduced: false,
  index: 0
};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function AppointmentContent(props) {
  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      appointmentTemplate: getTemplate(props.appointmentTemplate, props.appointmentRender, props.appointmentComponent)
    }),
    restAttributes: __restAttributes()
  });
}
AppointmentContent.defaultProps = AppointmentContentProps;