import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["appointmentComponent", "appointmentRender", "appointmentTemplate", "appointments", "isAllDay", "onAppointmentClick", "overflowIndicatorComponent", "overflowIndicatorRender", "overflowIndicatorTemplate", "overflowIndicators"];
import { Appointment } from "./appointment";
import { OverflowIndicator } from "./overflow_indicator/layout";
import { combineClasses } from "../../../utils/combine_classes";
export var viewFunction = _ref => {
  var {
    classes,
    props: {
      appointmentTemplate,
      appointments,
      onAppointmentClick,
      overflowIndicatorTemplate,
      overflowIndicators
    }
  } = _ref;
  return React.createElement("div", {
    className: classes
  }, appointments.map((item, index) => React.createElement(Appointment, {
    viewModel: item,
    appointmentTemplate: appointmentTemplate,
    index: index,
    key: item.key,
    onItemClick: onAppointmentClick
  })), overflowIndicators.map(item => React.createElement(OverflowIndicator, {
    viewModel: item,
    overflowIndicatorTemplate: overflowIndicatorTemplate,
    key: item.key
  })));
};
export var AppointmentLayoutProps = {
  isAllDay: false,

  get appointments() {
    return [];
  },

  get overflowIndicators() {
    return [];
  }

};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function AppointmentLayout(props) {
  var __classes = useCallback(function __classes() {
    var {
      isAllDay
    } = props;
    return combineClasses({
      "dx-scheduler-scrollable-appointments": !isAllDay,
      "dx-scheduler-all-day-appointments": isAllDay
    });
  }, [props.isAllDay]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      appointmentTemplate: getTemplate(props.appointmentTemplate, props.appointmentRender, props.appointmentComponent),
      overflowIndicatorTemplate: getTemplate(props.overflowIndicatorTemplate, props.overflowIndicatorRender, props.overflowIndicatorComponent)
    }),
    classes: __classes(),
    restAttributes: __restAttributes()
  });
}
AppointmentLayout.defaultProps = AppointmentLayoutProps;