import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["overflowIndicatorComponent", "overflowIndicatorRender", "overflowIndicatorTemplate", "viewModel"];
import { combineClasses } from "../../../../utils/combine_classes";
import { Button } from "../../../button";
import { getOverflowIndicatorStyles } from "./utils";
import messageLocalization from 'devextreme/localization/message';
export var viewFunction = _ref => {
  var {
    classes,
    data,
    props: {
      overflowIndicatorTemplate: OverflowIndicatorTemplate
    },
    styles,
    text
  } = _ref;
  return React.createElement(Button, {
    style: normalizeStyles(styles),
    className: classes,
    type: "default",
    stylingMode: "contained"
  }, OverflowIndicatorTemplate ? OverflowIndicatorTemplate({
    data: data
  }) : React.createElement("span", null, text));
};
export var OverflowIndicatorProps = {};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
var NUMBER_STYLES = new Set(["animationIterationCount", "borderImageOutset", "borderImageSlice", "border-imageWidth", "boxFlex", "boxFlexGroup", "boxOrdinalGroup", "columnCount", "fillOpacity", "flex", "flexGrow", "flexNegative", "flexOrder", "flexPositive", "flexShrink", "floodOpacity", "fontWeight", "gridColumn", "gridRow", "lineClamp", "lineHeight", "opacity", "order", "orphans", "stopOpacity", "strokeDasharray", "strokeDashoffset", "strokeMiterlimit", "strokeOpacity", "strokeWidth", "tabSize", "widows", "zIndex", "zoom"]);

var isNumeric = value => {
  if (typeof value === "number") return true;
  return !isNaN(Number(value));
};

var getNumberStyleValue = (style, value) => {
  return NUMBER_STYLES.has(style) ? value : "".concat(value, "px");
};

var normalizeStyles = styles => {
  if (!(styles instanceof Object)) return undefined;
  return Object.entries(styles).reduce((result, _ref2) => {
    var [key, value] = _ref2;
    result[key] = isNumeric(value) ? getNumberStyleValue(key, value) : value;
    return result;
  }, {});
};

export function OverflowIndicator(props) {
  var __data = useCallback(function __data() {
    return {
      appointmentCount: props.viewModel.items.settings.length,
      isCompact: props.viewModel.isCompact
    };
  }, [props.viewModel]);

  var __styles = useCallback(function __styles() {
    return getOverflowIndicatorStyles(props.viewModel);
  }, [props.viewModel]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __text = useCallback(function __text() {
    var {
      isCompact
    } = props.viewModel;

    var {
      appointmentCount
    } = __data();

    if (isCompact) {
      return "".concat(appointmentCount);
    }

    var formatter = messageLocalization.getFormatter("dxScheduler-moreAppointments");
    return formatter(appointmentCount);
  }, [props.viewModel, __data]);

  var __classes = useCallback(function __classes() {
    return combineClasses({
      "dx-scheduler-appointment-collector": true,
      "dx-scheduler-appointment-collector-compact": __data().isCompact
    });
  }, [__data]);

  return viewFunction({
    props: _extends({}, props, {
      overflowIndicatorTemplate: getTemplate(props.overflowIndicatorTemplate, props.overflowIndicatorRender, props.overflowIndicatorComponent)
    }),
    data: __data(),
    text: __text(),
    styles: __styles(),
    classes: __classes(),
    restAttributes: __restAttributes()
  });
}
OverflowIndicator.defaultProps = OverflowIndicatorProps;