export declare const viewFunction: (viewModel: SchedulerCalendar) => any;
export declare type SchedulerCalendarPropsType = {
    currentDate: Date;
    onCurrentDateUpdate: (date: Date) => void;
    firstDayOfWeek: number;
    visible: boolean;
    onVisibleUpdate: (visible: boolean) => void;
    min?: string | number | Date;
    max?: string | number | Date;
    isMobileLayout: any;
};
export declare const SchedulerCalendarProps: SchedulerCalendarPropsType;
import { DefaultOptionsRule } from 'devextreme/core/options/utils';
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface SchedulerCalendar {
    props: typeof SchedulerCalendarProps & RestProps;
    calendarRef: any;
    isMobile: boolean;
    focusCalendar: () => void;
    updateVisible: (visible: boolean) => void;
    updateDate: (date: Date) => void;
    restAttributes: RestProps;
}
export declare function SchedulerCalendar(props: typeof SchedulerCalendarProps & RestProps): any;
export declare namespace SchedulerCalendar {
    var defaultProps: SchedulerCalendarPropsType;
}
export default SchedulerCalendar;
declare type SchedulerCalendarOptionRule = DefaultOptionsRule<typeof SchedulerCalendarProps>;
export declare function defaultOptions(rule: SchedulerCalendarOptionRule): void;
