import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["currentDate", "firstDayOfWeek", "isMobileLayout", "max", "min", "onCurrentDateUpdate", "onVisibleUpdate", "visible"];
import { isMobileLayout } from "./utils";
import { Popup } from "../../overlays/popup";
import { Popover } from "../../overlays/popover";
import { Calendar } from "../../editors/calendar";
export var viewFunction = viewModel => {
  var {
    calendarRef,
    focusCalendar,
    isMobile,
    props,
    updateDate,
    updateVisible
  } = viewModel;
  var {
    currentDate,
    firstDayOfWeek,
    max,
    min,
    visible
  } = props;
  var calendar = React.createElement("div", {
    className: "dx-scheduler-navigator-calendar"
  }, React.createElement(Calendar, {
    value: currentDate,
    valueChange: updateDate,
    min: min,
    max: max,
    firstDayOfWeek: firstDayOfWeek,
    width: "100%",
    focusStateEnabled: true,
    skipFocusCheck: true,
    ref: calendarRef
  }));
  return isMobile ? React.createElement(Popup, {
    className: "dx-scheduler-navigator-calendar-popup",
    showTitle: false,
    hideOnOutsideClick: true,
    visible: visible,
    visibleChange: updateVisible,
    showCloseButton: true,
    fullScreen: true,
    toolbarItems: [{
      shortcut: "cancel"
    }],
    onShown: focusCalendar
  }, calendar) : React.createElement(Popover, {
    target: ".dx-scheduler-navigator-caption",
    className: "dx-scheduler-navigator-calendar-popover",
    showTitle: false,
    hideOnOutsideClick: true,
    visible: visible,
    visibleChange: updateVisible,
    onShown: focusCalendar
  }, calendar);
};
export var SchedulerCalendarProps = {
  get isMobileLayout() {
    return isMobileLayout();
  }

};
import { convertRulesToOptions } from 'devextreme/core/options/utils';
import * as React from "react";
import { useCallback, useRef } from "react";
export function SchedulerCalendar(props) {
  var __calendarRef = useRef(null);

  var __isMobile = useCallback(function __isMobile() {
    return props.isMobileLayout;
  }, [props.isMobileLayout]);

  var __focusCalendar = useCallback(function __focusCalendar() {
    var _calendarRef$current;

    (_calendarRef$current = __calendarRef.current) === null || _calendarRef$current === void 0 ? void 0 : _calendarRef$current.focus();
  }, []);

  var __updateVisible = useCallback(function __updateVisible(visible) {
    props.onVisibleUpdate(visible);
  }, [props.onVisibleUpdate]);

  var __updateDate = useCallback(function __updateDate(date) {
    props.onCurrentDateUpdate(date);
  }, [props.onCurrentDateUpdate]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props),
    calendarRef: __calendarRef,
    isMobile: __isMobile(),
    focusCalendar: __focusCalendar,
    updateVisible: __updateVisible,
    updateDate: __updateDate,
    restAttributes: __restAttributes()
  });
}
SchedulerCalendar.defaultProps = SchedulerCalendarProps;
var __defaultOptionRules = [];
export function defaultOptions(rule) {
  __defaultOptionRules.push(rule);

  SchedulerCalendar.defaultProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(SchedulerCalendar.defaultProps), Object.getOwnPropertyDescriptors(convertRulesToOptions(__defaultOptionRules))));
}