import 'devextreme/ui/button_group';
import 'devextreme/ui/drop_down_button';
import type { DateNavigatorTextInfo } from 'devextreme/ui/scheduler';
import { Direction, ItemView } from "./types";
import { ViewType } from "../types";
import { ViewProps } from "../props";
import { SchedulerToolbarItem } from "./props";
import { ToolbarItem } from "../../toolbar/toolbar_props";
export declare const viewFunction: (viewModel: SchedulerToolbar) => any;
export declare type SchedulerToolbarBasePropsType = {
    items: typeof SchedulerToolbarItem[];
    views: (ViewType | typeof ViewProps)[];
    onCurrentViewUpdate: (view: string | ViewType) => void;
    currentDate: Date;
    onCurrentDateUpdate: (date: Date) => void;
    startViewDate: Date;
    intervalCount: number;
    firstDayOfWeek: number;
    agendaDuration: number;
    useShortDateFormat: any;
    customizationFunction?: (caption: DateNavigatorTextInfo) => string;
    viewType: ViewType;
};
export declare const SchedulerToolbarBaseProps: SchedulerToolbarBasePropsType;
export declare type SchedulerToolbarPropsType = {
    items: typeof SchedulerToolbarItem[];
    views: (ViewType | typeof ViewProps)[];
    onCurrentViewUpdate: (view: string | ViewType) => void;
    currentDate: Date;
    onCurrentDateUpdate: (date: Date) => void;
    startViewDate: Date;
    intervalCount: number;
    firstDayOfWeek: number;
    agendaDuration: number;
    useShortDateFormat: any;
    customizationFunction?: (caption: DateNavigatorTextInfo) => string;
    viewType: ViewType;
    currentView: string | "agenda" | "day" | "month" | "timelineDay" | "timelineMonth" | "timelineWeek" | "timelineWorkWeek" | "week" | "workWeek";
    max?: Date | number | string;
    min?: Date | number | string;
    useDropDownViewSwitcher: boolean;
    defaultCurrentView: string | "agenda" | "day" | "month" | "timelineDay" | "timelineMonth" | "timelineWeek" | "timelineWorkWeek" | "week" | "workWeek";
    currentViewChange?: (currentView: string | "agenda" | "day" | "month" | "timelineDay" | "timelineMonth" | "timelineWeek" | "timelineWorkWeek" | "week" | "workWeek") => void;
};
export declare const SchedulerToolbarProps: SchedulerToolbarPropsType;
import { DefaultOptionsRule } from 'devextreme/core/options/utils';
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface SchedulerToolbar {
    props: typeof SchedulerToolbarProps & RestProps;
    calendarVisible: boolean;
    step: string;
    displayedDate: Date;
    caption: DateNavigatorTextInfo;
    captionText: string;
    views: ItemView[];
    selectedView: string;
    setCurrentView: (view: ItemView) => void;
    setCurrentDate: (date: Date) => void;
    intervalOptions: {
        step: string;
        intervalCount: number;
        firstDayOfWeek: number;
        agendaDuration: number;
    };
    getNextDate: (direction: Direction, initialDate?: Date) => Date;
    updateDateByDirection: (direction: Direction) => void;
    isPreviousButtonDisabled: () => boolean;
    isNextButtonDisabled: () => boolean;
    changeCalendarDate: (date: Date) => void;
    changeCalendarVisible: (visible: boolean) => void;
    showCalendar: () => void;
    items: typeof ToolbarItem[];
    restAttributes: RestProps;
}
export declare function SchedulerToolbar(props: typeof SchedulerToolbarProps & RestProps): any;
export declare namespace SchedulerToolbar {
    var defaultProps: SchedulerToolbarPropsType;
}
export default SchedulerToolbar;
declare type SchedulerToolbarOptionRule = DefaultOptionsRule<typeof SchedulerToolbarProps>;
export declare function defaultOptions(rule: SchedulerToolbarOptionRule): void;
