import { SchedulerProps } from "../props";
import { CurrentViewConfigType } from "../workspaces/props";
import { CellsMetaData, Group, ViewDataProviderType } from "../workspaces/types";
import { AppointmentsConfigType, AppointmentsModelType } from "./types";
import { DataAccessorType, ViewType } from "../types";
import { TimeZoneCalculator } from "../timeZoneCalculator/utils";
export declare const getAppointmentRenderingStrategyName: (viewType: ViewType) => string;
export declare const getAppointmentsConfig: (schedulerConfig: Pick<typeof SchedulerProps, "adaptivityEnabled" | "rtlEnabled" | "resources" | "timeZone" | "groups">, viewConfig: Pick<typeof CurrentViewConfigType, "startDayHour" | "endDayHour" | "currentDate" | "scrolling" | "intervalCount" | "hoursInterval" | "showAllDayPanel" | "firstDayOfWeek" | "type" | "cellDuration" | "maxAppointmentsPerCell">, loadedResources: Group[], viewDataProvider: ViewDataProviderType, isAllDayPanelSupported: boolean) => AppointmentsConfigType;
export declare const getAppointmentsModel: (appointmentsConfig: AppointmentsConfigType, viewDataProvider: ViewDataProviderType, timeZoneCalculator: TimeZoneCalculator, dataAccessors: DataAccessorType, cellsMetaData: CellsMetaData) => AppointmentsModelType;
