import { ResourceProps } from "../props";
import { AppointmentColorConfigType } from "../resources/utils";
import { DataAccessorType, GroupOrientation, ViewType } from "../types";
import { CellsMetaData, Group } from "../workspaces/types";
export interface AppointmentsConfigType {
    adaptivityEnabled: boolean;
    rtlEnabled?: boolean;
    startDayHour: number;
    viewStartDayHour: number;
    endDayHour: number;
    viewEndDayHour: number;
    currentDate: Date;
    resources: typeof ResourceProps[];
    maxAppointmentsPerCell?: number | "auto" | "unlimited";
    isVirtualScrolling: boolean;
    intervalCount: number;
    hoursInterval: number;
    showAllDayPanel: boolean;
    loadedResources: Group[];
    groups: string[];
    groupByDate: boolean;
    appointmentCountPerCell: number;
    appointmentOffset: number;
    allowResizing: boolean;
    allowAllDayResizing: boolean;
    dateTableOffset: number;
    groupOrientation: GroupOrientation;
    startViewDate?: Date;
    timeZone: string;
    firstDayOfWeek: number;
    viewType: ViewType;
    cellDurationInMinutes: number;
    supportAllDayRow: boolean;
    isVerticalGroupOrientation: boolean;
    groupCount: number;
    dateRange: Date[];
}
export interface AppointmentsModelType extends AppointmentsConfigType {
    appointmentRenderingStrategyName: string;
    loadedResources: Group[];
    dataAccessors: DataAccessorType;
    timeZoneCalculator: unknown;
    viewDataProvider: unknown;
    positionHelper: unknown;
    resizableStep: number;
    isGroupedAllDayPanel: boolean;
    rowCount: number;
    cellWidth: number;
    cellHeight: number;
    allDayHeight: number;
    isGroupedByDate: boolean;
    endViewDate: Date;
    visibleDayDuration: number;
    intervalDuration: number;
    allDayIntervalDuration: number;
    leftVirtualCellCount: number;
    topVirtualCellCount: number;
    cellDuration: number;
    getAppointmentColor: (config: AppointmentColorConfigType) => Promise<string>;
    DOMMetaData: CellsMetaData;
}
