import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["height", "scrolling", "width"];
import { isObject, isString } from 'devextreme/core/utils/type';
var VIEW_TYPES = ["day", "week", "workWeek", "month", "timelineDay", "timelineWeek", "timelineWorkWeek", "timelineMonth", "agenda"];
export var getCurrentView = (currentView, views) => {
  var currentViewProps = views.find(view => {
    var names = isObject(view) ? [view.name, view.type] : [view];

    if (names.includes(currentView)) {
      return true;
    }

    return false;
  });

  if (currentViewProps === undefined) {
    if (VIEW_TYPES.includes(currentView)) {
      currentViewProps = currentView;
    } else {
      [currentViewProps] = views;
    }
  }

  return currentViewProps;
};
export var getCurrentViewProps = (currentView, views) => {
  var currentViewProps = getCurrentView(currentView, views);
  return isString(currentViewProps) ? {
    type: currentViewProps
  } : currentViewProps;
};
export function getViewConfigProp(schedulerProp, viewProp) {
  return viewProp !== undefined ? viewProp : schedulerProp;
}
export var getCurrentViewConfig = (currentViewProps, schedulerProps, currentDate) => {
  var {
    scrolling: schedulerScrolling
  } = schedulerProps,
      restSchedulerProps = _objectWithoutPropertiesLoose(schedulerProps, _excluded);

  var {
    scrolling
  } = currentViewProps;
  var isVirtualScrolling = schedulerScrolling.mode === "virtual" || (scrolling === null || scrolling === void 0 ? void 0 : scrolling.mode) === "virtual";
  var crossScrollingEnabled = schedulerProps.crossScrollingEnabled || isVirtualScrolling;

  var result = _extends({
    scrolling: schedulerScrolling
  }, restSchedulerProps, currentViewProps, {
    schedulerHeight: schedulerProps.height,
    schedulerWidth: schedulerProps.width,
    crossScrollingEnabled
  });

  return _extends({}, result, {
    hoursInterval: result.cellDuration / 60,
    allDayPanelExpanded: true,
    allowMultipleCellSelection: true,
    currentDate
  });
};
export var getValidGroups = (schedulerGroups, viewGroups) => getViewConfigProp(schedulerGroups, viewGroups);