import _extends from "@babel/runtime/helpers/esm/extends";
import messageLocalization from 'devextreme/localization/message';
import { BaseWidgetProps } from "../common/base_props";
export var ResourceProps = {};
export var ViewProps = {};
export var AppointmentEditingProps = {};
export var AppointmentDraggingProps = {};
export var ScrollingProps = {};
export var SchedulerProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
  adaptivityEnabled: false,
  crossScrollingEnabled: false,
  descriptionExpr: "description",
  focusStateEnabled: true,
  groupByDate: false,
  indicatorUpdateInterval: 300000,

  get noDataText() {
    return messageLocalization.format("dxCollectionWidget-noDataText");
  },

  recurrenceEditMode: "dialog",
  remoteFiltering: false,

  get selectedCellData() {
    return [];
  },

  shadeUntilCurrentTime: false,
  showAllDayPanel: true,
  showCurrentTimeIndicator: true,
  timeZone: "",
  useDropDownViewSwitcher: false,
  endDayHour: 24,
  startDayHour: 0,
  firstDayOfWeek: 0,
  cellDuration: 30,

  get groups() {
    return [];
  },

  maxAppointmentsPerCell: "auto",
  recurrenceExceptionExpr: "recurrenceException",
  recurrenceRuleExpr: "recurrenceRule",
  startDateExpr: "startDate",
  startDateTimeZoneExpr: "startDateTimeZone",
  endDateExpr: "endDate",
  endDateTimeZoneExpr: "endDateTimeZone",
  allDayExpr: "allDay",
  textExpr: "text",

  get toolbar() {
    return [{
      defaultElement: "dateNavigator",
      location: "before"
    }, {
      defaultElement: "viewSwitcher",
      location: "after"
    }];
  },

  get __defaultNestedValues() {
    return {
      editing: {
        allowAdding: true,
        allowDeleting: true,
        allowDragging: true,
        allowResizing: true,
        allowUpdating: true,
        allowTimeZoneEditing: false
      },
      resources: [],
      scrolling: {
        mode: "standard"
      },
      views: ["day", "week"]
    };
  },

  get defaultCurrentDate() {
    return new Date();
  },

  currentDateChange: () => {},
  defaultCurrentView: "day",
  currentViewChange: () => {}
})));
export var DataAccessorsProps = {
  descriptionExpr: SchedulerProps.descriptionExpr,
  recurrenceExceptionExpr: SchedulerProps.recurrenceExceptionExpr,
  recurrenceRuleExpr: SchedulerProps.recurrenceRuleExpr,
  startDateExpr: SchedulerProps.startDateExpr,
  startDateTimeZoneExpr: SchedulerProps.startDateTimeZoneExpr,
  endDateExpr: SchedulerProps.endDateExpr,
  endDateTimeZoneExpr: SchedulerProps.endDateTimeZoneExpr,
  allDayExpr: SchedulerProps.allDayExpr,
  textExpr: SchedulerProps.textExpr,

  get __defaultNestedValues() {
    return {
      resources: SchedulerProps.resources
    };
  }

};
export var CurrentViewConfigProps = {
  crossScrollingEnabled: SchedulerProps.crossScrollingEnabled,
  groupByDate: SchedulerProps.groupByDate,
  indicatorUpdateInterval: SchedulerProps.indicatorUpdateInterval,
  shadeUntilCurrentTime: SchedulerProps.shadeUntilCurrentTime,
  showAllDayPanel: SchedulerProps.showAllDayPanel,
  showCurrentTimeIndicator: SchedulerProps.showCurrentTimeIndicator,
  endDayHour: SchedulerProps.endDayHour,
  startDayHour: SchedulerProps.startDayHour,
  firstDayOfWeek: SchedulerProps.firstDayOfWeek,
  cellDuration: SchedulerProps.cellDuration,
  maxAppointmentsPerCell: SchedulerProps.maxAppointmentsPerCell,

  get __defaultNestedValues() {
    return {
      scrolling: SchedulerProps.scrolling
    };
  }

};