import { DateType, PathTimeZoneConversion, TimeZoneCalculatorOptions, TimeZoneOffsetsType } from "./types";
export declare class TimeZoneCalculator {
    options: TimeZoneCalculatorOptions;
    constructor(options: TimeZoneCalculatorOptions);
    createDate(sourceDate: DateType, info: {
        path: PathTimeZoneConversion;
        appointmentTimeZone?: string;
    }): Date | undefined;
    getOffsets(date: Date, appointmentTimezone: string | undefined): TimeZoneOffsetsType;
    getConvertedDateByOffsets(date: Date, clientOffset: number, targetOffset: number, isBack: boolean): Date;
    protected getClientOffset(date: Date): number;
    protected getCommonOffset(date: Date): number;
    protected getAppointmentOffset(date: Date, appointmentTimezone: string | undefined): number;
    protected getConvertedDate(date: Date, appointmentTimezone: string | undefined, useAppointmentTimeZone: boolean, isBack: boolean): Date;
}
