import type { Appointment } from 'devextreme/ui/scheduler';
import type { DxPromise } from 'devextreme/core/utils/deferred';
export declare type Direction = "vertical" | "horizontal";
export declare type GroupOrientation = "vertical" | "horizontal";
export declare type ViewType = "agenda" | "day" | "month" | "timelineDay" | "timelineMonth" | "timelineWeek" | "timelineWorkWeek" | "week" | "workWeek";
export interface DataAccessorType {
    getter: Record<string, (data: unknown) => Date | string>;
    setter: Record<string, (object: unknown, data: unknown) => Date | string>;
    expr: Record<string, string>;
    resources?: DataAccessorType;
}
export interface BaseTemplateProps {
    index: number;
}
export interface DataSourcePromise extends DxPromise {
    done: (items: unknown) => void;
}
export interface AppointmentDataItem {
    startDate: Date;
    endDate: Date;
    recurrenceRule: string;
    recurrenceException: string;
    hasRecurrenceRule: boolean;
    allDay: boolean;
    visible: boolean;
    rawAppointment: Appointment;
}
export interface AppointmentFilter {
    filter: (dataItems: AppointmentDataItem[]) => Appointment[];
}
interface CustomLoadDataType {
    data: Appointment[];
}
export declare type LoadDataType = Appointment[] | CustomLoadDataType;
export {};
