import { CalculateCellIndex, GetDateForHeaderText, GetDateForHeaderTextOptions, HeaderCellTextFormat } from "../types";
import { ViewType, GroupOrientation } from "../../../../types";
import { Group } from "../../../../workspaces/types";
export declare const isDateInRange: (date: Date, startDate: Date, endDate: Date, diff: number) => boolean;
export declare const setOptionHour: (date: Date, optionHour: number) => Date;
export declare const getViewStartByOptions: (startDate: Date | undefined, currentDate: Date, intervalDuration: number, startViewDate: Date | undefined) => Date;
export declare const getCalculatedFirstDayOfWeek: (firstDayOfWeekOption: number | undefined) => number;
export declare const calculateViewStartDate: (startDateOption: Date | undefined) => Date | undefined;
export declare const calculateCellIndex: CalculateCellIndex;
export declare const getStartViewDateWithoutDST: (startViewDate: Date, startDayHour: number) => Date;
export declare const getHeaderCellText: (headerIndex: number, date: Date, headerCellTextFormat: HeaderCellTextFormat, getDateForHeaderText: GetDateForHeaderText, additionalOptions: GetDateForHeaderTextOptions) => string;
export declare const validateDayHours: (startDayHour: number, endDayHour: number) => void;
export declare const getStartViewDateTimeOffset: (startViewDate: Date, startDayHour: number) => number;
export declare const formatWeekday: (date: Date) => string;
export declare const formatWeekdayAndDay: (date: Date) => string;
export declare const getToday: (indicatorTime: Date | undefined, timeZoneCalculator: {
    createDate: (todayDate: Date, path: unknown) => Date;
}) => Date;
export declare const getVerticalGroupCountClass: (groups: Group[]) => string | undefined;
export declare const isDateAndTimeView: (viewType: ViewType) => boolean;
export declare const isSupportMultiDayAppointments: (viewType: ViewType) => boolean;
export declare const getHorizontalGroupCount: (groups: Group[], groupOrientation: GroupOrientation) => number;
export declare const calculateIsGroupedAllDayPanel: (groups: Group[], groupOrientation: GroupOrientation, isAllDayPanelVisible: boolean) => boolean;
export declare const calculateDayDuration: (startDayHour: number, endDayHour: number) => number;
export declare const isHorizontalView: (viewType: ViewType) => boolean;
export declare const getTotalCellCountByCompleteData: (completeData: unknown[][]) => number;
export declare const getTotalRowCountByCompleteData: (completeData: unknown[][]) => number;
export declare const getDisplayedCellCount: (displayedCellCount: number | undefined, completeData: unknown[][]) => number;
export declare const getDisplayedRowCount: (displayedRowCount: number | undefined, completeData: unknown[][]) => number;
export declare const getCellDuration: (viewType: ViewType, startDayHour: number, endDayHour: number, hoursInterval: number) => number;
