import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["allDay", "ariaLabel", "children", "className", "contentTemplateProps", "endDate", "groupIndex", "groups", "index", "isFirstGroupCell", "isLastGroupCell", "startDate", "text"];
import { getGroupCellClasses } from "../utils";
export var viewFunction = viewModel => React.createElement("td", {
  className: viewModel.classes,
  "aria-label": viewModel.props.ariaLabel
}, viewModel.props.children);
export var CellBaseProps = {
  className: "",
  isFirstGroupCell: false,
  isLastGroupCell: false,

  get startDate() {
    return new Date();
  },

  get endDate() {
    return new Date();
  },

  allDay: false,
  text: "",
  index: 0,

  get contentTemplateProps() {
    return {
      data: {},
      index: 0
    };
  }

};
import * as React from "react";
import { useCallback } from "react";
export function CellBase(props) {
  var __classes = useCallback(function __classes() {
    var {
      className,
      isFirstGroupCell,
      isLastGroupCell
    } = props;
    return getGroupCellClasses(isFirstGroupCell, isLastGroupCell, className);
  }, [props.className, props.isFirstGroupCell, props.isLastGroupCell]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props),
    classes: __classes(),
    restAttributes: __restAttributes()
  });
}
CellBase.defaultProps = CellBaseProps;