import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["addDateTableClass", "addVerticalSizesClassToRows", "allDayAppointments", "allDayPanelRef", "appointments", "bottomVirtualRowHeight", "className", "dataCellComponent", "dataCellRender", "dataCellTemplate", "dateCellComponent", "dateCellRender", "dateCellTemplate", "dateHeaderData", "dateTableComponent", "dateTableRef", "dateTableRender", "dateTableTemplate", "groupByDate", "groupOrientation", "groupPanelClassName", "groupPanelData", "groupPanelHeight", "groupPanelRef", "groups", "headerEmptyCellWidth", "headerPanelComponent", "headerPanelRender", "headerPanelTemplate", "intervalCount", "isAllDayPanelCollapsed", "isAllDayPanelVisible", "isRenderDateHeader", "isRenderGroupPanel", "isRenderHeaderEmptyCell", "isRenderTimePanel", "isStandaloneAllDayPanel", "isUseMonthDateTable", "isUseTimelineHeader", "isWorkSpaceWithOddCells", "leftVirtualCellWidth", "onScroll", "resourceCellComponent", "resourceCellRender", "resourceCellTemplate", "rightVirtualCellWidth", "scrollingDirection", "tablesWidth", "timeCellComponent", "timeCellRender", "timeCellTemplate", "timePanelData", "timePanelRef", "topVirtualRowHeight", "viewData", "widgetElementRef", "width"];
import { Widget } from "../../../common/widget";
import { Scrollable } from "../../../scroll_view/scrollable";
import { GroupPanel } from "./group_panel/group_panel";
import { AllDayPanelLayout } from "./date_table/all_day_panel/layout";
import { HeaderPanelEmptyCell } from "./header_panel_empty_cell";
import { MainLayoutProps } from "./main_layout_props";
import { Semaphore } from "../../semaphore";
import { TimePanelTableLayout } from "./time_panel/layout";
import { MonthDateTableLayout } from "../month/date_table/layout";
import { DateTableLayoutBase } from "./date_table/layout";
import { TimelineHeaderPanelLayout } from "../timeline/header_panel/layout";
import { HeaderPanelLayout } from "./header_panel/layout";
export var viewFunction = _ref => {
  var {
    dateTableScrollableRef,
    headerScrollableRef,
    headerStyles,
    onDateTableScroll,
    onHeaderScroll,
    onSideBarScroll,
    props: {
      allDayAppointments,
      allDayPanelRef,
      appointments,
      className,
      dataCellTemplate,
      dateCellTemplate,
      dateHeaderData,
      dateTableRef,
      groupByDate,
      groupOrientation,
      groupPanelClassName,
      groupPanelData,
      groupPanelHeight,
      groupPanelRef,
      groups,
      headerEmptyCellWidth,
      isRenderDateHeader,
      isRenderGroupPanel,
      isRenderHeaderEmptyCell,
      isRenderTimePanel,
      isStandaloneAllDayPanel,
      isUseMonthDateTable,
      isUseTimelineHeader,
      resourceCellTemplate,
      tablesWidth,
      timeCellTemplate,
      timePanelData,
      timePanelRef,
      viewData,
      widgetElementRef
    },
    sideBarScrollableRef
  } = _ref;
  var DateTable = isUseMonthDateTable ? MonthDateTableLayout : DateTableLayoutBase;
  var HeaderPanel = isUseTimelineHeader ? TimelineHeaderPanelLayout : HeaderPanelLayout;
  return React.createElement(Widget, {
    className: className,
    rootElementRef: widgetElementRef
  }, React.createElement("div", {
    className: "dx-scheduler-fixed-appointments"
  }), React.createElement("div", {
    className: "dx-scheduler-header-panel-container"
  }, isRenderHeaderEmptyCell && React.createElement(HeaderPanelEmptyCell, {
    width: headerEmptyCellWidth,
    isRenderAllDayTitle: isStandaloneAllDayPanel
  }), React.createElement("div", {
    className: "dx-scheduler-header-tables-container"
  }, React.createElement(Scrollable, {
    ref: headerScrollableRef,
    className: "dx-scheduler-header-scrollable",
    useKeyboard: false,
    showScrollbar: "never",
    direction: "horizontal",
    useNative: false,
    bounceEnabled: false,
    onScroll: onHeaderScroll
  }, React.createElement("table", {
    className: "dx-scheduler-header-panel",
    style: normalizeStyles(headerStyles)
  }, React.createElement(HeaderPanel, {
    dateHeaderData: dateHeaderData,
    groupPanelData: groupPanelData,
    timeCellTemplate: timeCellTemplate,
    dateCellTemplate: dateCellTemplate,
    isRenderDateHeader: isRenderDateHeader,
    groupOrientation: groupOrientation,
    groupByDate: groupByDate,
    groups: groups,
    resourceCellTemplate: resourceCellTemplate
  })), isStandaloneAllDayPanel && React.createElement(AllDayPanelLayout, {
    viewData: viewData,
    dataCellTemplate: dataCellTemplate,
    tableRef: allDayPanelRef,
    allDayAppointments: allDayAppointments,
    width: tablesWidth
  })))), React.createElement("div", {
    className: "dx-scheduler-work-space-flex-container"
  }, React.createElement(Scrollable, {
    ref: sideBarScrollableRef,
    className: "dx-scheduler-sidebar-scrollable",
    useKeyboard: false,
    showScrollbar: "never",
    direction: "vertical",
    useNative: false,
    bounceEnabled: false,
    onScroll: onSideBarScroll
  }, React.createElement("div", {
    className: "dx-scheduler-side-bar-scrollable-content"
  }, isRenderGroupPanel && React.createElement(GroupPanel, {
    groupPanelData: groupPanelData,
    className: groupPanelClassName,
    groupOrientation: groupOrientation,
    groupByDate: groupByDate,
    groups: groups,
    resourceCellTemplate: resourceCellTemplate,
    height: groupPanelHeight,
    elementRef: groupPanelRef
  }), isRenderTimePanel && React.createElement(TimePanelTableLayout, {
    timePanelData: timePanelData,
    timeCellTemplate: timeCellTemplate,
    groupOrientation: groupOrientation,
    tableRef: timePanelRef
  }))), React.createElement(Scrollable, {
    ref: dateTableScrollableRef,
    useKeyboard: false,
    bounceEnabled: false,
    direction: "both",
    className: "dx-scheduler-date-table-scrollable",
    onScroll: onDateTableScroll
  }, React.createElement("div", {
    className: "dx-scheduler-date-table-scrollable-content"
  }, React.createElement("div", {
    className: "dx-scheduler-date-table-container"
  }, React.createElement(DateTable, {
    tableRef: dateTableRef,
    viewData: viewData,
    groupOrientation: groupOrientation,
    dataCellTemplate: dataCellTemplate,
    width: tablesWidth
  }), appointments)))));
};
import * as React from "react";
import { useCallback, useMemo, useRef, useImperativeHandle, forwardRef } from "react";
import { getTemplate } from "@devextreme/runtime/react";
var NUMBER_STYLES = new Set(["animationIterationCount", "borderImageOutset", "borderImageSlice", "border-imageWidth", "boxFlex", "boxFlexGroup", "boxOrdinalGroup", "columnCount", "fillOpacity", "flex", "flexGrow", "flexNegative", "flexOrder", "flexPositive", "flexShrink", "floodOpacity", "fontWeight", "gridColumn", "gridRow", "lineClamp", "lineHeight", "opacity", "order", "orphans", "stopOpacity", "strokeDasharray", "strokeDashoffset", "strokeMiterlimit", "strokeOpacity", "strokeWidth", "tabSize", "widows", "zIndex", "zoom"]);

var isNumeric = value => {
  if (typeof value === "number") return true;
  return !isNaN(Number(value));
};

var getNumberStyleValue = (style, value) => {
  return NUMBER_STYLES.has(style) ? value : "".concat(value, "px");
};

var normalizeStyles = styles => {
  if (!(styles instanceof Object)) return undefined;
  return Object.entries(styles).reduce((result, _ref2) => {
    var [key, value] = _ref2;
    result[key] = isNumeric(value) ? getNumberStyleValue(key, value) : value;
    return result;
  }, {});
};

var CrossScrollingLayout = forwardRef(function crossScrollingLayout(props, ref) {
  var __dateTableScrollableRef = useRef(null);

  var __headerScrollableRef = useRef(null);

  var __sideBarScrollableRef = useRef(null);

  var __dateTableSemaphore = useMemo(function __dateTableSemaphore() {
    return new Semaphore();
  }, []);

  var __headerSemaphore = useMemo(function __headerSemaphore() {
    return new Semaphore();
  }, []);

  var __sideBarSemaphore = useMemo(function __sideBarSemaphore() {
    return new Semaphore();
  }, []);

  var __headerStyles = useCallback(function __headerStyles() {
    return {
      width: props.tablesWidth
    };
  }, [props.tablesWidth]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __getScrollableWidth = useCallback(function __getScrollableWidth() {
    return __dateTableScrollableRef.current.container().getBoundingClientRect().width;
  }, []);

  var __onDateTableScroll = useCallback(function __onDateTableScroll(e) {
    __dateTableSemaphore.take();

    __sideBarSemaphore.isFree() && __sideBarScrollableRef.current.scrollTo({
      top: e.scrollOffset.top
    });
    __headerSemaphore.isFree() && __headerScrollableRef.current.scrollTo({
      left: e.scrollOffset.left
    });
    props.onScroll(e);

    __dateTableSemaphore.release();
  }, [__dateTableSemaphore, __sideBarSemaphore, __headerSemaphore, props.onScroll]);

  var __onHeaderScroll = useCallback(function __onHeaderScroll(e) {
    __headerSemaphore.take();

    __dateTableSemaphore.isFree() && __dateTableScrollableRef.current.scrollTo({
      left: e.scrollOffset.left
    });

    __headerSemaphore.release();
  }, [__headerSemaphore, __dateTableSemaphore]);

  var __onSideBarScroll = useCallback(function __onSideBarScroll(e) {
    __sideBarSemaphore.take();

    __dateTableSemaphore.isFree() && __dateTableScrollableRef.current.scrollTo({
      top: e.scrollOffset.top
    });

    __sideBarSemaphore.release();
  }, [__sideBarSemaphore, __dateTableSemaphore]);

  useImperativeHandle(ref, () => ({
    getScrollableWidth: __getScrollableWidth
  }), [__getScrollableWidth]);
  return viewFunction({
    props: _extends({}, props, {
      headerPanelTemplate: getTemplate(props.headerPanelTemplate, props.headerPanelRender, props.headerPanelComponent),
      dateTableTemplate: getTemplate(props.dateTableTemplate, props.dateTableRender, props.dateTableComponent),
      resourceCellTemplate: getTemplate(props.resourceCellTemplate, props.resourceCellRender, props.resourceCellComponent),
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent),
      dateCellTemplate: getTemplate(props.dateCellTemplate, props.dateCellRender, props.dateCellComponent),
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    dateTableScrollableRef: __dateTableScrollableRef,
    headerScrollableRef: __headerScrollableRef,
    sideBarScrollableRef: __sideBarScrollableRef,
    dateTableSemaphore: __dateTableSemaphore,
    headerSemaphore: __headerSemaphore,
    sideBarSemaphore: __sideBarSemaphore,
    headerStyles: __headerStyles(),
    onDateTableScroll: __onDateTableScroll,
    onHeaderScroll: __onHeaderScroll,
    onSideBarScroll: __onSideBarScroll,
    restAttributes: __restAttributes()
  });
});
export { CrossScrollingLayout };
export default CrossScrollingLayout;
CrossScrollingLayout.defaultProps = MainLayoutProps;