import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["allDay", "ariaLabel", "children", "className", "contentTemplateProps", "dataCellComponent", "dataCellRender", "dataCellTemplate", "endDate", "firstDayOfMonth", "groupIndex", "groups", "index", "isFirstGroupCell", "isFocused", "isLastGroupCell", "isSelected", "otherMonth", "startDate", "text", "today"];
import { ALL_DAY_PANEL_CELL_CLASS } from "../../../const";
import { DateTableCellBaseProps, DateTableCellBase } from "../cell";
export var viewFunction = _ref => {
  var {
    props: {
      className,
      dataCellTemplate,
      endDate,
      groupIndex,
      groups,
      index,
      isFirstGroupCell,
      isFocused,
      isLastGroupCell,
      isSelected,
      startDate
    }
  } = _ref;
  return React.createElement(DateTableCellBase, {
    className: "".concat(ALL_DAY_PANEL_CELL_CLASS, " ").concat(className),
    startDate: startDate,
    endDate: endDate,
    groups: groups,
    groupIndex: groupIndex,
    allDay: true,
    isFirstGroupCell: isFirstGroupCell,
    isLastGroupCell: isLastGroupCell,
    index: index,
    dataCellTemplate: dataCellTemplate,
    isSelected: isSelected,
    isFocused: isFocused
  });
};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function AllDayPanelCell(props) {
  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    restAttributes: __restAttributes()
  });
}
AllDayPanelCell.defaultProps = DateTableCellBaseProps;