import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["addDateTableClass", "addVerticalSizesClassToRows", "bottomVirtualRowHeight", "dataCellComponent", "dataCellRender", "dataCellTemplate", "groupOrientation", "leftVirtualCellWidth", "rightVirtualCellWidth", "tableRef", "topVirtualRowHeight", "viewData", "width"];
import { Table } from "../../table";
import { AllDayPanelTableBody } from "./table_body";
import { LayoutProps } from "../../layout_props";
import { DefaultSizes } from "../../../const";
export var viewFunction = _ref => {
  var {
    allDayPanelData,
    emptyTableHeight,
    props: {
      dataCellTemplate,
      tableRef,
      viewData,
      width
    }
  } = _ref;
  return React.createElement(Table, {
    className: "dx-scheduler-all-day-table",
    height: emptyTableHeight,
    width: width,
    tableRef: tableRef
  }, React.createElement(AllDayPanelTableBody, {
    viewData: allDayPanelData,
    leftVirtualCellWidth: viewData.leftVirtualCellWidth,
    rightVirtualCellWidth: viewData.rightVirtualCellWidth,
    leftVirtualCellCount: viewData.leftVirtualCellCount,
    rightVirtualCellCount: viewData.rightVirtualCellCount,
    dataCellTemplate: dataCellTemplate
  }));
};
export var AllDayTableProps = LayoutProps;
import * as React from "react";
import { useCallback, useMemo } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function AllDayTable(props) {
  var __allDayPanelData = useMemo(function __allDayPanelData() {
    return props.viewData.groupedData[0].allDayPanel;
  }, [props.viewData]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __emptyTableHeight = useCallback(function __emptyTableHeight() {
    return __allDayPanelData ? undefined : DefaultSizes.allDayPanelHeight;
  }, [__allDayPanelData]);

  return viewFunction({
    props: _extends({}, props, {
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    allDayPanelData: __allDayPanelData,
    emptyTableHeight: __emptyTableHeight(),
    restAttributes: __restAttributes()
  });
}
AllDayTable.defaultProps = AllDayTableProps;