import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["className", "dataCellComponent", "dataCellRender", "dataCellTemplate", "isVerticalGroupOrientation", "leftVirtualCellCount", "leftVirtualCellWidth", "rightVirtualCellCount", "rightVirtualCellWidth", "viewData"];
import { Row } from "../../row";
import { AllDayPanelCell as Cell } from "./cell";
import { combineClasses } from "../../../../../../utils/combine_classes";
export var viewFunction = viewModel => React.createElement(Row, {
  leftVirtualCellWidth: viewModel.props.leftVirtualCellWidth,
  rightVirtualCellWidth: viewModel.props.rightVirtualCellWidth,
  leftVirtualCellCount: viewModel.props.leftVirtualCellCount,
  rightVirtualCellCount: viewModel.props.rightVirtualCellCount,
  className: viewModel.classes
}, viewModel.props.viewData.map(_ref => {
  var {
    endDate,
    groupIndex: cellGroupIndex,
    groups,
    index: cellIndex,
    isFirstGroupCell,
    isFocused,
    isLastGroupCell,
    isSelected,
    key,
    startDate
  } = _ref;
  return React.createElement(Cell, {
    isFirstGroupCell: !viewModel.props.isVerticalGroupOrientation && isFirstGroupCell,
    isLastGroupCell: !viewModel.props.isVerticalGroupOrientation && isLastGroupCell,
    startDate: startDate,
    endDate: endDate,
    groups: groups,
    groupIndex: cellGroupIndex,
    index: cellIndex,
    dataCellTemplate: viewModel.props.dataCellTemplate,
    key: key,
    isSelected: isSelected,
    isFocused: isFocused
  });
}));
export var AllDayPanelTableBodyProps = {
  get viewData() {
    return [];
  },

  isVerticalGroupOrientation: false,
  className: "",
  leftVirtualCellWidth: 0,
  rightVirtualCellWidth: 0
};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function AllDayPanelTableBody(props) {
  var __classes = useCallback(function __classes() {
    var {
      className
    } = props;
    return combineClasses({
      "dx-scheduler-all-day-table-row": true,
      [className]: !!className
    });
  }, [props.className]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    classes: __classes(),
    restAttributes: __restAttributes()
  });
}
AllDayPanelTableBody.defaultProps = AllDayPanelTableBodyProps;