import { CellBaseProps } from "../cell";
import { DataCellTemplateProps } from "../../types";
export declare const viewFunction: ({ ariaLabel, classes, dataCellTemplateProps, props: { children, dataCellTemplate: DataCellTemplate, isFirstGroupCell, isLastGroupCell, }, }: DateTableCellBase) => any;
export declare type DateTableCellBasePropsType = typeof CellBaseProps & {
    dataCellTemplate?: React.FunctionComponent<Partial<DataCellTemplateProps>>;
    otherMonth?: boolean;
    today?: boolean;
    firstDayOfMonth?: boolean;
    isSelected: boolean;
    isFocused: boolean;
    children?: React.ReactNode;
    dataCellRender?: React.FunctionComponent<Partial<DataCellTemplateProps>>;
    dataCellComponent?: React.JSXElementConstructor<Partial<DataCellTemplateProps>>;
};
export declare const DateTableCellBaseProps: DateTableCellBasePropsType;
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface DateTableCellBase {
    props: typeof DateTableCellBaseProps & RestProps;
    classes: string;
    dataCellTemplateProps: DataCellTemplateProps;
    ariaLabel: string | undefined;
    restAttributes: RestProps;
}
export declare function DateTableCellBase(props: typeof DateTableCellBaseProps & RestProps): any;
export declare namespace DateTableCellBase {
    var defaultProps: DateTableCellBasePropsType;
}
export default DateTableCellBase;
