import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["allDay", "ariaLabel", "children", "className", "contentTemplateProps", "dataCellComponent", "dataCellRender", "dataCellTemplate", "endDate", "firstDayOfMonth", "groupIndex", "groups", "index", "isFirstGroupCell", "isFocused", "isLastGroupCell", "isSelected", "otherMonth", "startDate", "text", "today"];
import { CellBase as Cell, CellBaseProps } from "../cell";
import { combineClasses } from "../../../../../utils/combine_classes";
import { DATE_TABLE_CELL_CLASS } from "../../const";
var ADD_APPOINTMENT_LABEL = "Add appointment";
export var viewFunction = _ref => {
  var {
    ariaLabel,
    classes,
    dataCellTemplateProps,
    props: {
      children,
      dataCellTemplate: DataCellTemplate,
      isFirstGroupCell,
      isLastGroupCell
    }
  } = _ref;
  return React.createElement(Cell, {
    isFirstGroupCell: isFirstGroupCell,
    isLastGroupCell: isLastGroupCell,
    className: classes,
    ariaLabel: ariaLabel
  }, !DataCellTemplate && children, !!DataCellTemplate && DataCellTemplate({
    index: dataCellTemplateProps.index,
    data: dataCellTemplateProps.data
  }));
};
export var DateTableCellBaseProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(CellBaseProps), Object.getOwnPropertyDescriptors({
  otherMonth: false,
  today: false,
  firstDayOfMonth: false,
  isSelected: false,
  isFocused: false
})));
import * as React from "react";
import { useCallback, useMemo } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function DateTableCellBase(props) {
  var __classes = useCallback(function __classes() {
    var {
      allDay,
      className,
      isFocused,
      isSelected
    } = props;
    return combineClasses({
      "dx-scheduler-cell-sizes-horizontal": true,
      "dx-scheduler-cell-sizes-vertical": !allDay,
      [DATE_TABLE_CELL_CLASS]: !allDay,
      "dx-state-focused": isSelected,
      "dx-scheduler-focused-cell": isFocused,
      [className]: true
    });
  }, [props.allDay, props.className, props.isFocused, props.isSelected]);

  var __dataCellTemplateProps = useMemo(function __dataCellTemplateProps() {
    var {
      allDay,
      contentTemplateProps,
      endDate,
      groupIndex,
      groups,
      index,
      startDate
    } = props;
    return {
      data: _extends({
        startDate,
        endDate,
        groups,
        groupIndex: groups ? groupIndex : undefined,
        text: "",
        allDay: !!allDay || undefined
      }, contentTemplateProps.data),
      index
    };
  }, [props.allDay, props.contentTemplateProps, props.endDate, props.groupIndex, props.groups, props.index, props.startDate]);

  var __ariaLabel = useCallback(function __ariaLabel() {
    return props.isSelected ? ADD_APPOINTMENT_LABEL : undefined;
  }, [props.isSelected]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    classes: __classes(),
    dataCellTemplateProps: __dataCellTemplateProps,
    ariaLabel: __ariaLabel(),
    restAttributes: __restAttributes()
  });
}
DateTableCellBase.defaultProps = DateTableCellBaseProps;