import { MutableRefObject } from "react";
import { CellTemplateProps } from "./table_body";
import { LayoutProps } from "../layout_props";
export declare const viewFunction: ({ bottomVirtualRowHeight, classes, leftVirtualCellWidth, props: { addVerticalSizesClassToRows, cellTemplate, dataCellTemplate, groupOrientation, tableRef, viewData, width, }, restAttributes, rightVirtualCellWidth, topVirtualRowHeight, virtualCellsCount, }: DateTableLayoutBase) => any;
export declare type DateTableLayoutPropsType = typeof LayoutProps & {
    cellTemplate: React.FunctionComponent<Partial<CellTemplateProps>>;
    tableRef?: MutableRefObject<HTMLTableElement | null>;
    cellRender?: React.FunctionComponent<Partial<CellTemplateProps>>;
    cellComponent?: React.JSXElementConstructor<Partial<CellTemplateProps>>;
};
export declare const DateTableLayoutProps: DateTableLayoutPropsType;
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface DateTableLayoutBase {
    props: typeof DateTableLayoutProps & RestProps;
    classes: string | undefined;
    topVirtualRowHeight: number;
    bottomVirtualRowHeight: number;
    leftVirtualCellWidth: number;
    rightVirtualCellWidth: number;
    virtualCellsCount: number;
    restAttributes: RestProps;
}
export declare function DateTableLayoutBase(props: typeof DateTableLayoutProps & RestProps): any;
export declare namespace DateTableLayoutBase {
    var defaultProps: DateTableLayoutPropsType;
}
export default DateTableLayoutBase;
