import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["addDateTableClass", "addVerticalSizesClassToRows", "bottomVirtualRowHeight", "cellComponent", "cellRender", "cellTemplate", "dataCellComponent", "dataCellRender", "dataCellTemplate", "groupOrientation", "leftVirtualCellWidth", "rightVirtualCellWidth", "tableRef", "topVirtualRowHeight", "viewData", "width"];
import { Table } from "../table";
import { DateTableBody } from "./table_body";
import { LayoutProps } from "../layout_props";
import { DateTableCellBase } from "./cell";
export var viewFunction = _ref => {
  var {
    bottomVirtualRowHeight,
    classes,
    leftVirtualCellWidth,
    props: {
      addVerticalSizesClassToRows,
      cellTemplate,
      dataCellTemplate,
      groupOrientation,
      tableRef,
      viewData,
      width
    },
    restAttributes,
    rightVirtualCellWidth,
    topVirtualRowHeight,
    virtualCellsCount
  } = _ref;
  return React.createElement(Table, _extends({}, restAttributes, {
    tableRef: tableRef,
    topVirtualRowHeight: topVirtualRowHeight,
    bottomVirtualRowHeight: bottomVirtualRowHeight,
    leftVirtualCellWidth: leftVirtualCellWidth,
    rightVirtualCellWidth: rightVirtualCellWidth,
    leftVirtualCellCount: viewData.leftVirtualCellCount,
    rightVirtualCellCount: viewData.rightVirtualCellCount,
    virtualCellsCount: virtualCellsCount,
    className: classes,
    width: width
  }), React.createElement(DateTableBody, {
    cellTemplate: cellTemplate,
    viewData: viewData,
    dataCellTemplate: dataCellTemplate,
    leftVirtualCellWidth: leftVirtualCellWidth,
    rightVirtualCellWidth: rightVirtualCellWidth,
    groupOrientation: groupOrientation,
    addVerticalSizesClassToRows: addVerticalSizesClassToRows
  }));
};
export var DateTableLayoutProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(LayoutProps), Object.getOwnPropertyDescriptors({
  cellTemplate: DateTableCellBase
})));
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function DateTableLayoutBase(props) {
  var __classes = useCallback(function __classes() {
    var {
      addDateTableClass
    } = props;
    return addDateTableClass ? "dx-scheduler-date-table" : undefined;
  }, [props.addDateTableClass]);

  var __topVirtualRowHeight = useCallback(function __topVirtualRowHeight() {
    var _props$viewData$topVi;

    return (_props$viewData$topVi = props.viewData.topVirtualRowHeight) !== null && _props$viewData$topVi !== void 0 ? _props$viewData$topVi : 0;
  }, [props.viewData]);

  var __bottomVirtualRowHeight = useCallback(function __bottomVirtualRowHeight() {
    var _props$viewData$botto;

    return (_props$viewData$botto = props.viewData.bottomVirtualRowHeight) !== null && _props$viewData$botto !== void 0 ? _props$viewData$botto : 0;
  }, [props.viewData]);

  var __leftVirtualCellWidth = useCallback(function __leftVirtualCellWidth() {
    var _props$viewData$leftV;

    return (_props$viewData$leftV = props.viewData.leftVirtualCellWidth) !== null && _props$viewData$leftV !== void 0 ? _props$viewData$leftV : 0;
  }, [props.viewData]);

  var __rightVirtualCellWidth = useCallback(function __rightVirtualCellWidth() {
    var _props$viewData$right;

    return (_props$viewData$right = props.viewData.rightVirtualCellWidth) !== null && _props$viewData$right !== void 0 ? _props$viewData$right : 0;
  }, [props.viewData]);

  var __virtualCellsCount = useCallback(function __virtualCellsCount() {
    return props.viewData.groupedData[0].dateTable[0].cells.length;
  }, [props.viewData]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      cellTemplate: getTemplate(props.cellTemplate, props.cellRender, props.cellComponent),
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    classes: __classes(),
    topVirtualRowHeight: __topVirtualRowHeight(),
    bottomVirtualRowHeight: __bottomVirtualRowHeight(),
    leftVirtualCellWidth: __leftVirtualCellWidth(),
    rightVirtualCellWidth: __rightVirtualCellWidth(),
    virtualCellsCount: __virtualCellsCount(),
    restAttributes: __restAttributes()
  });
}
DateTableLayoutBase.defaultProps = DateTableLayoutProps;