import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["addDateTableClass", "addVerticalSizesClassToRows", "bottomVirtualRowHeight", "cellComponent", "cellRender", "cellTemplate", "dataCellComponent", "dataCellRender", "dataCellTemplate", "groupOrientation", "leftVirtualCellWidth", "rightVirtualCellWidth", "topVirtualRowHeight", "viewData", "width"];
import { Row } from "../row";
import { AllDayPanelTableBody } from "./all_day_panel/table_body";
import { LayoutProps } from "../layout_props";
import { DateTableCellBase } from "./cell";
import { combineClasses } from "../../../../../utils/combine_classes";
import { DATE_TABLE_ROW_CLASS } from "../../const";
export var viewFunction = _ref => {
  var {
    props: {
      cellTemplate: Cell,
      dataCellTemplate,
      viewData
    },
    rowClasses
  } = _ref;
  return React.createElement(React.Fragment, null, viewData.groupedData.map(_ref2 => {
    var {
      allDayPanel,
      dateTable,
      isGroupedAllDayPanel,
      key: fragmentKey
    } = _ref2;
    return React.createElement(React.Fragment, {
      key: fragmentKey
    }, isGroupedAllDayPanel && React.createElement(AllDayPanelTableBody, {
      viewData: allDayPanel,
      dataCellTemplate: dataCellTemplate,
      isVerticalGroupOrientation: true,
      leftVirtualCellWidth: viewData.leftVirtualCellWidth,
      rightVirtualCellWidth: viewData.rightVirtualCellWidth,
      leftVirtualCellCount: viewData.leftVirtualCellCount,
      rightVirtualCellCount: viewData.rightVirtualCellCount
    }), dateTable.map(_ref3 => {
      var {
        cells,
        key: rowKey
      } = _ref3;
      return React.createElement(Row, {
        className: rowClasses,
        key: rowKey,
        leftVirtualCellWidth: viewData.leftVirtualCellWidth,
        rightVirtualCellWidth: viewData.rightVirtualCellWidth,
        leftVirtualCellCount: viewData.leftVirtualCellCount,
        rightVirtualCellCount: viewData.rightVirtualCellCount
      }, cells.map(_ref4 => {
        var {
          endDate,
          firstDayOfMonth,
          groupIndex: cellGroupIndex,
          groups,
          index: cellIndex,
          isFirstGroupCell,
          isFocused,
          isLastGroupCell,
          isSelected,
          key,
          otherMonth,
          startDate,
          text,
          today
        } = _ref4;
        return Cell({
          isFirstGroupCell: isFirstGroupCell,
          isLastGroupCell: isLastGroupCell,
          startDate: startDate,
          endDate: endDate,
          groups: groups,
          groupIndex: cellGroupIndex,
          index: cellIndex,
          dataCellTemplate: dataCellTemplate,
          key: key,
          text: text,
          today: today,
          otherMonth: otherMonth,
          firstDayOfMonth: firstDayOfMonth,
          isSelected: isSelected,
          isFocused: isFocused
        });
      }));
    }));
  }));
};
export var DateTableBodyProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(LayoutProps), Object.getOwnPropertyDescriptors({
  cellTemplate: DateTableCellBase
})));
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function DateTableBody(props) {
  var __rowClasses = useCallback(function __rowClasses() {
    var {
      addVerticalSizesClassToRows
    } = props;
    return combineClasses({
      [DATE_TABLE_ROW_CLASS]: true,
      "dx-scheduler-cell-sizes-vertical": addVerticalSizesClassToRows
    });
  }, [props.addVerticalSizesClassToRows]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      cellTemplate: getTemplate(props.cellTemplate, props.cellRender, props.cellComponent),
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    rowClasses: __rowClasses(),
    restAttributes: __restAttributes()
  });
}
DateTableBody.defaultProps = DateTableBodyProps;