import { MutableRefObject } from "react";
import { GroupPanelBaseProps } from "./group_panel_props";
import { VerticalGroupPanelLayoutProps } from "./vertical/layout";
import { HorizontalGroupPanelLayoutProps } from "./horizontal/layout";
import { Group } from "../../types";
import { GroupOrientation } from "../../../types";
export declare const viewFunction: ({ layout: Layout, props: { className, elementRef, groupPanelData, height, resourceCellTemplate, }, restAttributes, }: GroupPanel) => any;
export declare type GroupPanelPropsType = typeof GroupPanelBaseProps & {
    groups: Group[];
    groupOrientation: GroupOrientation;
    elementRef?: MutableRefObject<HTMLDivElement | null>;
};
export declare const GroupPanelProps: GroupPanelPropsType;
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface GroupPanel {
    props: typeof GroupPanelProps & RestProps;
    layout: React.FunctionComponent<Partial<typeof VerticalGroupPanelLayoutProps>> | React.FunctionComponent<Partial<typeof HorizontalGroupPanelLayoutProps>>;
    restAttributes: RestProps;
}
export declare function GroupPanel(props: typeof GroupPanelProps & RestProps): any;
export declare namespace GroupPanel {
    var defaultProps: GroupPanelPropsType;
}
export default GroupPanel;
