import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["className", "elementRef", "groupByDate", "groupOrientation", "groupPanelData", "groups", "height", "resourceCellComponent", "resourceCellRender", "resourceCellTemplate"];
import { isVerticalGroupingApplied } from "../../utils";
import { GroupPanelBaseProps } from "./group_panel_props";
import { GroupPanelVerticalLayout } from "./vertical/layout";
import { GroupPanelHorizontalLayout } from "./horizontal/layout";
import { VERTICAL_GROUP_ORIENTATION } from "../../../consts";
export var viewFunction = _ref => {
  var {
    layout: Layout,
    props: {
      className,
      elementRef,
      groupPanelData,
      height,
      resourceCellTemplate
    },
    restAttributes
  } = _ref;
  return React.createElement(Layout, {
    height: height,
    resourceCellTemplate: resourceCellTemplate,
    className: className,
    groupPanelData: groupPanelData,
    elementRef: elementRef,
    styles: restAttributes.style
  });
};
export var GroupPanelProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(GroupPanelBaseProps), Object.getOwnPropertyDescriptors({
  get groups() {
    return [];
  },

  groupOrientation: VERTICAL_GROUP_ORIENTATION
})));
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function GroupPanel(props) {
  var __layout = useCallback(function __layout() {
    var {
      groupOrientation,
      groups
    } = props;
    return isVerticalGroupingApplied(groups, groupOrientation) ? GroupPanelVerticalLayout : GroupPanelHorizontalLayout;
  }, [props.groupOrientation, props.groups]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      resourceCellTemplate: getTemplate(props.resourceCellTemplate, props.resourceCellRender, props.resourceCellComponent)
    }),
    layout: __layout(),
    restAttributes: __restAttributes()
  });
}
GroupPanel.defaultProps = GroupPanelProps;