import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["cellComponent", "cellRender", "cellTemplate", "className", "colSpan", "color", "data", "id", "index", "isFirstGroupCell", "isLastGroupCell", "text"];
import { combineClasses } from "../../../../../../utils/combine_classes";
import { GroupPanelCellProps } from "../cell_props";
export var viewFunction = _ref => {
  var {
    classes,
    props: {
      cellTemplate: CellTemplate,
      colSpan,
      color,
      data,
      id,
      index,
      text
    }
  } = _ref;
  return React.createElement("th", {
    className: classes,
    colSpan: colSpan
  }, React.createElement("div", {
    className: "dx-scheduler-group-header-content"
  }, !!CellTemplate && CellTemplate({
    data: {
      data,
      id,
      color,
      text
    },
    index: index
  }), !CellTemplate && React.createElement("div", null, text)));
};
export var GroupPanelHorizontalCellProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(GroupPanelCellProps), Object.getOwnPropertyDescriptors({
  isFirstGroupCell: false,
  isLastGroupCell: false,
  colSpan: 1
})));
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function GroupPanelHorizontalCell(props) {
  var __classes = useCallback(function __classes() {
    var {
      className,
      isFirstGroupCell,
      isLastGroupCell
    } = props;
    return combineClasses({
      "dx-scheduler-group-header": true,
      "dx-scheduler-first-group-cell": isFirstGroupCell,
      "dx-scheduler-last-group-cell": isLastGroupCell,
      [className]: !!className
    });
  }, [props.className, props.isFirstGroupCell, props.isLastGroupCell]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      cellTemplate: getTemplate(props.cellTemplate, props.cellRender, props.cellComponent)
    }),
    classes: __classes(),
    restAttributes: __restAttributes()
  });
}
GroupPanelHorizontalCell.defaultProps = GroupPanelHorizontalCellProps;