import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["className", "elementRef", "groupByDate", "groupPanelData", "height", "resourceCellComponent", "resourceCellRender", "resourceCellTemplate", "styles"];
import { Row } from "./row";
import { GroupPanelLayoutProps } from "../group_panel_layout_props";
export var viewFunction = _ref => {
  var {
    groupPanelItems,
    props: {
      resourceCellTemplate
    }
  } = _ref;
  return React.createElement(React.Fragment, null, groupPanelItems.map(group => React.createElement(Row, {
    groupItems: group,
    cellTemplate: resourceCellTemplate,
    key: group[0].key
  })));
};
export var HorizontalGroupPanelLayoutProps = GroupPanelLayoutProps;
import * as React from "react";
import { useCallback, useMemo } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function GroupPanelHorizontalLayout(props) {
  var __groupPanelItems = useMemo(function __groupPanelItems() {
    var {
      groupPanelData
    } = props;
    var {
      baseColSpan,
      groupPanelItems
    } = groupPanelData;
    var colSpans = groupPanelItems.reduceRight((currentColSpans, groupsRow, index) => {
      var nextColSpans = currentColSpans;
      var currentLevelGroupCount = groupsRow.length;
      var previousColSpan = index === groupPanelItems.length - 1 ? baseColSpan : currentColSpans[index + 1];
      var previousLevelGroupCount = index === groupPanelItems.length - 1 ? currentLevelGroupCount : groupPanelItems[index + 1].length;
      var groupCountDiff = previousLevelGroupCount / currentLevelGroupCount;
      nextColSpans[index] = groupCountDiff * previousColSpan;
      return nextColSpans;
    }, [...new Array(groupPanelItems.length)]);
    return groupPanelItems.map((groupsRenderRow, index) => {
      var colSpan = colSpans[index];
      return groupsRenderRow.map(groupItem => _extends({}, groupItem, {
        colSpan
      }));
    });
  }, [props.groupPanelData]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      resourceCellTemplate: getTemplate(props.resourceCellTemplate, props.resourceCellRender, props.resourceCellComponent)
    }),
    groupPanelItems: __groupPanelItems,
    restAttributes: __restAttributes()
  });
}
GroupPanelHorizontalLayout.defaultProps = HorizontalGroupPanelLayoutProps;