import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["cellComponent", "cellRender", "cellTemplate", "className", "groupItems"];
import { GroupPanelHorizontalCell } from "./cell";
import { GroupPanelRowProps } from "../row_props";
export var viewFunction = _ref => {
  var {
    props: {
      cellTemplate,
      className,
      groupItems
    }
  } = _ref;
  return React.createElement("tr", {
    className: "dx-scheduler-group-row ".concat(className)
  }, groupItems.map((_ref2, index) => {
    var {
      colSpan,
      color,
      data,
      id,
      isFirstGroupCell,
      isLastGroupCell,
      key,
      text
    } = _ref2;
    return React.createElement(GroupPanelHorizontalCell, {
      key: key,
      text: text,
      id: id,
      data: data,
      index: index,
      color: color,
      colSpan: colSpan,
      isFirstGroupCell: !!isFirstGroupCell,
      isLastGroupCell: !!isLastGroupCell,
      cellTemplate: cellTemplate
    });
  }));
};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function Row(props) {
  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      cellTemplate: getTemplate(props.cellTemplate, props.cellRender, props.cellComponent)
    }),
    restAttributes: __restAttributes()
  });
}
Row.defaultProps = GroupPanelRowProps;