import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["className", "elementRef", "groupByDate", "groupPanelData", "height", "resourceCellComponent", "resourceCellRender", "resourceCellTemplate", "styles"];
import { Row } from "./row";
import { addHeightToStyle } from "../../../utils";
import { GroupPanelLayoutProps } from "../group_panel_layout_props";
export var viewFunction = _ref => {
  var {
    props: {
      className,
      elementRef,
      groupPanelData,
      resourceCellTemplate
    },
    style
  } = _ref;
  return React.createElement("div", {
    className: className,
    ref: elementRef,
    style: normalizeStyles(style)
  }, React.createElement("div", {
    className: "dx-scheduler-group-flex-container"
  }, groupPanelData.groupPanelItems.map(group => React.createElement(Row, {
    groupItems: group,
    cellTemplate: resourceCellTemplate,
    key: group[0].key
  }))));
};
export var VerticalGroupPanelLayoutProps = GroupPanelLayoutProps;
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
var NUMBER_STYLES = new Set(["animationIterationCount", "borderImageOutset", "borderImageSlice", "border-imageWidth", "boxFlex", "boxFlexGroup", "boxOrdinalGroup", "columnCount", "fillOpacity", "flex", "flexGrow", "flexNegative", "flexOrder", "flexPositive", "flexShrink", "floodOpacity", "fontWeight", "gridColumn", "gridRow", "lineClamp", "lineHeight", "opacity", "order", "orphans", "stopOpacity", "strokeDasharray", "strokeDashoffset", "strokeMiterlimit", "strokeOpacity", "strokeWidth", "tabSize", "widows", "zIndex", "zoom"]);

var isNumeric = value => {
  if (typeof value === "number") return true;
  return !isNaN(Number(value));
};

var getNumberStyleValue = (style, value) => {
  return NUMBER_STYLES.has(style) ? value : "".concat(value, "px");
};

var normalizeStyles = styles => {
  if (!(styles instanceof Object)) return undefined;
  return Object.entries(styles).reduce((result, _ref2) => {
    var [key, value] = _ref2;
    result[key] = isNumeric(value) ? getNumberStyleValue(key, value) : value;
    return result;
  }, {});
};

export function GroupPanelVerticalLayout(props) {
  var __style = useCallback(function __style() {
    var {
      height,
      styles
    } = props;
    return addHeightToStyle(height, styles);
  }, [props.height, props.styles]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      resourceCellTemplate: getTemplate(props.resourceCellTemplate, props.resourceCellRender, props.resourceCellComponent)
    }),
    style: __style(),
    restAttributes: __restAttributes()
  });
}
GroupPanelVerticalLayout.defaultProps = VerticalGroupPanelLayoutProps;