import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["allDay", "ariaLabel", "children", "className", "colSpan", "contentTemplateProps", "dateCellComponent", "dateCellRender", "dateCellTemplate", "endDate", "groupIndex", "groups", "index", "isFirstGroupCell", "isLastGroupCell", "isTimeCellTemplate", "isWeekDayCell", "splitText", "startDate", "text", "timeCellComponent", "timeCellRender", "timeCellTemplate", "today"];
import { CellBaseProps } from "../../cell";
import { combineClasses } from "../../../../../../utils/combine_classes";
import { getGroupCellClasses } from "../../../utils";
import { DateHeaderText } from "./dateHeaderText";
export var viewFunction = _ref => {
  var {
    classes,
    props: {
      colSpan,
      dateCellTemplate: DateCellTemplate,
      groupIndex,
      groups,
      index,
      isTimeCellTemplate,
      splitText,
      startDate,
      text,
      timeCellTemplate: TimeCellTemplate
    },
    useTemplate
  } = _ref;
  return React.createElement("th", {
    className: classes,
    colSpan: colSpan,
    title: text
  }, useTemplate ? React.createElement(React.Fragment, null, isTimeCellTemplate && TimeCellTemplate && TimeCellTemplate({
    data: {
      date: startDate,
      text,
      groups,
      groupIndex
    },
    index: index
  }), !isTimeCellTemplate && DateCellTemplate && DateCellTemplate({
    data: {
      date: startDate,
      text,
      groups,
      groupIndex
    },
    index: index
  })) : React.createElement(DateHeaderText, {
    splitText: splitText,
    text: text
  }));
};
export var DateHeaderCellProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(CellBaseProps), Object.getOwnPropertyDescriptors({
  today: false,
  colSpan: 1,
  isWeekDayCell: false,
  splitText: false,
  isTimeCellTemplate: false
})));
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function DateHeaderCell(props) {
  var __classes = useCallback(function __classes() {
    var {
      className,
      isFirstGroupCell,
      isLastGroupCell,
      isWeekDayCell,
      today
    } = props;
    var cellClasses = combineClasses({
      "dx-scheduler-header-panel-cell": true,
      "dx-scheduler-cell-sizes-horizontal": true,
      "dx-scheduler-header-panel-current-time-cell": today,
      "dx-scheduler-header-panel-week-cell": isWeekDayCell,
      [className]: !!className
    });
    return getGroupCellClasses(isFirstGroupCell, isLastGroupCell, cellClasses);
  }, [props.className, props.isFirstGroupCell, props.isLastGroupCell, props.isWeekDayCell, props.today]);

  var __useTemplate = useCallback(function __useTemplate() {
    var {
      dateCellTemplate,
      isTimeCellTemplate,
      timeCellTemplate
    } = props;
    return !isTimeCellTemplate && !!dateCellTemplate || isTimeCellTemplate && !!timeCellTemplate;
  }, [props.dateCellTemplate, props.isTimeCellTemplate, props.timeCellTemplate]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent),
      dateCellTemplate: getTemplate(props.dateCellTemplate, props.dateCellRender, props.dateCellComponent)
    }),
    classes: __classes(),
    useTemplate: __useTemplate(),
    restAttributes: __restAttributes()
  });
}
DateHeaderCell.defaultProps = DateHeaderCellProps;