import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["dateCellComponent", "dateCellRender", "dateCellTemplate", "dateHeaderData", "groupByDate", "groupOrientation", "groups", "timeCellComponent", "timeCellRender", "timeCellTemplate"];
import { Row } from "../../row";
import { isHorizontalGroupingApplied } from "../../../utils";
import { DateHeaderCell } from "./cell";
import getThemeType from "../../../../../../utils/getThemeType";
var {
  isMaterial
} = getThemeType();
export var viewFunction = _ref => {
  var {
    isHorizontalGrouping,
    props: {
      dateCellTemplate,
      dateHeaderData
    }
  } = _ref;
  var {
    dataMap,
    leftVirtualCellCount,
    leftVirtualCellWidth,
    rightVirtualCellCount,
    rightVirtualCellWidth
  } = dateHeaderData;
  return React.createElement(React.Fragment, null, dataMap.map((dateHeaderRow, rowIndex) => React.createElement(Row, {
    className: "dx-scheduler-header-row",
    key: rowIndex.toString(),
    leftVirtualCellWidth: leftVirtualCellWidth,
    leftVirtualCellCount: leftVirtualCellCount,
    rightVirtualCellWidth: rightVirtualCellWidth,
    rightVirtualCellCount: rightVirtualCellCount,
    isHeaderRow: true
  }, dateHeaderRow.map(_ref2 => {
    var {
      colSpan,
      endDate,
      groupIndex,
      groups: cellGroups,
      index,
      isFirstGroupCell,
      isLastGroupCell,
      key,
      startDate,
      text,
      today
    } = _ref2;
    return React.createElement(DateHeaderCell, {
      startDate: startDate,
      endDate: endDate,
      groups: isHorizontalGrouping ? cellGroups : undefined,
      groupIndex: isHorizontalGrouping ? groupIndex : undefined,
      today: today,
      index: index,
      text: text,
      isFirstGroupCell: isFirstGroupCell,
      isLastGroupCell: isLastGroupCell,
      dateCellTemplate: dateCellTemplate,
      key: key,
      colSpan: colSpan,
      splitText: isMaterial
    });
  }))));
};
export var DateHeaderLayoutProps = {
  groupOrientation: "horizontal",
  groupByDate: false,

  get groups() {
    return [];
  }

};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function DateHeaderLayout(props) {
  var __isHorizontalGrouping = useCallback(function __isHorizontalGrouping() {
    var {
      groupByDate,
      groupOrientation,
      groups
    } = props;
    return isHorizontalGroupingApplied(groups, groupOrientation) && !groupByDate;
  }, [props.groupByDate, props.groupOrientation, props.groups]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dateCellTemplate: getTemplate(props.dateCellTemplate, props.dateCellRender, props.dateCellComponent),
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent)
    }),
    isHorizontalGrouping: __isHorizontalGrouping(),
    restAttributes: __restAttributes()
  });
}
DateHeaderLayout.defaultProps = DateHeaderLayoutProps;