import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["className", "dateCellComponent", "dateCellRender", "dateCellTemplate", "dateHeaderComponent", "dateHeaderData", "dateHeaderRender", "dateHeaderTemplate", "elementRef", "groupByDate", "groupOrientation", "groupPanelData", "groups", "height", "isRenderDateHeader", "resourceCellComponent", "resourceCellRender", "resourceCellTemplate", "timeCellComponent", "timeCellRender", "timeCellTemplate"];
import { isHorizontalGroupingApplied } from "../../utils";
import { GroupPanel, GroupPanelProps } from "../group_panel/group_panel";
import { DateHeaderLayout } from "./date_header/layout";
export var viewFunction = _ref => {
  var {
    isHorizontalGrouping,
    props: {
      dateCellTemplate,
      dateHeaderData,
      dateHeaderTemplate: DateHeader,
      groupByDate,
      groupOrientation,
      groupPanelData,
      groups,
      isRenderDateHeader,
      resourceCellTemplate,
      timeCellTemplate
    }
  } = _ref;
  return React.createElement("thead", null, isHorizontalGrouping && !groupByDate && React.createElement(GroupPanel, {
    groupPanelData: groupPanelData,
    groups: groups,
    groupByDate: groupByDate,
    groupOrientation: groupOrientation,
    resourceCellTemplate: resourceCellTemplate
  }), isRenderDateHeader && DateHeader({
    groupByDate: groupByDate,
    dateHeaderData: dateHeaderData,
    groupOrientation: groupOrientation,
    groups: groups,
    dateCellTemplate: dateCellTemplate,
    timeCellTemplate: timeCellTemplate
  }), groupByDate && React.createElement(GroupPanel, {
    groupPanelData: groupPanelData,
    groups: groups,
    groupByDate: groupByDate,
    groupOrientation: groupOrientation,
    resourceCellTemplate: resourceCellTemplate
  }));
};
export var HeaderPanelLayoutProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(GroupPanelProps), Object.getOwnPropertyDescriptors({
  isRenderDateHeader: true,
  dateHeaderTemplate: DateHeaderLayout
})));
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function HeaderPanelLayout(props) {
  var __isHorizontalGrouping = useCallback(function __isHorizontalGrouping() {
    var {
      groupOrientation,
      groups
    } = props;
    return isHorizontalGroupingApplied(groups, groupOrientation);
  }, [props.groupOrientation, props.groups]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dateCellTemplate: getTemplate(props.dateCellTemplate, props.dateCellRender, props.dateCellComponent),
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent),
      dateHeaderTemplate: getTemplate(props.dateHeaderTemplate, props.dateHeaderRender, props.dateHeaderComponent),
      resourceCellTemplate: getTemplate(props.resourceCellTemplate, props.resourceCellRender, props.resourceCellComponent)
    }),
    isHorizontalGrouping: __isHorizontalGrouping(),
    restAttributes: __restAttributes()
  });
}
HeaderPanelLayout.defaultProps = HeaderPanelLayoutProps;