import { MutableRefObject } from "react";
import { DateHeaderData, DateTimeCellTemplateProps, Group, GroupPanelData, ResourceCellTemplateProps, TimePanelData } from "../types";
import { DateTableLayoutProps } from "./date_table/layout";
import { HeaderPanelLayoutProps } from "./header_panel/layout";
import { LayoutProps } from "./layout_props";
import { ScrollableDirection, ScrollEventArgs } from "../../../scroll_view/common/types";
export declare type MainLayoutPropsType = typeof LayoutProps & {
    headerPanelTemplate: React.FunctionComponent<Partial<Omit<typeof HeaderPanelLayoutProps, "dateHeaderData">> & Required<Pick<typeof HeaderPanelLayoutProps, "dateHeaderData">>>;
    dateTableTemplate: React.FunctionComponent<Partial<typeof DateTableLayoutProps>>;
    resourceCellTemplate?: React.FunctionComponent<Partial<ResourceCellTemplateProps>>;
    timeCellTemplate?: React.FunctionComponent<Partial<DateTimeCellTemplateProps>>;
    dateCellTemplate?: React.FunctionComponent<Partial<DateTimeCellTemplateProps>>;
    timePanelData: TimePanelData;
    dateHeaderData: DateHeaderData;
    groupPanelData: GroupPanelData;
    intervalCount: number;
    className: string;
    isRenderDateHeader: boolean;
    groups: Group[];
    groupByDate: boolean;
    groupPanelClassName: "dx-scheduler-work-space-vertical-group-table" | "dx-scheduler-group-table";
    isWorkSpaceWithOddCells?: boolean;
    isAllDayPanelCollapsed: boolean;
    isAllDayPanelVisible: boolean;
    isRenderHeaderEmptyCell: boolean;
    isRenderGroupPanel: boolean;
    isStandaloneAllDayPanel: boolean;
    isRenderTimePanel: boolean;
    isUseMonthDateTable: boolean;
    isUseTimelineHeader: boolean;
    groupPanelHeight?: number;
    tablesWidth?: number;
    headerEmptyCellWidth?: number;
    scrollingDirection?: ScrollableDirection;
    onScroll: (event: ScrollEventArgs) => void;
    dateTableRef: MutableRefObject<HTMLTableElement | null>;
    allDayPanelRef?: MutableRefObject<HTMLTableElement | null>;
    timePanelRef?: MutableRefObject<HTMLTableElement | null>;
    groupPanelRef?: MutableRefObject<HTMLDivElement | null>;
    widgetElementRef?: MutableRefObject<HTMLDivElement | null>;
    appointments?: React.ReactNode;
    allDayAppointments?: React.ReactNode;
    headerPanelRender?: React.FunctionComponent<Partial<Omit<typeof HeaderPanelLayoutProps, "dateHeaderData">> & Required<Pick<typeof HeaderPanelLayoutProps, "dateHeaderData">>>;
    headerPanelComponent?: React.JSXElementConstructor<Partial<Omit<typeof HeaderPanelLayoutProps, "dateHeaderData">> & Required<Pick<typeof HeaderPanelLayoutProps, "dateHeaderData">>>;
    dateTableRender?: React.FunctionComponent<Partial<typeof DateTableLayoutProps>>;
    dateTableComponent?: React.JSXElementConstructor<Partial<typeof DateTableLayoutProps>>;
    resourceCellRender?: React.FunctionComponent<Partial<ResourceCellTemplateProps>>;
    resourceCellComponent?: React.JSXElementConstructor<Partial<ResourceCellTemplateProps>>;
    timeCellRender?: React.FunctionComponent<Partial<DateTimeCellTemplateProps>>;
    timeCellComponent?: React.JSXElementConstructor<Partial<DateTimeCellTemplateProps>>;
    dateCellRender?: React.FunctionComponent<Partial<DateTimeCellTemplateProps>>;
    dateCellComponent?: React.JSXElementConstructor<Partial<DateTimeCellTemplateProps>>;
};
export declare const MainLayoutProps: MainLayoutPropsType;
