import { MutableRefObject } from "react";
import { MainLayoutProps } from "./main_layout_props";
export declare const viewFunction: ({ dateTableScrollableRef, props: { allDayAppointments, allDayPanelRef, appointments, className, dataCellTemplate, dateCellTemplate, dateHeaderData, dateTableRef, groupByDate, groupOrientation, groupPanelClassName, groupPanelData, groupPanelHeight, groupPanelRef, groups, headerEmptyCellWidth, isRenderDateHeader, isRenderGroupPanel, isRenderHeaderEmptyCell, isRenderTimePanel, isStandaloneAllDayPanel, isUseMonthDateTable, isUseTimelineHeader, resourceCellTemplate, scrollingDirection, timeCellTemplate, timePanelData, timePanelRef, viewData, widgetElementRef, }, }: OrdinaryLayout) => any;
import * as React from "react";
export declare type OrdinaryLayoutRef = {
    getScrollableWidth: () => number;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface OrdinaryLayout {
    props: typeof MainLayoutProps & RestProps;
    dateTableScrollableRef: any;
    restAttributes: RestProps;
}
declare const OrdinaryLayout: React.FC<import("./layout_props").LayoutPropsType & {
    headerPanelTemplate: React.FunctionComponent<Partial<Omit<import("./header_panel/layout").HeaderPanelLayoutPropsType, "dateHeaderData">> & Required<Pick<import("./header_panel/layout").HeaderPanelLayoutPropsType, "dateHeaderData">>>;
    dateTableTemplate: React.FunctionComponent<Partial<import("./date_table/layout").DateTableLayoutPropsType>>;
    resourceCellTemplate?: React.FunctionComponent<Partial<import("../types").ResourceCellTemplateProps>>;
    timeCellTemplate?: React.FunctionComponent<Partial<import("../types").DateTimeCellTemplateProps>>;
    dateCellTemplate?: React.FunctionComponent<Partial<import("../types").DateTimeCellTemplateProps>>;
    timePanelData: import("../types").TimePanelData;
    dateHeaderData: import("../types").DateHeaderData;
    groupPanelData: import("../types").GroupPanelData;
    intervalCount: number;
    className: string;
    isRenderDateHeader: boolean;
    groups: import("../types").Group[];
    groupByDate: boolean;
    groupPanelClassName: "dx-scheduler-work-space-vertical-group-table" | "dx-scheduler-group-table";
    isWorkSpaceWithOddCells?: boolean;
    isAllDayPanelCollapsed: boolean;
    isAllDayPanelVisible: boolean;
    isRenderHeaderEmptyCell: boolean;
    isRenderGroupPanel: boolean;
    isStandaloneAllDayPanel: boolean;
    isRenderTimePanel: boolean;
    isUseMonthDateTable: boolean;
    isUseTimelineHeader: boolean;
    groupPanelHeight?: number;
    tablesWidth?: number;
    headerEmptyCellWidth?: number;
    scrollingDirection?: import("../../../scroll_view/common/types").ScrollableDirection;
    onScroll: (event: import("../../../scroll_view/common/types").ScrollEventArgs) => void;
    dateTableRef: MutableRefObject<HTMLTableElement>;
    allDayPanelRef?: MutableRefObject<HTMLTableElement>;
    timePanelRef?: MutableRefObject<HTMLTableElement>;
    groupPanelRef?: MutableRefObject<HTMLDivElement>;
    widgetElementRef?: MutableRefObject<HTMLDivElement>;
    appointments?: React.ReactNode;
    allDayAppointments?: React.ReactNode;
    headerPanelRender?: React.FunctionComponent<Partial<Omit<import("./header_panel/layout").HeaderPanelLayoutPropsType, "dateHeaderData">> & Required<Pick<import("./header_panel/layout").HeaderPanelLayoutPropsType, "dateHeaderData">>>;
    headerPanelComponent?: React.JSXElementConstructor<Partial<Omit<import("./header_panel/layout").HeaderPanelLayoutPropsType, "dateHeaderData">> & Required<Pick<import("./header_panel/layout").HeaderPanelLayoutPropsType, "dateHeaderData">>>;
    dateTableRender?: React.FunctionComponent<Partial<import("./date_table/layout").DateTableLayoutPropsType>>;
    dateTableComponent?: React.JSXElementConstructor<Partial<import("./date_table/layout").DateTableLayoutPropsType>>;
    resourceCellRender?: React.FunctionComponent<Partial<import("../types").ResourceCellTemplateProps>>;
    resourceCellComponent?: React.JSXElementConstructor<Partial<import("../types").ResourceCellTemplateProps>>;
    timeCellRender?: React.FunctionComponent<Partial<import("../types").DateTimeCellTemplateProps>>;
    timeCellComponent?: React.JSXElementConstructor<Partial<import("../types").DateTimeCellTemplateProps>>;
    dateCellRender?: React.FunctionComponent<Partial<import("../types").DateTimeCellTemplateProps>>;
    dateCellComponent?: React.JSXElementConstructor<Partial<import("../types").DateTimeCellTemplateProps>>;
} & RestProps & {
    ref?: React.Ref<OrdinaryLayoutRef>;
}> & {
    defaultProps: typeof MainLayoutProps;
};
export { OrdinaryLayout };
export default OrdinaryLayout;
