import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["addDateTableClass", "addVerticalSizesClassToRows", "allDayAppointments", "allDayPanelRef", "appointments", "bottomVirtualRowHeight", "className", "dataCellComponent", "dataCellRender", "dataCellTemplate", "dateCellComponent", "dateCellRender", "dateCellTemplate", "dateHeaderData", "dateTableComponent", "dateTableRef", "dateTableRender", "dateTableTemplate", "groupByDate", "groupOrientation", "groupPanelClassName", "groupPanelData", "groupPanelHeight", "groupPanelRef", "groups", "headerEmptyCellWidth", "headerPanelComponent", "headerPanelRender", "headerPanelTemplate", "intervalCount", "isAllDayPanelCollapsed", "isAllDayPanelVisible", "isRenderDateHeader", "isRenderGroupPanel", "isRenderHeaderEmptyCell", "isRenderTimePanel", "isStandaloneAllDayPanel", "isUseMonthDateTable", "isUseTimelineHeader", "isWorkSpaceWithOddCells", "leftVirtualCellWidth", "onScroll", "resourceCellComponent", "resourceCellRender", "resourceCellTemplate", "rightVirtualCellWidth", "scrollingDirection", "tablesWidth", "timeCellComponent", "timeCellRender", "timeCellTemplate", "timePanelData", "timePanelRef", "topVirtualRowHeight", "viewData", "widgetElementRef", "width"];
import { Widget } from "../../../common/widget";
import { Scrollable } from "../../../scroll_view/scrollable";
import { GroupPanel } from "./group_panel/group_panel";
import { AllDayPanelLayout } from "./date_table/all_day_panel/layout";
import { HeaderPanelEmptyCell } from "./header_panel_empty_cell";
import { MainLayoutProps } from "./main_layout_props";
import { TimePanelTableLayout } from "./time_panel/layout";
import { MonthDateTableLayout } from "../month/date_table/layout";
import { DateTableLayoutBase } from "./date_table/layout";
import { TimelineHeaderPanelLayout } from "../timeline/header_panel/layout";
import { HeaderPanelLayout } from "./header_panel/layout";
export var viewFunction = _ref => {
  var {
    dateTableScrollableRef,
    props: {
      allDayAppointments,
      allDayPanelRef,
      appointments,
      className,
      dataCellTemplate,
      dateCellTemplate,
      dateHeaderData,
      dateTableRef,
      groupByDate,
      groupOrientation,
      groupPanelClassName,
      groupPanelData,
      groupPanelHeight,
      groupPanelRef,
      groups,
      headerEmptyCellWidth,
      isRenderDateHeader,
      isRenderGroupPanel,
      isRenderHeaderEmptyCell,
      isRenderTimePanel,
      isStandaloneAllDayPanel,
      isUseMonthDateTable,
      isUseTimelineHeader,
      resourceCellTemplate,
      scrollingDirection,
      timeCellTemplate,
      timePanelData,
      timePanelRef,
      viewData,
      widgetElementRef
    }
  } = _ref;
  var DateTable = isUseMonthDateTable ? MonthDateTableLayout : DateTableLayoutBase;
  var HeaderPanel = isUseTimelineHeader ? TimelineHeaderPanelLayout : HeaderPanelLayout;
  return React.createElement(Widget, {
    className: className,
    rootElementRef: widgetElementRef
  }, React.createElement("div", {
    className: "dx-scheduler-header-panel-container"
  }, isRenderHeaderEmptyCell && React.createElement(HeaderPanelEmptyCell, {
    width: headerEmptyCellWidth,
    isRenderAllDayTitle: isStandaloneAllDayPanel
  }), React.createElement("div", {
    className: "dx-scheduler-header-tables-container"
  }, React.createElement("table", {
    className: "dx-scheduler-header-panel"
  }, React.createElement(HeaderPanel, {
    dateHeaderData: dateHeaderData,
    groupPanelData: groupPanelData,
    timeCellTemplate: timeCellTemplate,
    dateCellTemplate: dateCellTemplate,
    isRenderDateHeader: isRenderDateHeader,
    groupOrientation: groupOrientation,
    groupByDate: groupByDate,
    groups: groups,
    resourceCellTemplate: resourceCellTemplate
  })), isStandaloneAllDayPanel && React.createElement(AllDayPanelLayout, {
    viewData: viewData,
    dataCellTemplate: dataCellTemplate,
    tableRef: allDayPanelRef,
    allDayAppointments: allDayAppointments
  }))), React.createElement(Scrollable, {
    ref: dateTableScrollableRef,
    useKeyboard: false,
    bounceEnabled: false,
    direction: scrollingDirection,
    className: "dx-scheduler-date-table-scrollable"
  }, React.createElement("div", {
    className: "dx-scheduler-date-table-scrollable-content"
  }, isRenderGroupPanel && React.createElement(GroupPanel, {
    groupPanelData: groupPanelData,
    className: groupPanelClassName,
    groupOrientation: groupOrientation,
    groupByDate: groupByDate,
    groups: groups,
    resourceCellTemplate: resourceCellTemplate,
    height: groupPanelHeight,
    elementRef: groupPanelRef
  }), isRenderTimePanel && React.createElement(TimePanelTableLayout, {
    timePanelData: timePanelData,
    timeCellTemplate: timeCellTemplate,
    groupOrientation: groupOrientation,
    tableRef: timePanelRef
  }), React.createElement("div", {
    className: "dx-scheduler-date-table-container"
  }, React.createElement(DateTable, {
    tableRef: dateTableRef,
    viewData: viewData,
    groupOrientation: groupOrientation,
    dataCellTemplate: dataCellTemplate
  }), appointments))));
};
import * as React from "react";
import { useCallback, useRef, useImperativeHandle, forwardRef } from "react";
import { getTemplate } from "@devextreme/runtime/react";
var OrdinaryLayout = forwardRef(function ordinaryLayout(props, ref) {
  var __dateTableScrollableRef = useRef(null);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __getScrollableWidth = useCallback(function __getScrollableWidth() {
    return __dateTableScrollableRef.current.container().getBoundingClientRect().width;
  }, []);

  useImperativeHandle(ref, () => ({
    getScrollableWidth: __getScrollableWidth
  }), [__getScrollableWidth]);
  return viewFunction({
    props: _extends({}, props, {
      headerPanelTemplate: getTemplate(props.headerPanelTemplate, props.headerPanelRender, props.headerPanelComponent),
      dateTableTemplate: getTemplate(props.dateTableTemplate, props.dateTableRender, props.dateTableComponent),
      resourceCellTemplate: getTemplate(props.resourceCellTemplate, props.resourceCellRender, props.resourceCellComponent),
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent),
      dateCellTemplate: getTemplate(props.dateCellTemplate, props.dateCellRender, props.dateCellComponent),
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    dateTableScrollableRef: __dateTableScrollableRef,
    restAttributes: __restAttributes()
  });
});
export { OrdinaryLayout };
export default OrdinaryLayout;
OrdinaryLayout.defaultProps = MainLayoutProps;