import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "className", "isHeaderRow", "leftVirtualCellCount", "leftVirtualCellWidth", "rightVirtualCellCount", "rightVirtualCellWidth", "styles"];
import { VirtualCell } from "./virtual_cell";
export var viewFunction = _ref => {
  var {
    hasLeftVirtualCell,
    hasRightVirtualCell,
    props: {
      children,
      className,
      isHeaderRow,
      leftVirtualCellCount,
      leftVirtualCellWidth,
      rightVirtualCellCount,
      rightVirtualCellWidth,
      styles
    }
  } = _ref;
  return React.createElement("tr", {
    className: className,
    style: normalizeStyles(styles)
  }, hasLeftVirtualCell && React.createElement(VirtualCell, {
    width: leftVirtualCellWidth,
    colSpan: leftVirtualCellCount,
    isHeaderCell: isHeaderRow
  }), children, hasRightVirtualCell && React.createElement(VirtualCell, {
    width: rightVirtualCellWidth,
    colSpan: rightVirtualCellCount,
    isHeaderCell: isHeaderRow
  }));
};
export var RowProps = {
  className: "",
  leftVirtualCellWidth: 0,
  rightVirtualCellWidth: 0,
  isHeaderRow: false
};
import * as React from "react";
import { useCallback } from "react";
var NUMBER_STYLES = new Set(["animationIterationCount", "borderImageOutset", "borderImageSlice", "border-imageWidth", "boxFlex", "boxFlexGroup", "boxOrdinalGroup", "columnCount", "fillOpacity", "flex", "flexGrow", "flexNegative", "flexOrder", "flexPositive", "flexShrink", "floodOpacity", "fontWeight", "gridColumn", "gridRow", "lineClamp", "lineHeight", "opacity", "order", "orphans", "stopOpacity", "strokeDasharray", "strokeDashoffset", "strokeMiterlimit", "strokeOpacity", "strokeWidth", "tabSize", "widows", "zIndex", "zoom"]);

var isNumeric = value => {
  if (typeof value === "number") return true;
  return !isNaN(Number(value));
};

var getNumberStyleValue = (style, value) => {
  return NUMBER_STYLES.has(style) ? value : "".concat(value, "px");
};

var normalizeStyles = styles => {
  if (!(styles instanceof Object)) return undefined;
  return Object.entries(styles).reduce((result, _ref2) => {
    var [key, value] = _ref2;
    result[key] = isNumeric(value) ? getNumberStyleValue(key, value) : value;
    return result;
  }, {});
};

export function Row(props) {
  var __hasLeftVirtualCell = useCallback(function __hasLeftVirtualCell() {
    var {
      leftVirtualCellCount
    } = props;
    return !!leftVirtualCellCount;
  }, [props.leftVirtualCellCount]);

  var __hasRightVirtualCell = useCallback(function __hasRightVirtualCell() {
    var {
      rightVirtualCellCount
    } = props;
    return !!rightVirtualCellCount;
  }, [props.rightVirtualCellCount]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props),
    hasLeftVirtualCell: __hasLeftVirtualCell(),
    hasRightVirtualCell: __hasRightVirtualCell(),
    restAttributes: __restAttributes()
  });
}
Row.defaultProps = RowProps;