import { MutableRefObject } from "react";
export declare const viewFunction: ({ hasBottomVirtualRow, hasTopVirtualRow, props: { bottomVirtualRowHeight, children, className, leftVirtualCellCount, leftVirtualCellWidth, rightVirtualCellCount, rightVirtualCellWidth, tableRef, topVirtualRowHeight, virtualCellsCount, }, style, }: Table) => any;
export declare type TablePropsType = {
    className?: string;
    topVirtualRowHeight: number;
    bottomVirtualRowHeight: number;
    leftVirtualCellWidth: number;
    rightVirtualCellWidth: number;
    leftVirtualCellCount?: number;
    rightVirtualCellCount?: number;
    virtualCellsCount: number;
    height?: number;
    width?: number;
    children?: React.ReactNode;
    tableRef?: MutableRefObject<HTMLTableElement | null>;
};
export declare const TableProps: TablePropsType;
import * as React from "react";
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface Table {
    props: typeof TableProps & RestProps;
    elementRef: any;
    style: any;
    hasTopVirtualRow: boolean;
    hasBottomVirtualRow: boolean;
    restAttributes: RestProps;
}
export declare function Table(props: typeof TableProps & RestProps): any;
export declare namespace Table {
    var defaultProps: TablePropsType;
}
export default Table;
