import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["allDay", "ariaLabel", "children", "className", "contentTemplateProps", "endDate", "groupIndex", "groups", "index", "isFirstGroupCell", "isLastGroupCell", "startDate", "text", "timeCellComponent", "timeCellRender", "timeCellTemplate"];
import { CellBase as Cell, CellBaseProps } from "../cell";
export var viewFunction = _ref => {
  var {
    props: {
      className,
      isFirstGroupCell,
      isLastGroupCell,
      text,
      timeCellTemplate: TimeCellTemplate
    },
    timeCellTemplateProps
  } = _ref;
  return React.createElement(Cell, {
    isFirstGroupCell: isFirstGroupCell,
    isLastGroupCell: isLastGroupCell,
    className: "dx-scheduler-time-panel-cell dx-scheduler-cell-sizes-vertical ".concat(className)
  }, !TimeCellTemplate && React.createElement("div", null, text), !!TimeCellTemplate && TimeCellTemplate({
    index: timeCellTemplateProps.index,
    data: timeCellTemplateProps.data
  }));
};
export var TimePanelCellProps = CellBaseProps;
import * as React from "react";
import { useCallback, useMemo } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function TimePanelCell(props) {
  var __timeCellTemplateProps = useMemo(function __timeCellTemplateProps() {
    var {
      groupIndex,
      groups,
      index,
      startDate,
      text
    } = props;
    return {
      data: {
        date: startDate,
        groups,
        groupIndex,
        text
      },
      index
    };
  }, [props.groupIndex, props.groups, props.index, props.startDate, props.text]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent)
    }),
    timeCellTemplateProps: __timeCellTemplateProps,
    restAttributes: __restAttributes()
  });
}
TimePanelCell.defaultProps = TimePanelCellProps;