import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["groupOrientation", "tableRef", "timeCellComponent", "timeCellRender", "timeCellTemplate", "timePanelData"];
import { Row } from "../row";
import { TimePanelCell as Cell } from "./cell";
import { CellBase } from "../cell";
import { Table } from "../table";
import { AllDayPanelTitle } from "../date_table/all_day_panel/title";
export var viewFunction = _ref => {
  var {
    bottomVirtualRowHeight,
    props: {
      tableRef,
      timeCellTemplate,
      timePanelData
    },
    restAttributes,
    topVirtualRowHeight
  } = _ref;
  return React.createElement(Table, _extends({}, restAttributes, {
    topVirtualRowHeight: topVirtualRowHeight,
    bottomVirtualRowHeight: bottomVirtualRowHeight,
    virtualCellsCount: 1,
    className: "dx-scheduler-time-panel",
    tableRef: tableRef
  }), timePanelData.groupedData.map(_ref2 => {
    var {
      dateTable,
      groupIndex,
      isGroupedAllDayPanel,
      key: fragmentKey
    } = _ref2;
    return React.createElement(React.Fragment, {
      key: fragmentKey
    }, isGroupedAllDayPanel && React.createElement(Row, null, React.createElement(CellBase, {
      className: "dx-scheduler-time-panel-title-cell"
    }, React.createElement(AllDayPanelTitle, null))), dateTable.map(cell => {
      var {
        groups,
        index: cellIndex,
        isFirstGroupCell,
        isLastGroupCell,
        key,
        startDate,
        text
      } = cell;
      return React.createElement(Row, {
        className: "dx-scheduler-time-panel-row",
        key: key
      }, React.createElement(Cell, {
        startDate: startDate,
        text: text,
        groups: groups,
        groupIndex: groupIndex,
        isFirstGroupCell: isFirstGroupCell,
        isLastGroupCell: isLastGroupCell,
        index: cellIndex,
        timeCellTemplate: timeCellTemplate
      }));
    }));
  }));
};
export var TimePanelLayoutProps = {
  get timePanelData() {
    return {
      groupedData: [],
      leftVirtualCellCount: 0,
      rightVirtualCellCount: 0,
      topVirtualRowCount: 0,
      bottomVirtualRowCount: 0
    };
  }

};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function TimePanelTableLayout(props) {
  var __topVirtualRowHeight = useCallback(function __topVirtualRowHeight() {
    var _props$timePanelData$;

    return (_props$timePanelData$ = props.timePanelData.topVirtualRowHeight) !== null && _props$timePanelData$ !== void 0 ? _props$timePanelData$ : 0;
  }, [props.timePanelData]);

  var __bottomVirtualRowHeight = useCallback(function __bottomVirtualRowHeight() {
    var _props$timePanelData$2;

    return (_props$timePanelData$2 = props.timePanelData.bottomVirtualRowHeight) !== null && _props$timePanelData$2 !== void 0 ? _props$timePanelData$2 : 0;
  }, [props.timePanelData]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent)
    }),
    topVirtualRowHeight: __topVirtualRowHeight(),
    bottomVirtualRowHeight: __bottomVirtualRowHeight(),
    restAttributes: __restAttributes()
  });
}
TimePanelTableLayout.defaultProps = TimePanelLayoutProps;