import type { dxSchedulerScrolling } from 'devextreme/ui/scheduler';
import { GroupOrientation } from "../../types";
import { GetDateForHeaderText } from "../../view_model/to_test/views/types";
import { Group, TableWidthWorkSpaceConfig, ViewCellData, ViewDataProviderType, VirtualScrollingOptions } from "../types";
export declare const DATE_TABLE_MIN_CELL_WIDTH = 75;
export declare const getTotalRowCount: (rowCount: number, groupOrientation: GroupOrientation, groups: Group[], isAllDayPanelVisible: boolean) => number;
export declare const getTotalCellCount: (cellCount: number, groupOrientation: GroupOrientation, groups: Group[]) => number;
export declare const getRowCountWithAllDayRow: (rowCount: number, isAllDayPanelVisible: boolean) => number;
export declare const getHiddenInterval: (hoursInterval: number, cellCountInDay: number) => number;
export declare const createCellElementMetaData: (tableRect: DOMRect, cellRect: DOMRect) => DOMRect;
export declare const getDateForHeaderText: GetDateForHeaderText;
export declare const getDateTableWidth: (scrollableWidth: number, dateTable: HTMLTableElement, viewDataProvider: ViewDataProviderType, workSpaceConfig: TableWidthWorkSpaceConfig) => number;
export declare const createVirtualScrollingOptions: (options: {
    cellHeight: number;
    cellWidth: number;
    schedulerHeight?: number | string | (() => number | string);
    schedulerWidth?: number | string | (() => number | string);
    viewHeight: number;
    viewWidth: number;
    scrolling: dxSchedulerScrolling;
    scrollableWidth: number;
    groups: Group[];
    isVerticalGrouping: boolean;
    completeRowCount: number;
    completeColumnCount: number;
    windowHeight: number;
    windowWidth: number;
    rtlEnabled: boolean;
}) => VirtualScrollingOptions;
export declare const getCellIndices: (cell: HTMLElement) => {
    columnIndex: number;
    rowIndex: number;
};
export declare const compareCellsByDateAndIndex: (daysAndIndexes: {
    date: number;
    index: number;
    firstDate: number;
    firstIndex: number;
    lastDate: number;
    lastIndex: number;
}) => boolean;
export declare const getSelectedCells: (viewDataProvider: ViewDataProviderType, firstSelectedCell: ViewCellData, lastSelectedCell: ViewCellData, isLastSelectedCellAllDay: boolean) => ViewCellData[];
export declare const isCellAllDay: (cell: HTMLElement) => boolean;
