import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["cellsCount", "children", "className", "height", "isHeaderRow", "leftVirtualCellCount", "leftVirtualCellWidth", "rightVirtualCellCount", "rightVirtualCellWidth", "styles"];
import { addHeightToStyle } from "../utils";
import { RowProps, Row } from "./row";
import { VirtualCell } from "./virtual_cell";
export var viewFunction = _ref => {
  var {
    classes,
    props: {
      leftVirtualCellCount,
      leftVirtualCellWidth,
      rightVirtualCellCount,
      rightVirtualCellWidth
    },
    style,
    virtualCells
  } = _ref;
  return React.createElement(Row, {
    styles: style,
    className: classes,
    leftVirtualCellWidth: leftVirtualCellWidth,
    rightVirtualCellWidth: rightVirtualCellWidth,
    leftVirtualCellCount: leftVirtualCellCount,
    rightVirtualCellCount: rightVirtualCellCount
  }, virtualCells.map((_, index) => React.createElement(VirtualCell, {
    key: index.toString()
  })));
};
export var VirtualRowProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(RowProps), Object.getOwnPropertyDescriptors({
  leftVirtualCellWidth: 0,
  rightVirtualCellWidth: 0,
  cellsCount: 1
})));
import * as React from "react";
import { useCallback, useMemo } from "react";
export function VirtualRow(props) {
  var __classes = useCallback(function __classes() {
    var {
      className
    } = props;
    return "dx-scheduler-virtual-row ".concat(className);
  }, [props.className]);

  var __virtualCells = useMemo(function __virtualCells() {
    var {
      cellsCount
    } = props;
    return [...Array(cellsCount)];
  }, [props.cellsCount]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __style = useCallback(function __style() {
    var {
      height
    } = props;

    var {
      style
    } = __restAttributes();

    return addHeightToStyle(height, style);
  }, [props.height, __restAttributes]);

  return viewFunction({
    props: _extends({}, props),
    style: __style(),
    classes: __classes(),
    virtualCells: __virtualCells,
    restAttributes: __restAttributes()
  });
}
VirtualRow.defaultProps = VirtualRowProps;