import { CellsSelectionState, CorrectedVirtualScrollingState, DateHeaderCellData, DateHeaderData, DateHeaderDataGeneratorType, GroupedViewData, GroupPanelData, TimePanelData, TimePanelDataGeneratorType, ViewCellData, ViewDataGeneratorType, ViewDataMap, ViewDataProviderOptions, ViewDataProviderType, VirtualScrollingDispatcherType, VirtualScrollingState, WorkSpaceGenerationOptions } from "../types";
import { ViewRenderConfig, WorkSpaceProps } from "../props";
import { GroupOrientation } from "../../types";
import { ScrollEventArgs, ScrollOffset } from "../../../scroll_view/common/types";
import { ConfigContextValue } from "../../../../common/config_context";
interface VirtualScrollingSizes {
    cellHeight: number;
    cellWidth: number;
    viewWidth: number;
    viewHeight: number;
    scrollableWidth: number;
    windowHeight: number;
    windowWidth: number;
}
interface VirtualScrollingData {
    sizes: VirtualScrollingSizes;
    state: VirtualScrollingState;
}
export declare const prepareGenerationOptions: (workSpaceProps: WorkSpaceGenerationOptions, renderConfig: ViewRenderConfig, isAllDayPanelVisible: boolean, virtualStartIndices: CorrectedVirtualScrollingState) => ViewDataProviderOptions;
export declare const viewFunction: ({ allDayPanelRef, classes, dateHeaderData, dateTableRef, groupOrientation, groupPanelData, groupPanelHeight, groupPanelRef, headerEmptyCellWidth, isAllDayPanelVisible, isGroupedByDate, isRenderHeaderEmptyCell, isStandaloneAllDayPanel, isVerticalGrouping, layoutRef, onScrollableScroll, props: { allDayAppointments, allDayPanelExpanded, appointments, dataCellTemplate, dateCellTemplate, groups, intervalCount, resourceCellTemplate, timeCellTemplate, }, renderConfig: { groupPanelClassName, isCreateCrossScrolling, isRenderDateHeader, isRenderTimePanel, isUseMonthDateTable, isUseTimelineHeader, scrollingDirection, }, tablesWidth, timePanelData, timePanelRef, viewData, widgetElementRef, }: WorkSpace) => any;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface WorkSpace {
    props: typeof WorkSpaceProps & RestProps;
    groupPanelHeight: number | undefined;
    headerEmptyCellWidth: number | undefined;
    tablesWidth: number | undefined;
    virtualScrolling: VirtualScrollingDispatcherType;
    virtualScrollingData?: VirtualScrollingData;
    cellsSelectionState: CellsSelectionState | null;
    isPointerDown: boolean;
    dateTableRef: any;
    allDayPanelRef: any;
    timePanelRef: any;
    groupPanelRef: any;
    layoutRef: any;
    widgetElementRef: any;
    config?: ConfigContextValue;
    renderConfig: ViewRenderConfig;
    groupOrientation: GroupOrientation;
    isVerticalGrouping: boolean;
    isHorizontalGrouping: boolean;
    isGroupedByDate: boolean;
    isAllDayPanelVisible: boolean;
    viewDataGenerator: ViewDataGeneratorType;
    dateHeaderDataGenerator: DateHeaderDataGeneratorType;
    timePanelDataGenerator: TimePanelDataGeneratorType;
    startViewDate: Date;
    completeViewDataMap: ViewCellData[][];
    correctedVirtualScrollingState: CorrectedVirtualScrollingState;
    viewDataMap: ViewDataMap;
    viewDataMapWithSelection: ViewDataMap;
    viewData: GroupedViewData;
    completeDateHeaderData: DateHeaderCellData[][];
    dateHeaderData: DateHeaderData;
    completeTimePanelData: ViewCellData[] | undefined;
    timePanelData: TimePanelData | undefined;
    viewDataProvider: ViewDataProviderType;
    groupPanelData: GroupPanelData;
    isRenderHeaderEmptyCell: boolean;
    isWorkSpaceWithOddCells: boolean;
    classes: string;
    isStandaloneAllDayPanel: boolean;
    isCalculateTablesWidth: boolean;
    createDateTableElementsMeta: (totalCellCount: number) => DOMRect[][];
    createAllDayPanelElementsMeta: () => DOMRect[];
    onWindowScroll: () => void;
    onScrollableScroll: (event: ScrollEventArgs) => void;
    onScroll: (scrollOffset: ScrollOffset) => void;
    onPointerDown: (e: MouseEvent | TouchEvent) => void;
    onPointerUp: (e: MouseEvent | TouchEvent) => void;
    onPointerMove: (e: Event) => void;
    restAttributes: RestProps;
}
export declare function WorkSpace(props: typeof WorkSpaceProps & RestProps): any;
export declare namespace WorkSpace {
    var defaultProps: import("../props").WorkSpacePropsType;
}
export default WorkSpace;
