import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["allDay", "ariaLabel", "children", "className", "contentTemplateProps", "dataCellComponent", "dataCellRender", "dataCellTemplate", "endDate", "firstDayOfMonth", "groupIndex", "groups", "index", "isFirstGroupCell", "isFocused", "isLastGroupCell", "isSelected", "otherMonth", "startDate", "text", "today"];
import { combineClasses } from "../../../../../utils/combine_classes";
import { DateTableCellBase, DateTableCellBaseProps } from "../../base/date_table/cell";
export var viewFunction = _ref => {
  var {
    classes,
    contentTemplateProps,
    props: {
      dataCellTemplate,
      endDate,
      groupIndex,
      groups,
      index,
      isFirstGroupCell,
      isFocused,
      isLastGroupCell,
      isSelected,
      startDate,
      text
    }
  } = _ref;
  return React.createElement(DateTableCellBase, {
    className: classes,
    dataCellTemplate: dataCellTemplate,
    startDate: startDate,
    endDate: endDate,
    text: text,
    groups: groups,
    groupIndex: groupIndex,
    index: index,
    isFirstGroupCell: isFirstGroupCell,
    isLastGroupCell: isLastGroupCell,
    isSelected: isSelected,
    isFocused: isFocused,
    contentTemplateProps: contentTemplateProps
  }, React.createElement("div", {
    className: "dx-scheduler-date-table-cell-text"
  }, text));
};
import * as React from "react";
import { useCallback, useMemo } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function MonthDateTableCell(props) {
  var __classes = useCallback(function __classes() {
    var {
      className,
      firstDayOfMonth,
      otherMonth,
      today
    } = props;
    return combineClasses({
      "dx-scheduler-date-table-other-month": !!otherMonth,
      "dx-scheduler-date-table-current-date": !!today,
      "dx-scheduler-date-table-first-of-month": !!firstDayOfMonth,
      [className]: !!className
    });
  }, [props.className, props.firstDayOfMonth, props.otherMonth, props.today]);

  var __contentTemplateProps = useMemo(function __contentTemplateProps() {
    var {
      index,
      text
    } = props;
    return {
      data: {
        text
      },
      index
    };
  }, [props.index, props.text]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dataCellTemplate: getTemplate(props.dataCellTemplate, props.dataCellRender, props.dataCellComponent)
    }),
    classes: __classes(),
    contentTemplateProps: __contentTemplateProps,
    restAttributes: __restAttributes()
  });
}
MonthDateTableCell.defaultProps = DateTableCellBaseProps;