import _extends from "@babel/runtime/helpers/esm/extends";
import dateUtils from 'devextreme/core/utils/date';
import { BaseWidgetProps } from "../../common/base_props";
var DEFAULT_GROUPS = [];
export var WorkSpaceProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
  intervalCount: 1,
  groups: DEFAULT_GROUPS,
  groupByDate: false,
  crossScrollingEnabled: false,
  startDayHour: 0,
  endDayHour: 24,
  firstDayOfWeek: 0,
  hoursInterval: 0.5,
  showAllDayPanel: false,
  allDayPanelExpanded: false,
  allowMultipleCellSelection: true,

  get indicatorTime() {
    return new Date();
  },

  get indicatorUpdateInterval() {
    return 5 * dateUtils.dateToMilliseconds("minute");
  },

  shadeUntilCurrentTime: true,

  get selectedCellData() {
    return [];
  },

  get scrolling() {
    return {
      mode: "standard"
    };
  },

  cellDuration: 30,
  showCurrentTimeIndicator: true,
  type: "week"
})));
export var CurrentViewConfigType = {
  intervalCount: WorkSpaceProps.intervalCount,
  groupByDate: WorkSpaceProps.groupByDate,
  crossScrollingEnabled: WorkSpaceProps.crossScrollingEnabled,
  startDayHour: WorkSpaceProps.startDayHour,
  endDayHour: WorkSpaceProps.endDayHour,
  firstDayOfWeek: WorkSpaceProps.firstDayOfWeek,
  hoursInterval: WorkSpaceProps.hoursInterval,
  showAllDayPanel: WorkSpaceProps.showAllDayPanel,
  allDayPanelExpanded: WorkSpaceProps.allDayPanelExpanded,
  allowMultipleCellSelection: WorkSpaceProps.allowMultipleCellSelection,
  indicatorUpdateInterval: WorkSpaceProps.indicatorUpdateInterval,
  shadeUntilCurrentTime: WorkSpaceProps.shadeUntilCurrentTime,
  scrolling: WorkSpaceProps.scrolling,
  cellDuration: WorkSpaceProps.cellDuration,
  showCurrentTimeIndicator: WorkSpaceProps.showCurrentTimeIndicator,
  type: WorkSpaceProps.type,
  focusStateEnabled: WorkSpaceProps.focusStateEnabled,
  tabIndex: WorkSpaceProps.tabIndex
};