import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["dateCellComponent", "dateCellRender", "dateCellTemplate", "dateHeaderData", "groupByDate", "groupOrientation", "groups", "timeCellComponent", "timeCellRender", "timeCellTemplate"];
import { Row } from "../../../base/row";
import { isHorizontalGroupingApplied } from "../../../utils";
import { DateHeaderCell } from "../../../base/header_panel/date_header/cell";
import { DateHeaderLayoutProps } from "../../../base/header_panel/date_header/layout";
import getThemeType from "../../../../../../utils/getThemeType";
var {
  isMaterial
} = getThemeType();
export var viewFunction = _ref => {
  var {
    isHorizontalGrouping,
    props: {
      dateCellTemplate,
      dateHeaderData,
      timeCellTemplate
    }
  } = _ref;
  var {
    dataMap,
    isMonthDateHeader,
    leftVirtualCellCount,
    leftVirtualCellWidth,
    rightVirtualCellCount,
    rightVirtualCellWidth,
    weekDayLeftVirtualCellCount,
    weekDayLeftVirtualCellWidth,
    weekDayRightVirtualCellCount,
    weekDayRightVirtualCellWidth
  } = dateHeaderData;
  return React.createElement(React.Fragment, null, dataMap.map((dateHeaderRow, rowIndex) => {
    var rowsCount = dataMap.length;
    var isTimeCellTemplate = rowsCount - 1 === rowIndex;
    var isWeekDayRow = rowsCount > 1 && rowIndex === 0;
    var splitText = isMaterial && (isMonthDateHeader || isWeekDayRow);
    var validLeftVirtualCellCount = leftVirtualCellCount;
    var validRightVirtualCellCount = rightVirtualCellCount;
    var validRightVirtualCellWidth = rightVirtualCellWidth;
    var validLeftVirtualCellWidth = leftVirtualCellWidth;

    if (isWeekDayRow) {
      validLeftVirtualCellCount = weekDayLeftVirtualCellCount;
      validRightVirtualCellCount = weekDayRightVirtualCellCount;
      validRightVirtualCellWidth = weekDayRightVirtualCellWidth;
      validLeftVirtualCellWidth = weekDayLeftVirtualCellWidth;
    }

    return React.createElement(Row, {
      className: "dx-scheduler-header-row",
      leftVirtualCellWidth: validLeftVirtualCellWidth,
      leftVirtualCellCount: validLeftVirtualCellCount,
      rightVirtualCellWidth: validRightVirtualCellWidth,
      rightVirtualCellCount: validRightVirtualCellCount,
      key: rowIndex.toString()
    }, dateHeaderRow.map(_ref2 => {
      var {
        colSpan,
        endDate,
        groupIndex,
        groups: cellGroups,
        index,
        isFirstGroupCell,
        isLastGroupCell,
        key,
        startDate,
        text,
        today
      } = _ref2;
      return React.createElement(DateHeaderCell, {
        startDate: startDate,
        endDate: endDate,
        groups: isHorizontalGrouping ? cellGroups : undefined,
        groupIndex: isHorizontalGrouping ? groupIndex : undefined,
        today: today,
        index: index,
        text: text,
        isFirstGroupCell: isFirstGroupCell,
        isLastGroupCell: isLastGroupCell,
        isWeekDayCell: isWeekDayRow,
        key: key,
        colSpan: colSpan,
        splitText: splitText,
        dateCellTemplate: dateCellTemplate,
        timeCellTemplate: timeCellTemplate,
        isTimeCellTemplate: isTimeCellTemplate
      });
    }));
  }));
};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function TimelineDateHeaderLayout(props) {
  var __isHorizontalGrouping = useCallback(function __isHorizontalGrouping() {
    var {
      groupByDate,
      groupOrientation,
      groups
    } = props;
    return isHorizontalGroupingApplied(groups, groupOrientation) && !groupByDate;
  }, [props.groupByDate, props.groupOrientation, props.groups]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dateCellTemplate: getTemplate(props.dateCellTemplate, props.dateCellRender, props.dateCellComponent),
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent)
    }),
    isHorizontalGrouping: __isHorizontalGrouping(),
    restAttributes: __restAttributes()
  });
}
TimelineDateHeaderLayout.defaultProps = DateHeaderLayoutProps;