import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["className", "dateCellComponent", "dateCellRender", "dateCellTemplate", "dateHeaderComponent", "dateHeaderData", "dateHeaderRender", "dateHeaderTemplate", "elementRef", "groupByDate", "groupOrientation", "groupPanelData", "groups", "height", "isRenderDateHeader", "resourceCellComponent", "resourceCellRender", "resourceCellTemplate", "timeCellComponent", "timeCellRender", "timeCellTemplate"];
import { HeaderPanelLayout, HeaderPanelLayoutProps } from "../../base/header_panel/layout";
import { TimelineDateHeaderLayout } from "./date_header/layout";
export var viewFunction = _ref => {
  var {
    props: {
      dateCellTemplate,
      dateHeaderData,
      groupByDate,
      groupOrientation,
      groupPanelData,
      groups,
      isRenderDateHeader,
      resourceCellTemplate,
      timeCellTemplate
    }
  } = _ref;
  return React.createElement(HeaderPanelLayout, {
    dateHeaderTemplate: TimelineDateHeaderLayout,
    dateHeaderData: dateHeaderData,
    groupPanelData: groupPanelData,
    groupByDate: groupByDate,
    groups: groups,
    groupOrientation: groupOrientation,
    isRenderDateHeader: isRenderDateHeader,
    resourceCellTemplate: resourceCellTemplate,
    dateCellTemplate: dateCellTemplate,
    timeCellTemplate: timeCellTemplate
  });
};
import * as React from "react";
import { useCallback } from "react";
import { getTemplate } from "@devextreme/runtime/react";
export function TimelineHeaderPanelLayout(props) {
  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props, {
      dateCellTemplate: getTemplate(props.dateCellTemplate, props.dateCellRender, props.dateCellComponent),
      timeCellTemplate: getTemplate(props.timeCellTemplate, props.timeCellRender, props.timeCellComponent),
      dateHeaderTemplate: getTemplate(props.dateHeaderTemplate, props.dateHeaderRender, props.dateHeaderComponent),
      resourceCellTemplate: getTemplate(props.resourceCellTemplate, props.resourceCellRender, props.resourceCellComponent)
    }),
    restAttributes: __restAttributes()
  });
}
TimelineHeaderPanelLayout.defaultProps = HeaderPanelLayoutProps;