import { EventCallback } from "../../common/event_callback";
import { ScrollableDirection, ScrollEventArgs, RefreshStrategy } from "./types";
import { ScrollViewLoadPanelProps } from "../internal/load_panel";
export declare type BaseScrollablePropsType = {
    loadPanelTemplate?: React.FunctionComponent<Partial<typeof ScrollViewLoadPanelProps>>;
    children?: React.ReactNode;
    aria?: Record<string, string>;
    addWidgetClass: boolean;
    disabled: boolean;
    height?: string | number | (() => string | number);
    width?: string | number | (() => string | number);
    visible: boolean;
    rtlEnabled?: boolean;
    classes?: string;
    direction: ScrollableDirection;
    bounceEnabled: any;
    scrollByContent: boolean;
    pullDownEnabled: boolean;
    reachBottomEnabled: boolean;
    forceGeneratePockets: boolean;
    needScrollViewContentWrapper: boolean;
    needRenderScrollbars: boolean;
    onScroll?: EventCallback<ScrollEventArgs>;
    onUpdated?: EventCallback<ScrollEventArgs>;
    onPullDown?: EventCallback<unknown>;
    onReachBottom?: EventCallback<unknown>;
    refreshStrategy: RefreshStrategy;
    pullingDownText: string;
    pulledDownText: string;
    refreshingText: string;
    reachBottomText: string;
    loadPanelRender?: React.FunctionComponent<Partial<typeof ScrollViewLoadPanelProps>>;
    loadPanelComponent?: React.JSXElementConstructor<Partial<typeof ScrollViewLoadPanelProps>>;
};
export declare const BaseScrollableProps: BaseScrollablePropsType;
