import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["refreshingText", "targetElement", "visible"];
import { isDefined } from 'devextreme/core/utils/type';
import messageLocalization from 'devextreme/localization/message';
import { LoadPanel } from "../../overlays/load_panel";
var SCROLLVIEW_LOADPANEL = "dx-scrollview-loadpanel";
export var viewFunction = viewModel => {
  var {
    position,
    props: {
      visible
    },
    refreshingText
  } = viewModel;
  return React.createElement(LoadPanel, {
    className: SCROLLVIEW_LOADPANEL,
    shading: false,
    delay: 400,
    message: refreshingText,
    position: position,
    visible: visible
  });
};
export var ScrollViewLoadPanelProps = {
  visible: false
};
import * as React from "react";
import { useCallback, useMemo } from "react";
export function ScrollViewLoadPanel(props) {
  var __refreshingText = useCallback(function __refreshingText() {
    var {
      refreshingText
    } = props;

    if (isDefined(refreshingText)) {
      return refreshingText;
    }

    return messageLocalization.format("dxScrollView-refreshingText");
  }, [props.refreshingText]);

  var __position = useMemo(function __position() {
    if (props.targetElement) {
      return {
        of: props.targetElement.current
      };
    }

    return undefined;
  }, [props.targetElement]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props),
    refreshingText: __refreshingText(),
    position: __position,
    restAttributes: __restAttributes()
  });
}
ScrollViewLoadPanel.defaultProps = ScrollViewLoadPanelProps;