import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["bottomPocketRef", "reachBottomText", "visible"];
import { LoadIndicator } from "../../../load_indicator";
import { SCROLLVIEW_BOTTOM_POCKET_CLASS, SCROLLVIEW_REACHBOTTOM_CLASS, SCROLLVIEW_REACHBOTTOM_INDICATOR_CLASS, SCROLLVIEW_REACHBOTTOM_TEXT_CLASS } from "../../common/consts";
import { current, isMaterial } from 'devextreme/ui/themes';
import { combineClasses } from "../../../../utils/combine_classes";
import messageLocalization from 'devextreme/localization/message';
export var viewFunction = viewModel => {
  var {
    props: {
      bottomPocketRef,
      reachBottomText
    },
    reachBottomClasses
  } = viewModel;
  return React.createElement("div", {
    ref: bottomPocketRef,
    className: SCROLLVIEW_BOTTOM_POCKET_CLASS
  }, React.createElement("div", {
    className: reachBottomClasses
  }, React.createElement("div", {
    className: SCROLLVIEW_REACHBOTTOM_INDICATOR_CLASS
  }, React.createElement(LoadIndicator, null)), React.createElement("div", {
    className: SCROLLVIEW_REACHBOTTOM_TEXT_CLASS
  }, React.createElement("div", null, reachBottomText))));
};
export var BottomPocketProps = {
  get reachBottomText() {
    return isMaterial(current()) ? "" : messageLocalization.format("dxScrollView-reachBottomText");
  },

  visible: true
};
import * as React from "react";
import { useCallback } from "react";
export function BottomPocket(props) {
  var __reachBottomClasses = useCallback(function __reachBottomClasses() {
    var {
      visible
    } = props;
    var classesMap = {
      [SCROLLVIEW_REACHBOTTOM_CLASS]: true,
      "dx-state-invisible": !visible
    };
    return combineClasses(classesMap);
  }, [props.visible]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  return viewFunction({
    props: _extends({}, props),
    reachBottomClasses: __reachBottomClasses(),
    restAttributes: __restAttributes()
  });
}
BottomPocket.defaultProps = BottomPocketProps;