import { MutableRefObject } from "react";
import { RefreshStrategy } from "../../common/types";
export declare const viewFunction: (viewModel: TopPocket) => any;
export declare type TopPocketPropsType = {
    topPocketRef?: MutableRefObject<HTMLDivElement | null>;
    refreshStrategy?: RefreshStrategy;
    pullingDownText: string;
    pulledDownText: string;
    refreshingText: string;
    pocketState: number;
    pullDownTranslateTop: number;
    pullDownIconAngle: number;
    pullDownOpacity: number;
    pocketTop: number;
    topPocketTranslateTop: number;
    visible: boolean;
};
export declare const TopPocketProps: TopPocketPropsType;
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface TopPocket {
    props: typeof TopPocketProps & RestProps;
    pullDownRef: any;
    releaseVisibleClass: string | undefined;
    readyVisibleClass: string | undefined;
    refreshVisibleClass: string | undefined;
    pullDownClasses: string;
    topPocketClasses: string;
    pullDownStyles: {
        [key: string]: string | number;
    } | undefined;
    topPocketStyles: {
        [key: string]: string | number;
    } | undefined;
    pullDownIconStyles: {
        [key: string]: string | number;
    };
    restAttributes: RestProps;
}
export declare function TopPocket(props: typeof TopPocketProps & RestProps): any;
export declare namespace TopPocket {
    var defaultProps: TopPocketPropsType;
}
export default TopPocket;
