import { ElementOffset, ScrollOffset } from "./common/types";
import { ScrollViewProps } from "./common/scrollview_props";
export declare const viewFunction: (viewModel: ScrollView) => any;
import * as React from "react";
export declare type ScrollViewRef = {
    release: (preventScrollBottom: boolean) => void;
    refresh: () => void;
    content: () => HTMLDivElement;
    container: () => HTMLDivElement;
    scrollBy: (distance: number | Partial<ScrollOffset>) => void;
    scrollTo: (targetLocation: number | Partial<ScrollOffset>) => void;
    scrollToElement: (element: HTMLElement, offset?: ElementOffset) => void;
    scrollHeight: () => number;
    scrollWidth: () => number;
    scrollOffset: () => ScrollOffset;
    scrollTop: () => number;
    scrollLeft: () => number;
    clientHeight: () => number;
    clientWidth: () => number;
    toggleLoading: (showOrHide: boolean) => void;
    startLoading: () => void;
    finishLoading: () => void;
    updateHandler: () => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface ScrollView {
    props: typeof ScrollViewProps & RestProps;
    scrollableRef: any;
    forceReachBottom?: boolean;
    reachBottomEnabled: boolean;
    restAttributes: RestProps;
}
declare const ScrollView: React.FC<import("./common/base_scrollable_props").BaseScrollablePropsType & {
    inertiaEnabled: boolean;
    useKeyboard: boolean;
    showScrollbar: import("./common/types").ScrollableShowScrollbar;
    scrollByThumb: any;
    refreshStrategy: import("./common/types").RefreshStrategy;
    onVisibilityChange?: (visible: boolean) => void;
    onStart?: (value: import("./common/types").ScrollEventArgs) => void;
    onEnd?: (value: import("./common/types").ScrollEventArgs) => void;
    onBounce?: (value: import("./common/types").ScrollEventArgs) => void;
    scrollLocationChange?: (value: import("./common/types").ScrollLocationChangeArgs) => void;
} & {
    useNative: any;
    useSimulatedScrollbar: any;
    refreshStrategy: import("./common/types").RefreshStrategy;
} & {
    pullDownEnabled: boolean;
    reachBottomEnabled: boolean;
} & RestProps & {
    ref?: React.Ref<ScrollViewRef>;
}> & {
    defaultProps: typeof ScrollViewProps;
};
export { ScrollView };
export default ScrollView;
