import { DxMouseEvent, ElementOffset, ScrollableDirection, ScrollOffset } from "./common/types";
import { ScrollableProps } from "./common/scrollable_props";
import { ConfigContextValue } from "../../common/config_context";
export declare const viewFunction: (viewModel: Scrollable) => any;
import * as React from "react";
export declare type ScrollableRef = {
    content: () => HTMLDivElement;
    container: () => HTMLDivElement;
    scrollTo: (targetLocation: number | Partial<ScrollOffset>) => void;
    scrollBy: (distance: number | Partial<ScrollOffset>) => void;
    updateHandler: () => void;
    release: () => void;
    refresh: () => void;
    scrollToElement: (element: HTMLElement, offset?: ElementOffset) => void;
    scrollHeight: () => number;
    scrollWidth: () => number;
    scrollOffset: () => ScrollOffset;
    scrollTop: () => number;
    scrollLeft: () => number;
    clientHeight: () => number;
    clientWidth: () => number;
    getScrollElementPosition: (targetElement: HTMLElement, direction: ScrollableDirection, offset?: ElementOffset) => number;
    startLoading: () => void;
    finishLoading: () => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface Scrollable {
    props: typeof ScrollableProps & RestProps;
    config?: ConfigContextValue;
    scrollableNativeRef: any;
    scrollableSimulatedRef: any;
    validate: (event: DxMouseEvent) => boolean;
    scrollableRef: any;
    rtlEnabled: boolean;
    isServerSide: boolean;
    restAttributes: RestProps;
}
declare const Scrollable: React.FC<import("./common/base_scrollable_props").BaseScrollablePropsType & {
    inertiaEnabled: boolean;
    useKeyboard: boolean;
    showScrollbar: import("./common/types").ScrollableShowScrollbar;
    scrollByThumb: any;
    refreshStrategy: import("./common/types").RefreshStrategy;
    onVisibilityChange?: (visible: boolean) => void;
    onStart?: (value: import("./common/types").ScrollEventArgs) => void;
    onEnd?: (value: import("./common/types").ScrollEventArgs) => void;
    onBounce?: (value: import("./common/types").ScrollEventArgs) => void;
    scrollLocationChange?: (value: import("./common/types").ScrollLocationChangeArgs) => void;
} & {
    useNative: any;
    useSimulatedScrollbar: any;
    refreshStrategy: import("./common/types").RefreshStrategy;
} & RestProps & {
    ref?: React.Ref<ScrollableRef>;
}> & {
    defaultProps: typeof ScrollableProps;
};
export { Scrollable };
export default Scrollable;
