import { DxMouseEvent } from "../common/types";
import { ConfigContextValue } from "../../../common/config_context";
export declare const THUMB_MIN_SIZE = 15;
export declare const viewFunction: (viewModel: Scrollbar) => any;
import { ScrollableShowScrollbar, ScrollLocationChangeArgs } from "../common/types";
import { EventCallback } from "../../common/event_callback";
export declare type ScrollbarPropsTypeType = {
    direction: "vertical" | "horizontal";
    containerSize: number;
    contentSize: number;
    visible: boolean;
    containerHasSizes: boolean;
    scrollLocation: number;
    minOffset: number;
    maxOffset: number;
    showScrollbar: ScrollableShowScrollbar;
    scrollByThumb: any;
    scrollLocationChange?: EventCallback<ScrollLocationChangeArgs>;
    bounceEnabled: any;
};
export declare const ScrollbarPropsType: ScrollbarPropsTypeType;
import * as React from "react";
export declare type ScrollbarRef = {
    isThumb: (element: EventTarget | null) => boolean;
    isScrollbar: (element: EventTarget | null) => boolean;
    setActiveState: () => void;
    moveToMouseLocation: (event: DxMouseEvent, offset: number) => void;
    moveTo: (location: number) => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface Scrollbar {
    props: typeof ScrollbarPropsType & RestProps;
    config?: ConfigContextValue;
    scrollbarRef: any;
    scrollRef: any;
    hovered: boolean;
    active: boolean;
    thumbRef: any;
    axis: "x" | "y";
    fullScrollProp: "scrollLeft" | "scrollTop";
    dimension: "width" | "height";
    isHorizontal: boolean;
    scrollSize: number;
    containerToContentRatio: number;
    scrollRatio: number;
    scrollbarClasses: string;
    thumbStyles: {
        [key: string]: string | number;
    };
    thumbTransform: string;
    thumbClasses: string;
    hidden: boolean;
    isThumbVisible: boolean;
    isExpandable: boolean;
    isHoverMode: boolean;
    isAlwaysMode: boolean;
    isNeverMode: boolean;
    restAttributes: RestProps;
}
declare const Scrollbar: React.FC<ScrollbarPropsTypeType & RestProps & {
    ref?: React.Ref<ScrollbarRef>;
}> & {
    defaultProps: typeof ScrollbarPropsType;
};
export { Scrollbar };
export default Scrollbar;
