import 'devextreme/events/gesture/emitter.gesture.scroll';
import { ScrollEventArgs, ScrollOffset, ScrollableDirection, DxMouseEvent, DxMouseWheelEvent } from "../common/types";
import { ScrollableNativeProps } from "../common/native_strategy_props";
export declare const viewFunction: (viewModel: ScrollableNative) => any;
import * as React from "react";
export declare type ScrollableNativeRef = {
    content: () => HTMLDivElement;
    container: () => HTMLDivElement;
    refresh: () => void;
    release: () => void;
    scrollHeight: () => number;
    scrollWidth: () => number;
    scrollOffset: () => ScrollOffset;
    scrollTop: () => number;
    scrollLeft: () => number;
    clientHeight: () => number;
    clientWidth: () => number;
    validate: (event: DxMouseEvent) => boolean;
    moveIsAllowed: (event: DxMouseEvent | DxMouseWheelEvent) => boolean;
    updateHandler: () => void;
    scrollByLocation: (location: ScrollOffset) => void;
};
declare type RestProps = {
    className?: string;
    style?: {
        [name: string]: any;
    };
    key?: any;
    ref?: any;
};
interface ScrollableNative {
    props: typeof ScrollableNativeProps & RestProps;
    scrollableRef: any;
    topPocketRef: any;
    bottomPocketRef: any;
    wrapperRef: any;
    contentRef: any;
    scrollViewContentRef: any;
    containerRef: any;
    vScrollbarRef: any;
    hScrollbarRef: any;
    containerClientWidth: number;
    containerClientHeight: number;
    contentClientWidth: number;
    contentClientHeight: number;
    contentScrollWidth: number;
    contentScrollHeight: number;
    topPocketHeight: number;
    bottomPocketHeight: number;
    scrolling: boolean;
    topPocketState: any;
    isLoadPanelVisible: boolean;
    pullDownTranslateTop: number;
    pullDownIconAngle: number;
    pullDownOpacity: number;
    contentTranslateTop: number;
    vScrollLocation: number;
    hScrollLocation: number;
    clearReleaseTimer: () => void;
    onRelease: () => void;
    onUpdated: () => void;
    startLoading: () => void;
    finishLoading: () => void;
    setPocketState: (newState: number) => void;
    handleScroll: (event: DxMouseEvent) => void;
    handlePocketState: () => void;
    pullDownReady: () => void;
    onReachBottom: () => void;
    onPullDown: () => void;
    stateReleased: () => void;
    getEventArgs: () => ScrollEventArgs;
    lock: () => void;
    unlock: () => void;
    fullScrollInactiveProp: "scrollLeft" | "scrollTop";
    updateElementDimensions: () => void;
    setContainerDimensions: (containerEl: HTMLDivElement) => void;
    setContentDimensions: (contentEl: HTMLDivElement) => void;
    syncScrollbarsWithContent: () => void;
    getInitEventData: () => {
        getDirection: () => ScrollableDirection | undefined;
        validate: (event: DxMouseEvent) => boolean;
        isNative: boolean;
        scrollTarget: HTMLDivElement | null;
    };
    handleInit: (event: DxMouseEvent) => void;
    handleMove: (e: DxMouseEvent) => void;
    handleEnd: () => void;
    handleStop: () => void;
    pullDownComplete: () => void;
    clearRefreshTimer: () => void;
    pullDownRefreshing: () => void;
    movePullDown: () => void;
    getPullDownHeight: () => number;
    getPullDownStartPosition: () => number;
    complete: () => void;
    releaseState: () => void;
    isSwipeDownStrategy: boolean;
    isPullDownStrategy: boolean;
    isSwipeDown: () => boolean;
    pulledDown: () => boolean;
    isReachBottom: () => boolean;
    tryGetAllowedDirection: () => ScrollableDirection | undefined;
    isLocked: () => boolean;
    isScrollingOutOfBound: (event: DxMouseWheelEvent) => boolean;
    cssClasses: string;
    direction: {
        isVertical: boolean;
        isHorizontal: boolean;
    };
    pullDownEnabled: boolean;
    contentStyles: {
        transform: string;
    } | undefined;
    contentHeight: number;
    contentWidth: number;
    hScrollOffsetMax: number;
    vScrollOffsetMax: number;
    restAttributes: RestProps;
}
declare const ScrollableNative: React.FC<import("../common/base_scrollable_props").BaseScrollablePropsType & {
    useSimulatedScrollbar: any;
    showScrollbar: string;
    refreshStrategy: import("../common/types").RefreshStrategy;
} & RestProps & {
    ref?: React.Ref<ScrollableNativeRef>;
}> & {
    defaultProps: typeof ScrollableNativeProps;
};
export { ScrollableNative };
export default ScrollableNative;
