import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["addWidgetClass", "aria", "bounceEnabled", "children", "classes", "direction", "disabled", "forceGeneratePockets", "height", "loadPanelComponent", "loadPanelRender", "loadPanelTemplate", "needRenderScrollbars", "needScrollViewContentWrapper", "onPullDown", "onReachBottom", "onScroll", "onUpdated", "pullDownEnabled", "pulledDownText", "pullingDownText", "reachBottomEnabled", "reachBottomText", "refreshStrategy", "refreshingText", "rtlEnabled", "scrollByContent", "showScrollbar", "useSimulatedScrollbar", "visible", "width"];
import 'devextreme/events/gesture/emitter.gesture.scroll';
import { subscribeToScrollEvent, subscribeToScrollInitEvent, subscribeToDXScrollEndEvent, subscribeToDXScrollMoveEvent, subscribeToDXScrollStopEvent } from "../../../utils/subscribe_to_event";
import { Widget } from "../../common/widget";
import { combineClasses } from "../../../utils/combine_classes";
import { getScrollLeftMax } from "../utils/get_scroll_left_max";
import { getBoundaryProps } from "../utils/get_boundary_props";
import { normalizeOffsetLeft } from "../utils/normalize_offset_left";
import { getElementOverflowX, getElementOverflowY } from "../utils/get_element_style";
import devices from 'devextreme/core/devices';
import { isDefined } from 'devextreme/core/utils/type';
import { TopPocket } from "../internal/pocket/top";
import { BottomPocket } from "../internal/pocket/bottom";
import { isDxMouseWheelEvent } from 'devextreme/events/utils';
import { ScrollDirection } from "../utils/scroll_direction";
import { DIRECTION_HORIZONTAL, DIRECTION_BOTH, SCROLLABLE_CONTAINER_CLASS, SCROLLABLE_CONTENT_CLASS, SCROLLABLE_WRAPPER_CLASS, SCROLLVIEW_CONTENT_CLASS, SCROLLABLE_DISABLED_CLASS, SCROLLABLE_SCROLLBAR_SIMULATED, SCROLLABLE_SCROLLBARS_HIDDEN, TopPocketState } from "../common/consts";
import { Scrollbar } from "../scrollbar/scrollbar";
import { isElementVisible } from "../utils/is_element_visible";
import { ScrollableNativeProps } from "../common/native_strategy_props";
import { allowedDirection } from "../utils/get_allowed_direction";
import { getScrollTopMax } from "../utils/get_scroll_top_max";
import { subscribeToResize } from "../utils/subscribe_to_resize";
export var viewFunction = viewModel => {
  var {
    bottomPocketRef,
    containerClientHeight,
    containerClientWidth,
    containerRef,
    contentHeight,
    contentRef,
    contentStyles,
    contentTranslateTop,
    contentWidth,
    cssClasses,
    direction,
    hScrollLocation,
    hScrollOffsetMax,
    hScrollbarRef,
    isLoadPanelVisible,
    props: {
      aria,
      children,
      disabled,
      forceGeneratePockets,
      height,
      loadPanelTemplate: LoadPanelTemplate,
      needRenderScrollbars,
      needScrollViewContentWrapper,
      pullDownEnabled,
      pulledDownText,
      pullingDownText,
      reachBottomEnabled,
      reachBottomText,
      refreshStrategy,
      refreshingText,
      rtlEnabled,
      showScrollbar,
      useSimulatedScrollbar,
      visible,
      width
    },
    pullDownIconAngle,
    pullDownOpacity,
    pullDownTranslateTop,
    restAttributes,
    scrollViewContentRef,
    scrollableRef,
    scrolling,
    topPocketHeight,
    topPocketRef,
    topPocketState,
    vScrollLocation,
    vScrollOffsetMax,
    vScrollbarRef,
    wrapperRef
  } = viewModel;
  return React.createElement(Widget, _extends({
    rootElementRef: scrollableRef,
    aria: aria,
    addWidgetClass: false,
    classes: cssClasses,
    disabled: disabled,
    rtlEnabled: rtlEnabled,
    height: height,
    width: width,
    visible: visible
  }, restAttributes), React.createElement("div", {
    className: SCROLLABLE_WRAPPER_CLASS,
    ref: wrapperRef
  }, React.createElement("div", {
    className: SCROLLABLE_CONTAINER_CLASS,
    ref: containerRef
  }, React.createElement("div", {
    className: SCROLLABLE_CONTENT_CLASS,
    ref: contentRef
  }, forceGeneratePockets && React.createElement(TopPocket, {
    topPocketRef: topPocketRef,
    pullingDownText: pullingDownText,
    pulledDownText: pulledDownText,
    refreshingText: refreshingText,
    pocketState: topPocketState,
    refreshStrategy: refreshStrategy,
    pullDownTranslateTop: pullDownTranslateTop,
    pullDownIconAngle: pullDownIconAngle,
    topPocketTranslateTop: contentTranslateTop,
    pullDownOpacity: pullDownOpacity,
    pocketTop: topPocketHeight,
    visible: !!pullDownEnabled
  }), needScrollViewContentWrapper ? React.createElement("div", {
    className: SCROLLVIEW_CONTENT_CLASS,
    ref: scrollViewContentRef,
    style: normalizeStyles(contentStyles)
  }, children) : children, forceGeneratePockets && React.createElement(BottomPocket, {
    bottomPocketRef: bottomPocketRef,
    reachBottomText: reachBottomText,
    visible: !!reachBottomEnabled
  })))), viewModel.props.loadPanelTemplate && LoadPanelTemplate({
    targetElement: scrollableRef,
    refreshingText: refreshingText,
    visible: isLoadPanelVisible
  }), needRenderScrollbars && showScrollbar !== "never" && useSimulatedScrollbar && direction.isHorizontal && React.createElement(Scrollbar, {
    direction: "horizontal",
    showScrollbar: "onScroll",
    ref: hScrollbarRef,
    contentSize: contentWidth,
    containerSize: containerClientWidth,
    maxOffset: hScrollOffsetMax,
    scrollLocation: hScrollLocation,
    visible: scrolling
  }), needRenderScrollbars && showScrollbar !== "never" && useSimulatedScrollbar && direction.isVertical && React.createElement(Scrollbar, {
    direction: "vertical",
    showScrollbar: "onScroll",
    ref: vScrollbarRef,
    contentSize: contentHeight,
    containerSize: containerClientHeight,
    maxOffset: vScrollOffsetMax,
    scrollLocation: vScrollLocation,
    visible: scrolling
  }));
};
import * as React from "react";
import { useState, useCallback, useMemo, useEffect, useRef, useImperativeHandle, forwardRef } from "react";
import { getTemplate } from "@devextreme/runtime/react";
var NUMBER_STYLES = new Set(["animationIterationCount", "borderImageOutset", "borderImageSlice", "border-imageWidth", "boxFlex", "boxFlexGroup", "boxOrdinalGroup", "columnCount", "fillOpacity", "flex", "flexGrow", "flexNegative", "flexOrder", "flexPositive", "flexShrink", "floodOpacity", "fontWeight", "gridColumn", "gridRow", "lineClamp", "lineHeight", "opacity", "order", "orphans", "stopOpacity", "strokeDasharray", "strokeDashoffset", "strokeMiterlimit", "strokeOpacity", "strokeWidth", "tabSize", "widows", "zIndex", "zoom"]);

var isNumeric = value => {
  if (typeof value === "number") return true;
  return !isNaN(Number(value));
};

var getNumberStyleValue = (style, value) => {
  return NUMBER_STYLES.has(style) ? value : "".concat(value, "px");
};

var normalizeStyles = styles => {
  if (!(styles instanceof Object)) return undefined;
  return Object.entries(styles).reduce((result, _ref) => {
    var [key, value] = _ref;
    result[key] = isNumeric(value) ? getNumberStyleValue(key, value) : value;
    return result;
  }, {});
};

var ScrollableNative = forwardRef(function scrollableNative(props, ref) {
  var __wrapperRef = useRef(null);

  var __contentRef = useRef(null);

  var __scrollViewContentRef = useRef(null);

  var __containerRef = useRef(null);

  var __scrollableRef = useRef(null);

  var __topPocketRef = useRef(null);

  var __bottomPocketRef = useRef(null);

  var __vScrollbarRef = useRef(null);

  var __hScrollbarRef = useRef(null);

  var [__state_containerClientWidth, __state_setContainerClientWidth] = useState(0);
  var [__state_containerClientHeight, __state_setContainerClientHeight] = useState(0);
  var [__state_contentClientWidth, __state_setContentClientWidth] = useState(0);
  var [__state_contentClientHeight, __state_setContentClientHeight] = useState(0);
  var [__state_contentScrollWidth, __state_setContentScrollWidth] = useState(0);
  var [__state_contentScrollHeight, __state_setContentScrollHeight] = useState(0);
  var [__state_topPocketHeight, __state_setTopPocketHeight] = useState(0);
  var [__state_bottomPocketHeight, __state_setBottomPocketHeight] = useState(0);
  var [__state_scrolling, __state_setScrolling] = useState(false);
  var [__state_topPocketState, __state_setTopPocketState] = useState(TopPocketState.STATE_RELEASED);
  var [__state_isLoadPanelVisible, __state_setIsLoadPanelVisible] = useState(false);
  var [__state_pullDownTranslateTop, __state_setPullDownTranslateTop] = useState(0);
  var [__state_pullDownIconAngle, __state_setPullDownIconAngle] = useState(0);
  var [__state_pullDownOpacity, __state_setPullDownOpacity] = useState(0);
  var [__state_contentTranslateTop, __state_setContentTranslateTop] = useState(0);
  var [__state_vScrollLocation, __state_setVScrollLocation] = useState(0);
  var [__state_hScrollLocation, __state_setHScrollLocation] = useState(0);
  var locked = useRef(false);
  var loadingIndicatorEnabled = useRef(true);
  var hideScrollbarTimer = useRef();
  var releaseTimer = useRef();
  var refreshTimer = useRef();
  var eventForUserAction = useRef();
  var initPageY = useRef(0);
  var deltaY = useRef(0);
  var locationTop = useRef(0);

  var __clearReleaseTimer = useCallback(function __clearReleaseTimer() {
    clearTimeout(releaseTimer.current);
    releaseTimer.current = undefined;
  }, [releaseTimer]);

  var __setPocketState = useCallback(function __setPocketState(newState) {
    __state_setTopPocketState(__state_topPocketState => newState);
  }, []);

  var __onReachBottom = useCallback(function __onReachBottom() {
    var _props$onReachBottom;

    (_props$onReachBottom = props.onReachBottom) === null || _props$onReachBottom === void 0 ? void 0 : _props$onReachBottom.call(props, {});
  }, [props.onReachBottom]);

  var __onPullDown = useCallback(function __onPullDown() {
    var _props$onPullDown;

    (_props$onPullDown = props.onPullDown) === null || _props$onPullDown === void 0 ? void 0 : _props$onPullDown.call(props, {});
  }, [props.onPullDown]);

  var __lock = useCallback(function __lock() {
    locked.current = true;
  }, []);

  var __unlock = useCallback(function __unlock() {
    if (!props.disabled) {
      locked.current = false;
    }
  }, [props.disabled]);

  var __fullScrollInactiveProp = useCallback(function __fullScrollInactiveProp() {
    return props.direction === DIRECTION_HORIZONTAL ? "scrollTop" : "scrollLeft";
  }, [props.direction]);

  var __setContainerDimensions = useCallback(function __setContainerDimensions(containerEl) {
    __state_setContainerClientWidth(__state_containerClientWidth => containerEl.clientWidth);

    __state_setContainerClientHeight(__state_containerClientHeight => containerEl.clientHeight);
  }, []);

  var __setContentDimensions = useCallback(function __setContentDimensions(contentEl) {
    __state_setContentClientWidth(__state_contentClientWidth => contentEl.clientWidth);

    __state_setContentClientHeight(__state_contentClientHeight => contentEl.clientHeight);

    __state_setContentScrollWidth(__state_contentScrollWidth => contentEl.scrollWidth);

    __state_setContentScrollHeight(__state_contentScrollHeight => contentEl.scrollHeight);

    if (props.forceGeneratePockets) {
      __state_setTopPocketHeight(__state_topPocketHeight => (__topPocketRef === null || __topPocketRef === void 0 ? void 0 : __topPocketRef.current.clientHeight) || 0);

      __state_setBottomPocketHeight(__state_bottomPocketHeight => (__bottomPocketRef === null || __bottomPocketRef === void 0 ? void 0 : __bottomPocketRef.current.clientHeight) || 0);
    }
  }, [props.forceGeneratePockets]);

  var __syncScrollbarsWithContent = useCallback(function __syncScrollbarsWithContent() {
    var {
      left,
      top
    } = __scrollOffset();

    __state_setHScrollLocation(__state_hScrollLocation => -left);

    __state_setVScrollLocation(__state_vScrollLocation => -top);
  }, []);

  var __clearRefreshTimer = useCallback(function __clearRefreshTimer() {
    clearTimeout(refreshTimer.current);
    refreshTimer.current = undefined;
  }, [refreshTimer]);

  var __getPullDownHeight = useCallback(function __getPullDownHeight() {
    return Math.round(__scrollableRef.current.offsetHeight * 0.05);
  }, []);

  var __getPullDownStartPosition = useCallback(function __getPullDownStartPosition() {
    return -Math.round(__state_topPocketHeight * 1.5);
  }, [__state_topPocketHeight]);

  var __isSwipeDownStrategy = useCallback(function __isSwipeDownStrategy() {
    return props.refreshStrategy === "swipeDown";
  }, [props.refreshStrategy]);

  var __isPullDownStrategy = useCallback(function __isPullDownStrategy() {
    return props.refreshStrategy === "pullDown";
  }, [props.refreshStrategy]);

  var __tryGetAllowedDirection = useCallback(function __tryGetAllowedDirection() {
    var containerEl = __containerRef.current;
    return allowedDirection(props.direction, getScrollTopMax(containerEl), getScrollLeftMax(containerEl), false);
  }, [props.direction]);

  var __isLocked = useCallback(function __isLocked() {
    return locked.current;
  }, [locked]);

  var __isScrollingOutOfBound = useCallback(function __isScrollingOutOfBound(event) {
    var {
      delta,
      shiftKey
    } = event;
    var {
      clientHeight,
      clientWidth,
      scrollHeight,
      scrollLeft,
      scrollTop,
      scrollWidth
    } = __containerRef.current;

    if (delta > 0) {
      return shiftKey ? !scrollLeft : !scrollTop;
    }

    return shiftKey ? clientWidth >= scrollWidth - scrollLeft : clientHeight >= scrollHeight - scrollTop;
  }, []);

  var __cssClasses = useCallback(function __cssClasses() {
    var {
      classes,
      direction,
      disabled,
      showScrollbar
    } = props;
    var classesMap = {
      ["dx-scrollable dx-scrollable-native dx-scrollable-native-".concat(devices.real().platform)]: true,
      ["dx-scrollable-".concat(direction)]: true,
      [SCROLLABLE_DISABLED_CLASS]: !!disabled,
      [SCROLLABLE_SCROLLBAR_SIMULATED]: showScrollbar !== "never" && props.useSimulatedScrollbar,
      [SCROLLABLE_SCROLLBARS_HIDDEN]: showScrollbar === "never",
      [String(classes)]: !!classes
    };
    return combineClasses(classesMap);
  }, [props.classes, props.direction, props.disabled, props.showScrollbar, props.useSimulatedScrollbar]);

  var __direction = useMemo(function __direction() {
    return new ScrollDirection(props.direction);
  }, [props.direction]);

  var __pullDownEnabled = useCallback(function __pullDownEnabled() {
    return props.pullDownEnabled && devices.real().platform !== "generic";
  }, [props.pullDownEnabled]);

  var __contentHeight = useCallback(function __contentHeight() {
    return getElementOverflowY(__contentRef === null || __contentRef === void 0 ? void 0 : __contentRef.current) === "hidden" ? __state_contentClientHeight : Math.max(__state_contentScrollHeight, __state_contentClientHeight);
  }, [__state_contentClientHeight, __state_contentScrollHeight]);

  var __contentWidth = useCallback(function __contentWidth() {
    return getElementOverflowX(__contentRef === null || __contentRef === void 0 ? void 0 : __contentRef.current) === "hidden" ? __state_contentClientWidth : Math.max(__state_contentScrollWidth, __state_contentClientWidth);
  }, [__state_contentClientWidth, __state_contentScrollWidth]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __content = useCallback(function __content() {
    if (props.needScrollViewContentWrapper) {
      return __scrollViewContentRef.current;
    }

    return __contentRef.current;
  }, [props.needScrollViewContentWrapper]);

  var __container = useCallback(function __container() {
    return __containerRef.current;
  }, []);

  var __scrollTop = useCallback(function __scrollTop() {
    return __containerRef.current.scrollTop;
  }, []);

  var __scrollLeft = useCallback(function __scrollLeft() {
    var containerEl = __containerRef.current;
    var scrollLeftMax = getScrollLeftMax(containerEl);
    return normalizeOffsetLeft(containerEl.scrollLeft, scrollLeftMax, !!props.rtlEnabled);
  }, [props.rtlEnabled]);

  var __clientHeight = useCallback(function __clientHeight() {
    return __containerRef.current.clientHeight;
  }, []);

  var __clientWidth = useCallback(function __clientWidth() {
    return __containerRef.current.clientWidth;
  }, []);

  var __startLoading = useCallback(function __startLoading() {
    if (loadingIndicatorEnabled.current && isElementVisible(__scrollableRef.current)) {
      __state_setIsLoadPanelVisible(__state_isLoadPanelVisible => true);
    }

    __lock();
  }, [loadingIndicatorEnabled, __lock]);

  var __finishLoading = useCallback(function __finishLoading() {
    __state_setIsLoadPanelVisible(__state_isLoadPanelVisible => false);

    __unlock();
  }, [__unlock]);

  var __pullDownReady = useCallback(function __pullDownReady() {
    if (__state_topPocketState === TopPocketState.STATE_READY) {
      return;
    }

    __setPocketState(TopPocketState.STATE_READY);
  }, [__state_topPocketState, __setPocketState]);

  var __updateElementDimensions = useCallback(function __updateElementDimensions() {
    __setContentDimensions(__content());

    __setContainerDimensions(__containerRef.current);
  }, [__setContentDimensions, __content, __setContainerDimensions]);

  var __handleInit = useCallback(function __handleInit(event) {
    if (props.forceGeneratePockets && __isSwipeDownStrategy()) {
      var {
        scrollTop
      } = __containerRef.current;

      if (__state_topPocketState === TopPocketState.STATE_RELEASED && scrollTop === 0) {
        initPageY.current = event.originalEvent.pageY;

        __setPocketState(TopPocketState.STATE_TOUCHED);
      }
    }
  }, [props.forceGeneratePockets, __isSwipeDownStrategy, __state_topPocketState, __setPocketState]);

  var __pullDownRefreshing = useCallback(function __pullDownRefreshing() {
    if (__state_topPocketState === TopPocketState.STATE_REFRESHING) {
      return;
    }

    __setPocketState(TopPocketState.STATE_REFRESHING);

    if (__isSwipeDownStrategy()) {
      __state_setPullDownTranslateTop(__state_pullDownTranslateTop => __getPullDownHeight());
    }

    __onPullDown();
  }, [__state_topPocketState, __setPocketState, __isSwipeDownStrategy, __getPullDownHeight, __onPullDown]);

  var __movePullDown = useCallback(function __movePullDown() {
    var pullDownHeight = __getPullDownHeight();

    var top = Math.min(pullDownHeight * 3, deltaY.current + __getPullDownStartPosition());
    var angle = 180 * top / pullDownHeight / 3;

    __state_setPullDownOpacity(__state_pullDownOpacity => 1);

    __state_setPullDownTranslateTop(__state_pullDownTranslateTop => top);

    __state_setPullDownIconAngle(__state_pullDownIconAngle => angle);
  }, [__getPullDownHeight, deltaY, __getPullDownStartPosition]);

  var __releaseState = useCallback(function __releaseState() {
    __setPocketState(TopPocketState.STATE_RELEASED);

    __state_setPullDownOpacity(__state_pullDownOpacity => 0);
  }, [__setPocketState]);

  var __isSwipeDown = useCallback(function __isSwipeDown() {
    return __pullDownEnabled() && __state_topPocketState === TopPocketState.STATE_PULLED && deltaY.current >= __getPullDownHeight() - __getPullDownStartPosition();
  }, [__pullDownEnabled, __state_topPocketState, deltaY, __getPullDownHeight, __getPullDownStartPosition]);

  var __pulledDown = useCallback(function __pulledDown() {
    var {
      scrollTop
    } = __containerRef.current;
    return __pullDownEnabled() && scrollTop <= -__state_topPocketHeight;
  }, [__pullDownEnabled, __state_topPocketHeight]);

  var __contentStyles = useMemo(function __contentStyles() {
    if (props.forceGeneratePockets && __isPullDownStrategy()) {
      return {
        transform: "translate(0px, ".concat(__state_contentTranslateTop, "px)")
      };
    }

    return undefined;
  }, [props.forceGeneratePockets, __isPullDownStrategy, __state_contentTranslateTop]);

  var __hScrollOffsetMax = useCallback(function __hScrollOffsetMax() {
    return -Math.max(__contentWidth() - __state_containerClientWidth, 0);
  }, [__contentWidth, __state_containerClientWidth]);

  var __vScrollOffsetMax = useCallback(function __vScrollOffsetMax() {
    return -Math.max(__contentHeight() - __state_containerClientHeight, 0);
  }, [__contentHeight, __state_containerClientHeight]);

  var __scrollHeight = useCallback(function __scrollHeight() {
    return __content().offsetHeight;
  }, [__content]);

  var __scrollWidth = useCallback(function __scrollWidth() {
    return __content().offsetWidth;
  }, [__content]);

  var __scrollOffset = useCallback(function __scrollOffset() {
    return {
      top: __scrollTop(),
      left: __scrollLeft()
    };
  }, [__scrollTop, __scrollLeft]);

  var __moveIsAllowed = useCallback(function __moveIsAllowed(event) {
    if (props.disabled || isDxMouseWheelEvent(event) && __isScrollingOutOfBound(event)) {
      return false;
    }

    return isDefined(__tryGetAllowedDirection());
  }, [props.disabled, __isScrollingOutOfBound, __tryGetAllowedDirection]);

  var __scrollByLocation = useCallback(function __scrollByLocation(location) {
    var containerEl = __containerRef.current;

    if (__direction.isVertical) {
      containerEl.scrollTop += location.top;
    }

    if (__direction.isHorizontal) {
      containerEl.scrollLeft += location.left;
    }
  }, [__direction]);

  var __stateReleased = useCallback(function __stateReleased() {
    if (__state_topPocketState === TopPocketState.STATE_RELEASED) {
      return;
    }

    __releaseState();
  }, [__state_topPocketState, __releaseState]);

  var __getEventArgs = useCallback(function __getEventArgs() {
    var scrollOffset = __scrollOffset();

    return _extends({
      event: eventForUserAction.current,
      scrollOffset
    }, getBoundaryProps(props.direction, scrollOffset, __containerRef.current));
  }, [__scrollOffset, eventForUserAction, props.direction]);

  var __pullDownComplete = useCallback(function __pullDownComplete() {
    if (__state_topPocketState === TopPocketState.STATE_READY) {
      __state_setContentTranslateTop(__state_contentTranslateTop => __state_topPocketHeight);

      __clearRefreshTimer();

      refreshTimer.current = setTimeout(() => {
        __pullDownRefreshing();
      }, 400);
    }
  }, [__state_topPocketState, __state_topPocketHeight, __clearRefreshTimer, __pullDownRefreshing]);

  var __complete = useCallback(function __complete() {
    if (__state_topPocketState === TopPocketState.STATE_TOUCHED || __state_topPocketState === TopPocketState.STATE_PULLED) {
      __releaseState();
    }
  }, [__state_topPocketState, __releaseState]);

  var __isReachBottom = useCallback(function __isReachBottom() {
    var {
      scrollTop
    } = __containerRef.current;
    return props.reachBottomEnabled && Math.round(-scrollTop - __vScrollOffsetMax()) <= 1;
  }, [props.reachBottomEnabled, __vScrollOffsetMax]);

  var __refresh = useCallback(function __refresh() {
    __setPocketState(TopPocketState.STATE_READY);

    __startLoading();

    __onPullDown();
  }, [__setPocketState, __startLoading, __onPullDown]);

  var __onUpdated = useCallback(function __onUpdated() {
    var _props$onUpdated;

    (_props$onUpdated = props.onUpdated) === null || _props$onUpdated === void 0 ? void 0 : _props$onUpdated.call(props, __getEventArgs());
  }, [props.onUpdated, __getEventArgs]);

  var __handlePocketState = useCallback(function __handlePocketState() {
    if (props.forceGeneratePockets) {
      if (__state_topPocketState === TopPocketState.STATE_REFRESHING) {
        return;
      }

      var {
        scrollTop
      } = __containerRef.current;
      var scrollDelta = locationTop.current + scrollTop;
      locationTop.current = -scrollTop;

      if (__isSwipeDownStrategy() && scrollDelta > 0 && __isReachBottom()) {
        __onReachBottom();

        return;
      }

      if (__isPullDownStrategy()) {
        if (__pulledDown()) {
          __pullDownReady();

          return;
        }

        if (scrollDelta > 0 && __isReachBottom()) {
          if (__state_topPocketState !== TopPocketState.STATE_LOADING) {
            __setPocketState(TopPocketState.STATE_LOADING);

            __onReachBottom();
          }

          return;
        }
      }

      __stateReleased();
    }
  }, [props.forceGeneratePockets, __state_topPocketState, locationTop, __isSwipeDownStrategy, __isReachBottom, __onReachBottom, __isPullDownStrategy, __pulledDown, __pullDownReady, __setPocketState, __stateReleased]);

  var __handleMove = useCallback(function __handleMove(e) {
    if (locked.current) {
      e.cancel = true;
      return;
    }

    if (isDefined(__tryGetAllowedDirection())) {
      e.originalEvent.isScrollingEvent = true;
    }

    if (props.forceGeneratePockets && __isSwipeDownStrategy()) {
      deltaY.current = e.originalEvent.pageY - initPageY.current;

      if (__state_topPocketState === TopPocketState.STATE_TOUCHED) {
        if (__pullDownEnabled() && deltaY.current > 0) {
          __setPocketState(TopPocketState.STATE_PULLED);
        } else {
          __complete();
        }
      }

      if (__state_topPocketState === TopPocketState.STATE_PULLED) {
        e.preventDefault();

        __movePullDown();
      }
    }
  }, [locked, __tryGetAllowedDirection, props.forceGeneratePockets, __isSwipeDownStrategy, initPageY, __state_topPocketState, __pullDownEnabled, deltaY, __setPocketState, __complete, __movePullDown]);

  var __handleEnd = useCallback(function __handleEnd() {
    if (props.forceGeneratePockets) {
      if (__isSwipeDownStrategy()) {
        if (__isSwipeDown()) {
          __pullDownRefreshing();
        }

        __complete();
      }

      if (__isPullDownStrategy()) {
        __pullDownComplete();
      }
    }
  }, [props.forceGeneratePockets, __isSwipeDownStrategy, __isSwipeDown, __pullDownRefreshing, __complete, __isPullDownStrategy, __pullDownComplete]);

  var __handleStop = useCallback(function __handleStop() {
    if (props.forceGeneratePockets) {
      if (__isSwipeDownStrategy()) {
        __complete();
      }

      if (__isPullDownStrategy()) {
        __pullDownComplete();
      }
    }
  }, [props.forceGeneratePockets, __isSwipeDownStrategy, __complete, __isPullDownStrategy, __pullDownComplete]);

  var __handleScroll = useCallback(function __handleScroll(event) {
    var _props$onScroll;

    eventForUserAction.current = event;

    if (props.useSimulatedScrollbar) {
      __state_setScrolling(__state_scrolling => true);

      __syncScrollbarsWithContent();

      __state_setScrolling(__state_scrolling => false);
    }

    (_props$onScroll = props.onScroll) === null || _props$onScroll === void 0 ? void 0 : _props$onScroll.call(props, __getEventArgs());

    __handlePocketState();
  }, [props.useSimulatedScrollbar, __syncScrollbarsWithContent, props.onScroll, __getEventArgs, __handlePocketState]);

  var __updateHandler = useCallback(function __updateHandler() {
    __updateElementDimensions();

    __onUpdated();
  }, [__updateElementDimensions, __onUpdated]);

  var __onRelease = useCallback(function __onRelease() {
    loadingIndicatorEnabled.current = true;

    __finishLoading();

    __updateHandler();
  }, [__finishLoading, __updateHandler]);

  var __validate = useCallback(function __validate(event) {
    if (__isLocked()) {
      return false;
    }

    __updateHandler();

    return __moveIsAllowed(event);
  }, [__isLocked, __updateHandler, __moveIsAllowed]);

  var __getInitEventData = useCallback(function __getInitEventData() {
    return {
      getDirection: () => __tryGetAllowedDirection(),
      validate: event => __validate(event),
      isNative: true,
      scrollTarget: __containerRef.current
    };
  }, [__tryGetAllowedDirection, __validate]);

  var __release = useCallback(function __release() {
    __clearReleaseTimer();

    if (__isPullDownStrategy()) {
      if (__state_topPocketState === TopPocketState.STATE_LOADING) {
        __setPocketState(TopPocketState.STATE_RELEASED);
      }
    }

    releaseTimer.current = setTimeout(() => {
      if (__isPullDownStrategy()) {
        __state_setContentTranslateTop(__state_contentTranslateTop => 0);
      }

      __stateReleased();

      __onRelease();
    }, __isSwipeDownStrategy() ? 800 : 400);
  }, [__clearReleaseTimer, __isPullDownStrategy, __state_topPocketState, __setPocketState, __stateReleased, __onRelease, __isSwipeDownStrategy]);

  useEffect(() => {
    return () => __clearReleaseTimer();
  }, []);
  useEffect(() => {
    return subscribeToScrollEvent(__containerRef.current, event => {
      __handleScroll(event);
    });
  }, [__handleScroll]);
  useEffect(() => {
    if (props.disabled) {
      __lock();
    } else {
      __unlock();
    }
  }, [props.disabled, __lock, __unlock]);
  useEffect(() => {
    if (props.direction === DIRECTION_BOTH) {
      return;
    }

    __containerRef.current[__fullScrollInactiveProp()] = 0;
  }, [props.direction]);
  useEffect(() => {
    return subscribeToScrollInitEvent(__wrapperRef.current, event => {
      __handleInit(event);
    }, __getInitEventData());
  }, [__handleInit, __getInitEventData]);
  useEffect(() => {
    return subscribeToDXScrollMoveEvent(__wrapperRef.current, event => {
      __handleMove(event);
    });
  }, [__handleMove]);
  useEffect(() => {
    return subscribeToDXScrollEndEvent(__wrapperRef.current, () => {
      __handleEnd();
    });
  }, [__handleEnd]);
  useEffect(() => {
    return subscribeToDXScrollStopEvent(__wrapperRef.current, () => {
      __handleStop();
    });
  }, [__handleStop]);
  useEffect(() => {
    return () => __clearRefreshTimer();
  }, []);
  useEffect(() => {
    __updateElementDimensions();
  }, []);
  useEffect(() => {
    return subscribeToResize(__containerRef.current, element => {
      __setContainerDimensions(element);
    });
  }, []);
  useEffect(() => {
    return subscribeToResize(__content(), element => {
      __setContentDimensions(element);
    });
  }, []);
  useImperativeHandle(ref, () => ({
    content: __content,
    container: __container,
    refresh: __refresh,
    release: __release,
    scrollHeight: __scrollHeight,
    scrollWidth: __scrollWidth,
    scrollOffset: __scrollOffset,
    scrollTop: __scrollTop,
    scrollLeft: __scrollLeft,
    clientHeight: __clientHeight,
    clientWidth: __clientWidth,
    validate: __validate,
    moveIsAllowed: __moveIsAllowed,
    updateHandler: __updateHandler,
    scrollByLocation: __scrollByLocation
  }), [__content, __container, __refresh, __release, __scrollHeight, __scrollWidth, __scrollOffset, __scrollTop, __scrollLeft, __clientHeight, __clientWidth, __validate, __moveIsAllowed, __updateHandler, __scrollByLocation]);
  return viewFunction({
    props: _extends({}, props, {
      loadPanelTemplate: getTemplate(props.loadPanelTemplate, props.loadPanelRender, props.loadPanelComponent)
    }),
    containerClientWidth: __state_containerClientWidth,
    containerClientHeight: __state_containerClientHeight,
    contentClientWidth: __state_contentClientWidth,
    contentClientHeight: __state_contentClientHeight,
    contentScrollWidth: __state_contentScrollWidth,
    contentScrollHeight: __state_contentScrollHeight,
    topPocketHeight: __state_topPocketHeight,
    bottomPocketHeight: __state_bottomPocketHeight,
    scrolling: __state_scrolling,
    topPocketState: __state_topPocketState,
    isLoadPanelVisible: __state_isLoadPanelVisible,
    pullDownTranslateTop: __state_pullDownTranslateTop,
    pullDownIconAngle: __state_pullDownIconAngle,
    pullDownOpacity: __state_pullDownOpacity,
    contentTranslateTop: __state_contentTranslateTop,
    vScrollLocation: __state_vScrollLocation,
    hScrollLocation: __state_hScrollLocation,
    wrapperRef: __wrapperRef,
    contentRef: __contentRef,
    scrollViewContentRef: __scrollViewContentRef,
    containerRef: __containerRef,
    scrollableRef: __scrollableRef,
    topPocketRef: __topPocketRef,
    bottomPocketRef: __bottomPocketRef,
    vScrollbarRef: __vScrollbarRef,
    hScrollbarRef: __hScrollbarRef,
    clearReleaseTimer: __clearReleaseTimer,
    onRelease: __onRelease,
    onUpdated: __onUpdated,
    startLoading: __startLoading,
    finishLoading: __finishLoading,
    setPocketState: __setPocketState,
    handleScroll: __handleScroll,
    handlePocketState: __handlePocketState,
    pullDownReady: __pullDownReady,
    onReachBottom: __onReachBottom,
    onPullDown: __onPullDown,
    stateReleased: __stateReleased,
    getEventArgs: __getEventArgs,
    lock: __lock,
    unlock: __unlock,
    fullScrollInactiveProp: __fullScrollInactiveProp(),
    updateElementDimensions: __updateElementDimensions,
    setContainerDimensions: __setContainerDimensions,
    setContentDimensions: __setContentDimensions,
    syncScrollbarsWithContent: __syncScrollbarsWithContent,
    getInitEventData: __getInitEventData,
    handleInit: __handleInit,
    handleMove: __handleMove,
    handleEnd: __handleEnd,
    handleStop: __handleStop,
    pullDownComplete: __pullDownComplete,
    clearRefreshTimer: __clearRefreshTimer,
    pullDownRefreshing: __pullDownRefreshing,
    movePullDown: __movePullDown,
    getPullDownHeight: __getPullDownHeight,
    getPullDownStartPosition: __getPullDownStartPosition,
    complete: __complete,
    releaseState: __releaseState,
    isSwipeDownStrategy: __isSwipeDownStrategy(),
    isPullDownStrategy: __isPullDownStrategy(),
    isSwipeDown: __isSwipeDown,
    pulledDown: __pulledDown,
    isReachBottom: __isReachBottom,
    tryGetAllowedDirection: __tryGetAllowedDirection,
    isLocked: __isLocked,
    isScrollingOutOfBound: __isScrollingOutOfBound,
    cssClasses: __cssClasses(),
    direction: __direction,
    pullDownEnabled: __pullDownEnabled(),
    contentStyles: __contentStyles,
    contentHeight: __contentHeight(),
    contentWidth: __contentWidth(),
    hScrollOffsetMax: __hScrollOffsetMax(),
    vScrollOffsetMax: __vScrollOffsetMax(),
    restAttributes: __restAttributes()
  });
});
export { ScrollableNative };
export default ScrollableNative;
ScrollableNative.defaultProps = ScrollableNativeProps;