import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["accessKey", "activeStateEnabled", "className", "disabled", "focusStateEnabled", "height", "hint", "hoverStateEnabled", "isReactComponentWrapper", "items", "onClick", "onKeyDown", "rtlEnabled", "tabIndex", "visible", "width"];
import LegacyToolbar from 'devextreme/ui/toolbar';
import { DomComponentWrapper } from "../common/dom_component_wrapper";
import { ToolbarProps } from "./toolbar_props";
import { isObject } from 'devextreme/core/utils/type';
import { ConfigContext } from "../../common/config_context";
import { resolveRtlEnabled } from "../../utils/resolve_rtl";
export var viewFunction = _ref => {
  var {
    componentProps,
    restAttributes
  } = _ref;
  return React.createElement(DomComponentWrapper, _extends({
    componentType: LegacyToolbar,
    componentProps: componentProps,
    templateNames: []
  }, restAttributes));
};
import * as React from "react";
import { useContext, useCallback, useMemo } from "react";
export function Toolbar(props) {
  var config = useContext(ConfigContext);

  var __resolvedRtlEnabled = useCallback(function __resolvedRtlEnabled() {
    var {
      rtlEnabled
    } = props;
    return !!resolveRtlEnabled(rtlEnabled, config);
  }, [props.rtlEnabled, config]);

  var __restAttributes = useCallback(function __restAttributes() {
    var restProps = _objectWithoutPropertiesLoose(props, _excluded);

    return restProps;
  }, [props]);

  var __componentProps = useMemo(function __componentProps() {
    var {
      items
    } = props;
    var toolbarItems = items === null || items === void 0 ? void 0 : items.map(item => {
      var _item$options, _options$rtlEnabled;

      if (!isObject(item)) {
        return item;
      }

      var options = (_item$options = item.options) !== null && _item$options !== void 0 ? _item$options : {};
      options.rtlEnabled = (_options$rtlEnabled = options.rtlEnabled) !== null && _options$rtlEnabled !== void 0 ? _options$rtlEnabled : __resolvedRtlEnabled();
      return _extends({}, item, {
        options
      });
    });
    return _extends({}, props, {
      items: toolbarItems
    });
  }, [__resolvedRtlEnabled, props]);

  return viewFunction({
    props: _extends({}, props),
    config,
    componentProps: __componentProps,
    resolvedRtlEnabled: __resolvedRtlEnabled(),
    restAttributes: __restAttributes()
  });
}
Toolbar.defaultProps = ToolbarProps;