import { getWindow } from 'devextreme/core/utils/window';
export var DiagnosticUtils = {
  resolveMap: () => {
    var diagnosticWindow = getWindow();

    if (!diagnosticWindow.dxDiagnostic) {
      diagnosticWindow.dxDiagnostic = {};
    }

    return diagnosticWindow.dxDiagnostic;
  },
  getDiagnostic: key => {
    var diagnosticMap = DiagnosticUtils.resolveMap();

    if (!diagnosticMap[key]) {
      diagnosticMap[key] = {
        renderCount: 0
      };
    }

    return diagnosticMap[key];
  },
  incrementRenderCount: key => {
    var diagnostic = DiagnosticUtils.getDiagnostic(key);
    diagnostic.renderCount += 1;
  }
};